export const PeriodicTable = [
    null,
    {
        'Atomic mass': 1.00794,
        'Atomic no': 1,
        'Atomic orbitals': { '1s': -0.233471 },
        'Atomic radius': 0.25,
        'Atomic radius calculated': 0.53,
        'Boiling point': '20.28 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-1, 1],
        'Critical temperature': '33 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '1s<sup>1</sup>',
        'ICSD oxidation states': [1, -1],
        'Liquid range': '6.27 K',
        'Melting point': '14.01 K',
        'Mendeleev no': 103,
        'Mineral hardness': 'no data',
        'Molar volume': '11.42 cm<sup>3</sup>',
        Name: 'Hydrogen',
        'Oxidation states': [-1, 1],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000132 (gas; liquid 1.12)(no units)',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '1': {
                I: { '': { crystal_radius: -0.24, ionic_radius: -0.38 } },
                II: { '': { crystal_radius: -0.04, ionic_radius: -0.18 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.1805 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.1,
        'Velocity of sound': '1270 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.2,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'H-2': 2.86 },
        'Metallic radius': 'no data',
        iupac_ordering: 92,
        'IUPAC ordering': 92,
        'Ground level': '2S1/2',
        'Ionization energies': [13.598434599702],
        'Electron affinity': 0.754598,
        symbol: 'H',
    },
    {
        'Atomic mass': 4.002602,
        'Atomic no': 2,
        'Atomic orbitals': { '1s': -0.570425 },
        'Atomic radius': 'no data',
        'Atomic radius calculated': 0.31,
        'Boiling point': '4.22 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Critical temperature': '5.19 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '1s<sup>2</sup>',
        'Liquid range': '3.27 K',
        'Max oxidation state': 0,
        'Melting point': '0.95 K',
        'Mendeleev no': 1,
        'Min oxidation state': 0,
        'Mineral hardness': 'no data',
        'Molar volume': '21.0 cm<sup>3</sup>',
        Name: 'Helium',
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000035 (gas; liquid 1.028)(no units)',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.1513 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.4,
        'Velocity of sound': '970 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 5,
        'IUPAC ordering': 5,
        'Ground level': '1S0',
        'Ionization energies': [24.587389011, 54.417765486],
        'Electron affinity': -0.52,
        symbol: 'He',
    },
    {
        'Atomic mass': 6.941,
        'Atomic no': 3,
        'Atomic orbitals': { '1s': -1.878564, '2s': -0.10554 },
        'Atomic radius': 1.45,
        'Atomic radius calculated': 1.67,
        'Boiling point': '1615 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '11 GPa',
        'Coefficient of linear thermal expansion': '46 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1],
        'Critical temperature': '3223 K',
        'Density of solid': '535 kg m<sup>-3</sup>',
        'Electrical resistivity': '9.5 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[He].2s<sup>1</sup>',
        'ICSD oxidation states': [1],
        'Ionic radii': { '1': 0.9 },
        'Liquid range': '1161.31 K',
        'Melting point': '453.69 K',
        'Mendeleev no': 12,
        'Mineral hardness': '0.6',
        'Molar volume': '13.02 cm<sup>3</sup>',
        Name: 'Lithium',
        'Oxidation states': [1],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '4.2 GPa',
        'Shannon radii': {
            '1': {
                IV: { '': { crystal_radius: 0.73, ionic_radius: 0.59 } },
                VI: { '': { crystal_radius: 0.9, ionic_radius: 0.76 } },
                VIII: { '': { crystal_radius: 1.06, ionic_radius: 0.92 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '85 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.82,
        'Velocity of sound': '6000 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.98,
        'Youngs modulus': '4.9 GPa',
        'NMR Quadrupole Moment': { 'Li-6': -0.808, 'Li-7': -40.1 },
        'Metallic radius': 1.52,
        iupac_ordering: 11,
        'IUPAC ordering': 11,
        'Ground level': '2S1/2',
        'Ionization energies': [5.391714996, 75.640097, 122.45435914],
        'Electron affinity': 0.61804922,
        symbol: 'Li',
    },
    {
        'Atomic mass': 9.012182,
        'Atomic no': 4,
        'Atomic orbitals': { '1s': -3.856411, '2s': -0.205744 },
        'Atomic radius': 1.05,
        'Atomic radius calculated': 1.12,
        'Boiling point': '2742 K',
        'Brinell hardness': '600 MN m<sup>-2</sup>',
        'Bulk modulus': '130 GPa',
        'Coefficient of linear thermal expansion': '11.3 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '1848 kg m<sup>-3</sup>',
        'Electrical resistivity': '3.8 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[He].2s<sup>2</sup>',
        'ICSD oxidation states': [2],
        'Ionic radii': { '2': 0.59 },
        'Liquid range': '1182 K',
        'Melting point': '1560 K',
        'Mendeleev no': 77,
        'Mineral hardness': '5.5',
        'Molar volume': '4.85 cm<sup>3</sup>',
        Name: 'Beryllium',
        'Oxidation states': [2],
        'Poissons ratio': '0.032',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '132 GPa',
        'Shannon radii': {
            '2': {
                III: { '': { crystal_radius: 0.3, ionic_radius: 0.16 } },
                IV: { '': { crystal_radius: 0.41, ionic_radius: 0.27 } },
                VI: { '': { crystal_radius: 0.59, ionic_radius: 0.45 } },
            },
        },
        'Superconduction temperature': '0.026 K',
        'Thermal conductivity': '190 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.53,
        'Velocity of sound': '13000 m s<sup>-1</sup>',
        'Vickers hardness': '1670 MN m<sup>-2</sup>',
        X: 1.57,
        'Youngs modulus': '287 GPa',
        'NMR Quadrupole Moment': { 'Be-9': 52.88 },
        'Metallic radius': 1.12,
        iupac_ordering: 17,
        'IUPAC ordering': 17,
        'Ground level': '1S0',
        'Ionization energies': [9.322699, 18.21115, 153.896205, 217.7185861],
        'Electron affinity': -0.52,
        symbol: 'Be',
    },
    {
        'Atomic mass': 10.811,
        'Atomic no': 5,
        'Atomic orbitals': { '1s': -6.564347, '2p': -0.136603, '2s': -0.344701 },
        'Atomic radius': 0.85,
        'Atomic radius calculated': 0.87,
        'Boiling point': '4200 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '320 GPa',
        'Coefficient of linear thermal expansion': '6 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '2460 kg m<sup>-3</sup>',
        'Electrical resistivity': '&gt; 10<sup>12</sup>10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[He].2s<sup>2</sup>.2p<sup>1</sup>',
        'ICSD oxidation states': [3, -3],
        'Ionic radii': { '3': 0.41 },
        'Liquid range': '1851 K',
        'Melting point': '2349 K',
        'Mendeleev no': 86,
        'Mineral hardness': '9.3',
        'Molar volume': '4.39 cm<sup>3</sup>',
        Name: 'Boron',
        'Oxidation states': [1, 2, 3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': {
                III: { '': { crystal_radius: 0.15, ionic_radius: 0.01 } },
                IV: { '': { crystal_radius: 0.25, ionic_radius: 0.11 } },
                VI: { '': { crystal_radius: 0.41, ionic_radius: 0.27 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '27 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.92,
        'Velocity of sound': '16200 m s<sup>-1</sup>',
        'Vickers hardness': '49000 MN m<sup>-2</sup>',
        X: 2.04,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'B-10': 84.59, 'B-11': 40.59 },
        'Metallic radius': 'no data',
        iupac_ordering: 81,
        'IUPAC ordering': 81,
        'Ground level': '2P°1/2',
        'Ionization energies': [8.298019, 25.15483, 37.93059, 259.3715, 340.2260229],
        'Electron affinity': 0.27972325,
        symbol: 'B',
    },
    {
        'Atomic mass': 12.0107,
        'Atomic no': 6,
        'Atomic orbitals': { '1s': -9.947718, '2p': -0.199186, '2s': -0.500866 },
        'Atomic radius': 0.7,
        'Atomic radius calculated': 0.67,
        'Boiling point': '4300 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '33 GPa',
        'Coefficient of linear thermal expansion': '7.1 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-4, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '2267 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 1000 - direction dependent10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[He].2s<sup>2</sup>.2p<sup>2</sup>',
        'ICSD oxidation states': [2, 3, 4, -4, -3, -2],
        'Ionic radii': { '4': 0.3 },
        'Liquid range': '500 K',
        'Melting point': '3800 K',
        'Mendeleev no': 95,
        'Mineral hardness': '0.5 (graphite; diamond is 10.0)(no units)',
        'Molar volume': '5.29 cm<sup>3</sup>',
        Name: 'Carbon',
        'Oxidation states': [-4, -3, -2, -1, 1, 2, 3, 4],
        'Poissons ratio': 'no data',
        Reflectivity: '27 %',
        'Refractive index': '2.417 (diamond)(no units)',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '4': {
                III: { '': { crystal_radius: 0.06, ionic_radius: -0.08 } },
                IV: { '': { crystal_radius: 0.29, ionic_radius: 0.15 } },
                VI: { '': { crystal_radius: 0.3, ionic_radius: 0.16 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '140 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.7,
        'Velocity of sound': '18350 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.55,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'C-11': 33.27 },
        'Metallic radius': 'no data',
        iupac_ordering: 86,
        'IUPAC ordering': 86,
        'Ground level': '3P0',
        'Ionization energies': [11.260288, 24.383154, 47.88778, 64.49352, 392.090518, 489.993198],
        'Electron affinity': 1.262113612,
        symbol: 'C',
    },
    {
        'Atomic mass': 14.0067,
        'Atomic no': 7,
        'Atomic orbitals': { '1s': -14.011501, '2p': -0.266297, '2s': -0.676151 },
        'Atomic radius': 0.65,
        'Atomic radius calculated': 0.56,
        'Boiling point': '77.36 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-3, 3, 5],
        'Critical temperature': '126.2 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[He].2s<sup>2</sup>.2p<sup>3</sup>',
        'ICSD oxidation states': [1, 3, 5, -1, -3, -2],
        'Ionic radii': { '3': 0.3, '5': 0.27, '-3': 1.32 },
        'Liquid range': '14.31 K',
        'Melting point': '63.05 K',
        'Mendeleev no': 100,
        'Mineral hardness': 'no data',
        'Molar volume': '13.54 cm<sup>3</sup>',
        Name: 'Nitrogen',
        'Oxidation states': [-3, -2, -1, 1, 2, 3, 4, 5],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000298 (gas; liquid 1.197)(no units)',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.3, ionic_radius: 0.16 } } },
            '5': {
                III: { '': { crystal_radius: 0.044, ionic_radius: -0.104 } },
                VI: { '': { crystal_radius: 0.27, ionic_radius: 0.13 } },
            },
            '-3': { IV: { '': { crystal_radius: 1.32, ionic_radius: 1.46 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.02583 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.55,
        'Velocity of sound': '333.6 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 3.04,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'N-14': 20.44 },
        'Metallic radius': 'no data',
        iupac_ordering: 91,
        'IUPAC ordering': 91,
        'Ground level': '4S°3/2',
        'Ionization energies': [14.53413, 29.60125, 47.4453, 77.4735, 97.8901, 552.06733, 667.046121],
        'Electron affinity': -0.07,
        symbol: 'N',
    },
    {
        'Atomic mass': 15.9994,
        'Atomic no': 8,
        'Atomic orbitals': { '1s': -18.758245, '2p': -0.338381, '2s': -0.871362 },
        'Atomic radius': 0.6,
        'Atomic radius calculated': 0.48,
        'Boiling point': '90.2 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-2],
        'Critical temperature': '154.6 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[He].2s<sup>2</sup>.2p<sup>4</sup>',
        'ICSD oxidation states': [-2],
        'Ionic radii': { '-2': 1.26 },
        'Liquid range': '35.4 K',
        'Melting point': '54.8 K',
        'Mendeleev no': 101,
        'Mineral hardness': 'no data',
        'Molar volume': '17.36 cm<sup>3</sup>',
        Name: 'Oxygen',
        'Oxidation states': [-2, -1, 1, 2],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000271 (gas; liquid 1.221)(no units)',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '-2': {
                II: { '': { crystal_radius: 1.21, ionic_radius: 1.35 } },
                III: { '': { crystal_radius: 1.22, ionic_radius: 1.36 } },
                IV: { '': { crystal_radius: 1.24, ionic_radius: 1.38 } },
                VI: { '': { crystal_radius: 1.26, ionic_radius: 1.4 } },
                VIII: { '': { crystal_radius: 1.28, ionic_radius: 1.42 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.02658 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.52,
        'Velocity of sound': '317.5 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 3.44,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'O-17': -25.58 },
        'Metallic radius': 'no data',
        iupac_ordering: 97,
        'IUPAC ordering': 97,
        'Ground level': '3P2',
        'Ionization energies': [13.618055, 35.12112, 54.93554, 77.4135, 113.899, 138.1189, 739.32683, 871.409883],
        'Electron affinity': 1.4611053,
        symbol: 'O',
    },
    {
        'Atomic mass': 18.9984032,
        'Atomic no': 9,
        'Atomic orbitals': { '1s': -24.189391, '2p': -0.415606, '2s': -1.086859 },
        'Atomic radius': 0.5,
        'Atomic radius calculated': 0.42,
        'Boiling point': '85.03 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-1],
        'Critical temperature': '144 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[He].2s<sup>2</sup>.2p<sup>5</sup>',
        'ICSD oxidation states': [-1],
        'Ionic radii': { '7': 0.22, '-1': 1.19 },
        'Liquid range': '31.5 K',
        'Melting point': '53.53 K',
        'Mendeleev no': 102,
        'Mineral hardness': 'no data',
        'Molar volume': '11.20 cm<sup>3</sup>',
        Name: 'Fluorine',
        'Oxidation states': [-1],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000195',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '7': { VI: { '': { crystal_radius: 0.22, ionic_radius: 0.08 } } },
            '-1': {
                II: { '': { crystal_radius: 1.145, ionic_radius: 1.285 } },
                III: { '': { crystal_radius: 1.16, ionic_radius: 1.3 } },
                IV: { '': { crystal_radius: 1.17, ionic_radius: 1.31 } },
                VI: { '': { crystal_radius: 1.19, ionic_radius: 1.33 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.0277 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.47,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 3.98,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'F-19': -94.2 },
        'Metallic radius': 'no data',
        iupac_ordering: 102,
        'IUPAC ordering': 102,
        'Ground level': '2P°3/2',
        'Ionization energies': [
            17.42282, 34.97081, 62.70798, 87.175, 114.249, 157.16311, 185.1868, 953.89805, 1103.11748,
        ],
        'Electron affinity': 3.401189824,
        symbol: 'F',
    },
    {
        'Atomic mass': 20.1797,
        'Atomic no': 10,
        'Atomic orbitals': { '1s': -30.305855, '2p': -0.498034, '2s': -1.322809 },
        'Atomic radius': 'no data',
        'Atomic radius calculated': 0.38,
        'Boiling point': '27.07 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Critical temperature': '44.4 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[He].2s<sup>2</sup>.2p<sup>6</sup>',
        'Liquid range': '2.51 K',
        'Max oxidation state': 0,
        'Melting point': '24.56 K',
        'Mendeleev no': 2,
        'Min oxidation state': 0,
        'Mineral hardness': 'no data',
        'Molar volume': '13.23 cm<sup>3</sup>',
        Name: 'Neon',
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000067',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.0491 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.54,
        'Velocity of sound': '936 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'Ne-21': 101.55 },
        'Metallic radius': 'no data',
        iupac_ordering: 4,
        'IUPAC ordering': 4,
        'Ground level': '1S0',
        'Ionization energies': [
            21.564541, 40.96297, 63.4233, 97.19, 126.247, 157.934, 207.271, 239.097, 1195.80784, 1362.19916,
        ],
        'Electron affinity': -1.22,
        symbol: 'Ne',
    },
    {
        'Atomic mass': 22.98976928,
        'Atomic no': 11,
        'Atomic orbitals': { '1s': -37.719975, '2p': -1.060636, '2s': -2.063401, '3s': -0.103415 },
        'Atomic radius': 1.8,
        'Atomic radius calculated': 1.9,
        'Boiling point': '1156 K',
        'Brinell hardness': '0.69 MN m<sup>-2</sup>',
        'Bulk modulus': '6.3 GPa',
        'Coefficient of linear thermal expansion': '71 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1],
        'Critical temperature': '2573 K',
        'Density of solid': '968 kg m<sup>-3</sup>',
        'Electrical resistivity': '4.9 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ne].3s<sup>1</sup>',
        'ICSD oxidation states': [1],
        'Ionic radii': { '1': 1.16 },
        'Liquid range': '785.13 K',
        'Melting point': '370.87 K',
        'Mendeleev no': 11,
        'Mineral hardness': '0.5',
        'Molar volume': '23.78 cm<sup>3</sup>',
        Name: 'Sodium',
        'Oxidation states': [-1, 1],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '3.3 GPa',
        'Shannon radii': {
            '1': {
                IV: { '': { crystal_radius: 1.13, ionic_radius: 0.99 } },
                V: { '': { crystal_radius: 1.14, ionic_radius: 1 } },
                VI: { '': { crystal_radius: 1.16, ionic_radius: 1.02 } },
                VII: { '': { crystal_radius: 1.26, ionic_radius: 1.12 } },
                VIII: { '': { crystal_radius: 1.32, ionic_radius: 1.18 } },
                IX: { '': { crystal_radius: 1.38, ionic_radius: 1.24 } },
                XII: { '': { crystal_radius: 1.53, ionic_radius: 1.39 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '140 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.27,
        'Velocity of sound': '3200 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.93,
        'Youngs modulus': '10 GPa',
        'NMR Quadrupole Moment': { 'Na-23': 104.1 },
        'Metallic radius': 1.86,
        iupac_ordering: 10,
        'IUPAC ordering': 10,
        'Ground level': '2S1/2',
        'Ionization energies': [
            5.13907696, 47.28636, 71.62, 98.936, 138.404, 172.23, 208.504, 264.192, 299.856, 1465.134502, 1648.7022,
        ],
        'Electron affinity': 0.54792625,
        symbol: 'Na',
    },
    {
        'Atomic mass': 24.305,
        'Atomic no': 12,
        'Atomic orbitals': { '1s': -45.973167, '2p': -1.71897, '2s': -2.903746, '3s': -0.175427 },
        'Atomic radius': 1.5,
        'Atomic radius calculated': 1.45,
        'Boiling point': '1363 K',
        'Brinell hardness': '260 MN m<sup>-2</sup>',
        'Bulk modulus': '45 GPa',
        'Coefficient of linear thermal expansion': '8.2 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '1738 kg m<sup>-3</sup>',
        'Electrical resistivity': '4.4 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ne].3s<sup>2</sup>',
        'ICSD oxidation states': [2],
        'Ionic radii': { '2': 0.86 },
        'Liquid range': '440 K',
        'Melting point': '923 K',
        'Mendeleev no': 73,
        'Mineral hardness': '2.5',
        'Molar volume': '14.00 cm<sup>3</sup>',
        Name: 'Magnesium',
        'Oxidation states': [1, 2],
        'Poissons ratio': '0.29',
        Reflectivity: '74 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '17 GPa',
        'Shannon radii': {
            '2': {
                IV: { '': { crystal_radius: 0.71, ionic_radius: 0.57 } },
                V: { '': { crystal_radius: 0.8, ionic_radius: 0.66 } },
                VI: { '': { crystal_radius: 0.86, ionic_radius: 0.72 } },
                VIII: { '': { crystal_radius: 1.03, ionic_radius: 0.89 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '160 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.73,
        'Velocity of sound': '4602 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.31,
        'Youngs modulus': '45 GPa',
        'NMR Quadrupole Moment': { 'Mg-25': 199.4 },
        'Metallic radius': 1.6,
        iupac_ordering: 16,
        'IUPAC ordering': 16,
        'Ground level': '1S0',
        'Ionization energies': [
            7.646236, 15.035271, 80.1436, 109.2654, 141.33, 186.76, 225.02, 265.924, 327.99, 367.489, 1761.80488,
            1962.66366,
        ],
        'Electron affinity': -0.42,
        symbol: 'Mg',
    },
    {
        'Atomic mass': 26.9815386,
        'Atomic no': 13,
        'Atomic orbitals': { '1s': -55.156044, '2p': -2.564018, '2s': -3.934827, '3p': -0.102545, '3s': -0.286883 },
        'Atomic radius': 1.25,
        'Atomic radius calculated': 1.18,
        'Boiling point': '2792 K',
        'Brinell hardness': '245 MN m<sup>-2</sup>',
        'Bulk modulus': '76 GPa',
        'Coefficient of linear thermal expansion': '23.1 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '2700 kg m<sup>-3</sup>',
        'Electrical resistivity': '2.7 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ne].3s<sup>2</sup>.3p<sup>1</sup>',
        'ICSD oxidation states': [3],
        'Ionic radii': { '3': 0.675 },
        'Liquid range': '1858.53 K',
        'Melting point': '933.47 K',
        'Mendeleev no': 80,
        'Mineral hardness': '2.75',
        'Molar volume': '10.00 cm<sup>3</sup>',
        Name: 'Aluminum',
        'Oxidation states': [1, 3],
        'Poissons ratio': '0.35',
        Reflectivity: '71 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '26 GPa',
        'Shannon radii': {
            '3': {
                IV: { '': { crystal_radius: 0.53, ionic_radius: 0.39 } },
                V: { '': { crystal_radius: 0.62, ionic_radius: 0.48 } },
                VI: { '': { crystal_radius: 0.675, ionic_radius: 0.535 } },
            },
        },
        'Superconduction temperature': '1.175 K',
        'Thermal conductivity': '235 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.84,
        'Velocity of sound': '5100 m s<sup>-1</sup>',
        'Vickers hardness': '167 MN m<sup>-2</sup>',
        X: 1.61,
        'Youngs modulus': '70 GPa',
        'NMR Quadrupole Moment': { 'Al-27': 146.6 },
        'Metallic radius': 1.43,
        iupac_ordering: 80,
        'IUPAC ordering': 80,
        'Ground level': '2P°1/2',
        'Ionization energies': [
            5.985769, 18.82855, 28.447642, 119.9924, 153.8252, 190.49, 241.76, 284.64, 330.21, 398.65, 442.005,
            2085.97702, 2304.14007,
        ],
        'Electron affinity': 0.432835,
        symbol: 'Al',
    },
    {
        'Atomic mass': 28.0855,
        'Atomic no': 14,
        'Atomic orbitals': { '1s': -65.184426, '2p': -3.514938, '2s': -5.075056, '3p': -0.153293, '3s': -0.398139 },
        'Atomic radius': 1.1,
        'Atomic radius calculated': 1.11,
        'Boiling point': '3173 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '100 GPa',
        'Coefficient of linear thermal expansion': '2.6 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-4, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '2330 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 100000 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ne].3s<sup>2</sup>.3p<sup>2</sup>',
        'ICSD oxidation states': [-4, 4],
        'Ionic radii': { '4': 0.54 },
        'Liquid range': '1486 K',
        'Melting point': '1687 K',
        'Mendeleev no': 85,
        'Mineral hardness': '6.5',
        'Molar volume': '12.06 cm<sup>3</sup>',
        Name: 'Silicon',
        'Oxidation states': [-4, -3, -2, -1, 1, 2, 3, 4],
        'Poissons ratio': 'no data',
        Reflectivity: '28 %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '4': {
                IV: { '': { crystal_radius: 0.4, ionic_radius: 0.26 } },
                VI: { '': { crystal_radius: 0.54, ionic_radius: 0.4 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '150 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.1,
        'Velocity of sound': '2200 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.9,
        'Youngs modulus': '47 GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 85,
        'IUPAC ordering': 85,
        'Ground level': '3P0',
        'Ionization energies': [
            8.15168, 16.34585, 33.493, 45.14179, 166.767, 205.279, 246.57, 303.59, 351.28, 401.38, 476.273, 523.415,
            2437.65815, 2673.17755,
        ],
        'Electron affinity': 1.38952128,
        symbol: 'Si',
    },
    {
        'Atomic mass': 30.973762,
        'Atomic no': 15,
        'Atomic orbitals': { '1s': -76.061897, '2p': -4.576617, '2s': -6.329346, '3p': -0.20608, '3s': -0.512364 },
        'Atomic radius': 1,
        'Atomic radius calculated': 0.98,
        'Boiling point': '550 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '11 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-3, 3, 5],
        'Critical temperature': '994 K',
        'Density of solid': '1823 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 10 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ne].3s<sup>2</sup>.3p<sup>3</sup>',
        'ICSD oxidation states': [3, 4, 5, -2, -3, -1],
        'Ionic radii': { '3': 0.58, '5': 0.52 },
        'Liquid range': '232.7 K',
        'Melting point': '(white P) 317.3 K',
        'Mendeleev no': 90,
        'Mineral hardness': 'no data',
        'Molar volume': '17.02 cm<sup>3</sup>',
        Name: 'Phosphorus',
        'Oxidation states': [-3, -2, -1, 1, 2, 3, 4, 5],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.001212',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.58, ionic_radius: 0.44 } } },
            '5': {
                IV: { '': { crystal_radius: 0.31, ionic_radius: 0.17 } },
                V: { '': { crystal_radius: 0.43, ionic_radius: 0.29 } },
                VI: { '': { crystal_radius: 0.52, ionic_radius: 0.38 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.236 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.8,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.19,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 90,
        'IUPAC ordering': 90,
        'Ground level': '4S°3/2',
        'Ionization energies': [
            10.486686, 19.76949, 30.20264, 51.44387, 65.02511, 220.43, 263.57, 309.6, 372.31, 424.4, 479.44, 560.62,
            611.741, 2816.90879, 3069.8416,
        ],
        'Electron affinity': 0.7466071,
        symbol: 'P',
    },
    {
        'Atomic mass': 32.065,
        'Atomic no': 16,
        'Atomic orbitals': { '1s': -87.789937, '2p': -5.751257, '2s': -7.69994, '3p': -0.261676, '3s': -0.630912 },
        'Atomic radius': 1,
        'Atomic radius calculated': 0.88,
        'Boiling point': '717.87 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '7.7 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-2, 2, 4, 6],
        'Critical temperature': '1314 K',
        'Density of solid': '1960 kg m<sup>-3</sup>',
        'Electrical resistivity': '&gt; 10<sup>23</sup>10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ne].3s<sup>2</sup>.3p<sup>4</sup>',
        'ICSD oxidation states': [-1, 2, 4, -2, 6],
        'Ionic radii': { '4': 0.51, '6': 0.43, '-2': 1.7 },
        'Liquid range': '329.51 K',
        'Melting point': '388.36 K',
        'Mendeleev no': 94,
        'Mineral hardness': '2.0',
        'Molar volume': '15.53 cm<sup>3</sup>',
        Name: 'Sulfur',
        'Oxidation states': [-2, -1, 1, 2, 3, 4, 5, 6],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.001111',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '4': { VI: { '': { crystal_radius: 0.51, ionic_radius: 0.37 } } },
            '6': {
                IV: { '': { crystal_radius: 0.26, ionic_radius: 0.12 } },
                VI: { '': { crystal_radius: 0.43, ionic_radius: 0.29 } },
            },
            '-2': { VI: { '': { crystal_radius: 1.7, ionic_radius: 1.84 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.205 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.8,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.58,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'S-33': -67.8, 'S-35': 47.1 },
        'Metallic radius': 'no data',
        iupac_ordering: 96,
        'IUPAC ordering': 96,
        'Ground level': '3P2',
        'Ionization energies': [
            10.36001, 23.33788, 34.86, 47.222, 72.5945, 88.0529, 280.954, 328.794, 379.84, 447.7, 504.55, 564.41,
            651.96, 706.994, 3223.7807, 3494.1879,
        ],
        'Electron affinity': 2.077104512,
        symbol: 'S',
    },
    {
        'Atomic mass': 35.453,
        'Atomic no': 17,
        'Atomic orbitals': { '1s': -100.369229, '2p': -7.039982, '2s': -9.187993, '3p': -0.32038, '3s': -0.754458 },
        'Atomic radius': 1,
        'Atomic radius calculated': 0.79,
        'Boiling point': '239.11 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '1.1 (liquid)GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-1, 1, 3, 5, 7],
        'Critical temperature': '417 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': '&gt; 10<sup>10</sup>10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ne].3s<sup>2</sup>.3p<sup>5</sup>',
        'ICSD oxidation states': [-1],
        'Ionic radii': { '5': 0.26, '7': 0.41, '-1': 1.67 },
        'Liquid range': '67.51 K',
        'Melting point': '171.6 K',
        'Mendeleev no': 99,
        'Mineral hardness': 'no data',
        'Molar volume': '17.39 cm<sup>3</sup>',
        Name: 'Chlorine',
        'Oxidation states': [-1, 1, 2, 3, 4, 5, 6, 7],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000773',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '5': { IIIPY: { '': { crystal_radius: 0.26, ionic_radius: 0.12 } } },
            '7': {
                IV: { '': { crystal_radius: 0.22, ionic_radius: 0.08 } },
                VI: { '': { crystal_radius: 0.41, ionic_radius: 0.27 } },
            },
            '-1': { VI: { '': { crystal_radius: 1.67, ionic_radius: 1.81 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.0089 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.75,
        'Velocity of sound': '206 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 3.16,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'Cl-35': -81.65, 'Cl-37': -64.35 },
        'Metallic radius': 'no data',
        iupac_ordering: 101,
        'IUPAC ordering': 101,
        'Ground level': '2P°3/2',
        'Ionization energies': [
            12.967633, 23.81364, 39.8, 53.24, 67.68, 96.94, 114.2013, 348.306, 400.851, 456.7, 530, 591.58, 656.3,
            750.23, 809.198, 3658.3438, 3946.2909,
        ],
        'Electron affinity': 3.61272528,
        symbol: 'Cl',
    },
    {
        'Atomic mass': 39.948,
        'Atomic no': 18,
        'Atomic orbitals': { '1s': -113.800134, '2p': -8.443439, '2s': -10.794172, '3p': -0.38233, '3s': -0.883384 },
        'Atomic radius': 0.71,
        'Atomic radius calculated': 0.71,
        'Boiling point': '87.3 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Critical temperature': '150.8 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ne].3s<sup>2</sup>.3p<sup>6</sup>',
        'Liquid range': '3.5 K',
        'Max oxidation state': 0,
        'Melting point': '83.8 K',
        'Mendeleev no': 3,
        'Min oxidation state': 0,
        'Mineral hardness': 'no data',
        'Molar volume': '22.56 cm<sup>3</sup>',
        Name: 'Argon',
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000281',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.01772 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.88,
        'Velocity of sound': '319 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 3,
        'IUPAC ordering': 3,
        'Ground level': '1S0',
        'Ionization energies': [
            15.7596119, 27.62967, 40.735, 59.58, 74.84, 91.29, 124.41, 143.4567, 422.6, 479.76, 540.4, 619, 685.5,
            755.13, 855.5, 918.375, 4120.6657, 4426.2229,
        ],
        'Electron affinity': -1.02,
        symbol: 'Ar',
    },
    {
        'Atomic mass': 39.0983,
        'Atomic no': 19,
        'Atomic orbitals': {
            '1s': -128.414957,
            '2p': -10.283851,
            '2s': -12.839001,
            '3p': -0.693776,
            '3s': -1.281897,
            '4s': -0.088815,
        },
        'Atomic radius': 2.2,
        'Atomic radius calculated': 2.43,
        'Boiling point': '1032 K',
        'Brinell hardness': '0.363 MN m<sup>-2</sup>',
        'Bulk modulus': '3.1 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1],
        'Critical temperature': '2223 K',
        'Density of solid': '856 kg m<sup>-3</sup>',
        'Electrical resistivity': '7.5 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].4s<sup>1</sup>',
        'ICSD oxidation states': [1],
        'Ionic radii': { '1': 1.52 },
        'Liquid range': '695.47 K',
        'Melting point': '336.53 K',
        'Mendeleev no': 10,
        'Mineral hardness': '0.4',
        'Molar volume': '45.94 cm<sup>3</sup>',
        Name: 'Potassium',
        'Oxidation states': [-1, 1],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '1.3 GPa',
        'Shannon radii': {
            '1': {
                IV: { '': { crystal_radius: 1.51, ionic_radius: 1.37 } },
                VI: { '': { crystal_radius: 1.52, ionic_radius: 1.38 } },
                VII: { '': { crystal_radius: 1.6, ionic_radius: 1.46 } },
                VIII: { '': { crystal_radius: 1.65, ionic_radius: 1.51 } },
                IX: { '': { crystal_radius: 1.69, ionic_radius: 1.55 } },
                X: { '': { crystal_radius: 1.73, ionic_radius: 1.59 } },
                XII: { '': { crystal_radius: 1.78, ionic_radius: 1.64 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '100 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.75,
        'Velocity of sound': '2000 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.82,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'K-39': 58.5, 'K-40': -73, 'K-41': 71.1 },
        'Metallic radius': 2.381,
        iupac_ordering: 9,
        'IUPAC ordering': 9,
        'Ground level': '2S1/2',
        'Ionization energies': [
            4.34066373, 31.625, 45.8031, 60.917, 82.66, 99.44, 117.56, 154.87, 175.8174, 503.67, 565.6, 631.1, 714.7,
            786.3, 860.92, 967.7, 1034.542, 4610.87018, 4934.0484,
        ],
        'Electron affinity': 0.50145913,
        symbol: 'K',
    },
    {
        'Atomic mass': 40.078,
        'Atomic no': 20,
        'Atomic orbitals': {
            '1s': -143.935181,
            '2p': -12.285376,
            '2s': -15.046905,
            '3p': -1.030572,
            '3s': -1.706331,
            '4s': -0.141411,
        },
        'Atomic radius': 1.8,
        'Atomic radius calculated': 1.94,
        'Boiling point': '1757 K',
        'Brinell hardness': '167 MN m<sup>-2</sup>',
        'Bulk modulus': '17 GPa',
        'Coefficient of linear thermal expansion': '22.3 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '1550 kg m<sup>-3</sup>',
        'Electrical resistivity': '3.4 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].4s<sup>2</sup>',
        'ICSD oxidation states': [2],
        'Ionic radii': { '2': 1.14 },
        'Liquid range': '642 K',
        'Melting point': '1115 K',
        'Mendeleev no': 16,
        'Mineral hardness': '1.75',
        'Molar volume': '26.20 cm<sup>3</sup>',
        Name: 'Calcium',
        'Oxidation states': [2],
        'Poissons ratio': '0.31',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '7.4 GPa',
        'Shannon radii': {
            '2': {
                VI: { '': { crystal_radius: 1.14, ionic_radius: 1 } },
                VII: { '': { crystal_radius: 1.2, ionic_radius: 1.06 } },
                VIII: { '': { crystal_radius: 1.26, ionic_radius: 1.12 } },
                IX: { '': { crystal_radius: 1.32, ionic_radius: 1.18 } },
                X: { '': { crystal_radius: 1.37, ionic_radius: 1.23 } },
                XII: { '': { crystal_radius: 1.48, ionic_radius: 1.34 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '200 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.31,
        'Velocity of sound': '3810 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1,
        'Youngs modulus': '20 GPa',
        'NMR Quadrupole Moment': { 'Ca-41': -66.5, 'Ca-43': -40.8 },
        'Metallic radius': 1.976,
        iupac_ordering: 15,
        'IUPAC ordering': 15,
        'Ground level': '1S0',
        'Ionization energies': [
            6.11315547, 11.871719, 50.91316, 67.2732, 84.34, 108.78, 127.21, 147.24, 188.54, 211.275, 591.6, 658.2,
            728.6, 817.2, 894, 973.7, 1086.8, 1157.726, 5128.8578, 5469.8616,
        ],
        'Electron affinity': 0.024551,
        symbol: 'Ca',
    },
    {
        'Atomic mass': 44.955912,
        'Atomic no': 21,
        'Atomic orbitals': {
            '1s': -160.184109,
            '2p': -14.240006,
            '2s': -17.206464,
            '3d': -0.13108,
            '3p': -1.233165,
            '3s': -1.988378,
            '4s': -0.156478,
        },
        'Atomic radius': 1.6,
        'Atomic radius calculated': 1.84,
        'Boiling point': '3103 K',
        'Brinell hardness': '750 MN m<sup>-2</sup>',
        'Bulk modulus': '57 GPa',
        'Coefficient of linear thermal expansion': '10.2 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '2985 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 55 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>1</sup>.4s<sup>2</sup>',
        'ICSD oxidation states': [2, 3],
        'Ionic radii': { '3': 0.885 },
        'Liquid range': '1289 K',
        'Melting point': '1814 K',
        'Mendeleev no': 19,
        'Mineral hardness': 'no data',
        'Molar volume': '15.00 cm<sup>3</sup>',
        Name: 'Scandium',
        'Oxidation states': [1, 2, 3],
        'Poissons ratio': '0.28',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '29 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 0.885, ionic_radius: 0.745 } },
                VIII: { '': { crystal_radius: 1.01, ionic_radius: 0.87 } },
            },
        },
        'Superconduction temperature': '0.05 (under pressure)K',
        'Thermal conductivity': '16 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.15,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.36,
        'Youngs modulus': '74 GPa',
        'NMR Quadrupole Moment': { 'Sc-45': -220.2 },
        'Metallic radius': 1.641,
        iupac_ordering: 49,
        'IUPAC ordering': 49,
        'Ground level': '2D3/2',
        'Ionization energies': [
            6.56149, 12.79977, 24.756839, 73.4894, 91.95, 110.68, 137.99, 158.08, 180.03, 225.18, 249.798, 687.36,
            757.7, 833.2, 926.5, 1008.6, 1093.5, 1213.1, 1287.957, 5674.9037, 6033.7542,
        ],
        'Electron affinity': 0.1882,
        symbol: 'Sc',
    },
    {
        'Atomic mass': 47.867,
        'Atomic no': 22,
        'Atomic orbitals': {
            '1s': -177.276643,
            '2p': -16.285339,
            '2s': -19.457901,
            '3d': -0.17001,
            '3p': -1.422947,
            '3s': -2.258007,
            '4s': -0.167106,
        },
        'Atomic radius': 1.4,
        'Atomic radius calculated': 1.76,
        'Boiling point': '3560 K',
        'Brinell hardness': '716 MN m<sup>-2</sup>',
        'Bulk modulus': '110 GPa',
        'Coefficient of linear thermal expansion': '8.6 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4],
        'Critical temperature': 'no data K',
        'Density of solid': '4507 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 40 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>2</sup>.4s<sup>2</sup>',
        'ICSD oxidation states': [2, 3, 4],
        'Ionic radii': { '2': 1, '3': 0.81, '4': 0.745 },
        'Liquid range': '1619 K',
        'Melting point': '1941 K',
        'Mendeleev no': 51,
        'Mineral hardness': '6.0',
        'Molar volume': '10.64 cm<sup>3</sup>',
        Name: 'Titanium',
        'Oxidation states': [-1, 2, 3, 4],
        'Poissons ratio': '0.32',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '44 GPa',
        'Shannon radii': {
            '2': { VI: { '': { crystal_radius: 1, ionic_radius: 0.86 } } },
            '3': { VI: { '': { crystal_radius: 0.81, ionic_radius: 0.67 } } },
            '4': {
                IV: { '': { crystal_radius: 0.56, ionic_radius: 0.42 } },
                V: { '': { crystal_radius: 0.65, ionic_radius: 0.51 } },
                VI: { '': { crystal_radius: 0.745, ionic_radius: 0.605 } },
                VIII: { '': { crystal_radius: 0.88, ionic_radius: 0.74 } },
            },
        },
        'Superconduction temperature': '0.40 K',
        'Thermal conductivity': '22 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.11,
        'Velocity of sound': '4140 m s<sup>-1</sup>',
        'Vickers hardness': '970 MN m<sup>-2</sup>',
        X: 1.54,
        'Youngs modulus': '116 GPa',
        'NMR Quadrupole Moment': { 'Ti-47': 302.1, 'Ti-49': 247.11 },
        'Metallic radius': 1.462,
        iupac_ordering: 52,
        'IUPAC ordering': 52,
        'Ground level': '3F2',
        'Ionization energies': [
            6.82812, 13.5755, 27.49171, 43.26717, 99.299, 119.533, 140.68, 170.5, 192.1, 215.92, 265.07, 291.5, 787.67,
            864, 944.5, 1042.5, 1130.2, 1220.3, 1346.3, 1425.257, 6249.0226, 6625.8073,
        ],
        'Electron affinity': 0.075545,
        symbol: 'Ti',
    },
    {
        'Atomic mass': 50.9415,
        'Atomic no': 23,
        'Atomic orbitals': {
            '1s': -195.224014,
            '2p': -18.435189,
            '2s': -21.815346,
            '3d': -0.204634,
            '3p': -1.610516,
            '3s': -2.526904,
            '4s': -0.175968,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.71,
        'Boiling point': '3680 K',
        'Brinell hardness': '628 MN m<sup>-2</sup>',
        'Bulk modulus': '160 GPa',
        'Coefficient of linear thermal expansion': '8.4 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [5],
        'Critical temperature': 'no data K',
        'Density of solid': '6110 kg m<sup>-3</sup>',
        'Electrical resistivity': '20 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>3</sup>.4s<sup>2</sup>',
        'ICSD oxidation states': [2, 3, 4, 5],
        'Ionic radii': { '2': 0.93, '3': 0.78, '4': 0.72, '5': 0.68 },
        'Liquid range': '1497 K',
        'Melting point': '2183 K',
        'Mendeleev no': 54,
        'Mineral hardness': '7.0',
        'Molar volume': '8.32 cm<sup>3</sup>',
        Name: 'Vanadium',
        'Oxidation states': [-1, 1, 2, 3, 4, 5],
        'Poissons ratio': '0.37',
        Reflectivity: '61 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '47 GPa',
        'Shannon radii': {
            '2': { VI: { '': { crystal_radius: 0.93, ionic_radius: 0.79 } } },
            '3': { VI: { '': { crystal_radius: 0.78, ionic_radius: 0.64 } } },
            '4': {
                V: { '': { crystal_radius: 0.67, ionic_radius: 0.53 } },
                VI: { '': { crystal_radius: 0.72, ionic_radius: 0.58 } },
                VIII: { '': { crystal_radius: 0.86, ionic_radius: 0.72 } },
            },
            '5': {
                IV: { '': { crystal_radius: 0.495, ionic_radius: 0.355 } },
                V: { '': { crystal_radius: 0.6, ionic_radius: 0.46 } },
                VI: { '': { crystal_radius: 0.68, ionic_radius: 0.54 } },
            },
        },
        'Superconduction temperature': '5.40 K',
        'Thermal conductivity': '31 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.07,
        'Velocity of sound': '4560 m s<sup>-1</sup>',
        'Vickers hardness': '628 MN m<sup>-2</sup>',
        X: 1.63,
        'Youngs modulus': '128 GPa',
        'NMR Quadrupole Moment': { 'V-50': 210.4, 'V-51': -52.1 },
        'Metallic radius': 1.347,
        iupac_ordering: 55,
        'IUPAC ordering': 55,
        'Ground level': '4F3/2',
        'Ionization energies': [
            6.746187, 14.634, 29.3111, 46.709, 65.28165, 128.125, 150.72, 173.55, 206, 230.5, 254.8, 308.5, 336.274,
            896, 977.2, 1062.9, 1165.2, 1258.9, 1354.2, 1486.7, 1569.656, 6851.3109, 7246.1226,
        ],
        'Electron affinity': 0.527662,
        symbol: 'V',
    },
    {
        'Atomic mass': 51.9961,
        'Atomic no': 24,
        'Atomic orbitals': {
            '1s': -213.881191,
            '2p': -20.526273,
            '2s': -24.113457,
            '3d': -0.118123,
            '3p': -1.65423,
            '3s': -2.649085,
            '4s': -0.150445,
        },
        'Atomic radius': 1.4,
        'Atomic radius calculated': 1.66,
        'Boiling point': '2944 K',
        'Brinell hardness': '1120 MN m<sup>-2</sup>',
        'Bulk modulus': '160 GPa',
        'Coefficient of linear thermal expansion': '4.9 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3, 6],
        'Critical temperature': 'no data K',
        'Density of solid': '7140 kg m<sup>-3</sup>',
        'Electrical resistivity': '12.7 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>5</sup>.4s<sup>1</sup>',
        'ICSD oxidation states': [2, 3, 4, 5, 6],
        'Ionic radii': { '2': 0.94 },
        'Ionic radii hs': { '2': 0.94 },
        'Ionic radii ls': { '2': 0.87, '3': 0.755, '4': 0.69, '5': 0.63, '6': 0.58 },
        'Liquid range': '764 K',
        'Melting point': '2180 K',
        'Mendeleev no': 57,
        'Mineral hardness': '8.5',
        'Molar volume': '7.23 cm<sup>3</sup>',
        Name: 'Chromium',
        'Oxidation states': [-2, -1, 1, 2, 3, 4, 5, 6],
        'Poissons ratio': '0.21',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '115 GPa',
        'Shannon radii': {
            '2': {
                VI: {
                    'Low Spin': { crystal_radius: 0.87, ionic_radius: 0.73 },
                    'High Spin': { crystal_radius: 0.94, ionic_radius: 0.8 },
                },
            },
            '3': { VI: { '': { crystal_radius: 0.755, ionic_radius: 0.615 } } },
            '4': {
                IV: { '': { crystal_radius: 0.55, ionic_radius: 0.41 } },
                VI: { '': { crystal_radius: 0.69, ionic_radius: 0.55 } },
            },
            '5': {
                IV: { '': { crystal_radius: 0.485, ionic_radius: 0.345 } },
                VI: { '': { crystal_radius: 0.63, ionic_radius: 0.49 } },
                VIII: { '': { crystal_radius: 0.71, ionic_radius: 0.57 } },
            },
            '6': {
                IV: { '': { crystal_radius: 0.4, ionic_radius: 0.26 } },
                VI: { '': { crystal_radius: 0.58, ionic_radius: 0.44 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '94 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.06,
        'Velocity of sound': '5940 m s<sup>-1</sup>',
        'Vickers hardness': '1060 MN m<sup>-2</sup>',
        X: 1.66,
        'Youngs modulus': '279 GPa',
        'NMR Quadrupole Moment': { 'Cr-53': -150.5 },
        'Metallic radius': 1.285,
        iupac_ordering: 58,
        'IUPAC ordering': 58,
        'Ground level': '7S3',
        'Ionization energies': [
            6.76651, 16.486305, 30.959, 49.16, 69.46, 90.6349, 160.29, 184.76, 209.5, 244.5, 270.8, 296.7, 354.7,
            384.163, 1011.6, 1097.2, 1188, 1294.8, 1394.5, 1495.1, 1634.1, 1721.183, 7481.8628, 7894.7992,
        ],
        'Electron affinity': 0.6758412,
        symbol: 'Cr',
    },
    {
        'Atomic mass': 54.938045,
        'Atomic no': 25,
        'Atomic orbitals': {
            '1s': -233.696912,
            '2p': -23.066297,
            '2s': -26.866646,
            '3d': -0.26654,
            '3p': -1.99145,
            '3s': -3.076637,
            '4s': -0.191136,
        },
        'Atomic radius': 1.4,
        'Atomic radius calculated': 1.61,
        'Boiling point': '2334 K',
        'Brinell hardness': '196 MN m<sup>-2</sup>',
        'Bulk modulus': '120 GPa',
        'Coefficient of linear thermal expansion': '21.7 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2, 4, 7],
        'Critical temperature': 'no data K',
        'Density of solid': '7470 kg m<sup>-3</sup>',
        'Electrical resistivity': '144 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>5</sup>.4s<sup>2</sup>',
        'ICSD oxidation states': [2, 3, 4, 7],
        'Ionic radii': { '2': 0.97, '3': 0.785, '4': 0.67, '5': 0.47, '6': 0.395, '7': 0.6 },
        'Ionic radii hs': { '2': 0.97, '3': 0.785 },
        'Ionic radii ls': { '2': 0.81, '3': 0.72, '4': 0.67, '5': 0.47, '6': 0.395, '7': 0.6 },
        'Liquid range': '815 K',
        'Melting point': '1519 K',
        'Mendeleev no': 60,
        'Mineral hardness': '6.0',
        'Molar volume': '7.35 cm<sup>3</sup>',
        Name: 'Manganese',
        'Oxidation states': [-3, -2, -1, 1, 2, 3, 4, 5, 6, 7],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '2': {
                IV: { 'High Spin': { crystal_radius: 0.8, ionic_radius: 0.66 } },
                V: { 'High Spin': { crystal_radius: 0.89, ionic_radius: 0.75 } },
                VI: {
                    'Low Spin': { crystal_radius: 0.81, ionic_radius: 0.67 },
                    'High Spin': { crystal_radius: 0.97, ionic_radius: 0.83 },
                },
                VII: { 'High Spin': { crystal_radius: 1.04, ionic_radius: 0.9 } },
                VIII: { '': { crystal_radius: 1.1, ionic_radius: 0.96 } },
            },
            '3': {
                V: { '': { crystal_radius: 0.72, ionic_radius: 0.58 } },
                VI: {
                    'Low Spin': { crystal_radius: 0.72, ionic_radius: 0.58 },
                    'High Spin': { crystal_radius: 0.785, ionic_radius: 0.645 },
                },
            },
            '4': {
                IV: { '': { crystal_radius: 0.53, ionic_radius: 0.39 } },
                VI: { '': { crystal_radius: 0.67, ionic_radius: 0.53 } },
            },
            '5': { IV: { '': { crystal_radius: 0.47, ionic_radius: 0.33 } } },
            '6': { IV: { '': { crystal_radius: 0.395, ionic_radius: 0.255 } } },
            '7': {
                IV: { '': { crystal_radius: 0.39, ionic_radius: 0.25 } },
                VI: { '': { crystal_radius: 0.6, ionic_radius: 0.46 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '7.8 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.05,
        'Velocity of sound': '5150 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.55,
        'Youngs modulus': '198 GPa',
        'NMR Quadrupole Moment': { 'Mn-55': 330.1 },
        'Metallic radius': 1.292,
        iupac_ordering: 61,
        'IUPAC ordering': 61,
        'Ground level': '6S5/2',
        'Ionization energies': [
            7.434038, 15.63999, 33.668, 51.21, 72.41, 95.604, 119.203, 195.5, 221.89, 248.6, 286.1, 314.4, 343.6,
            402.95, 435.172, 1133.7, 1224.1, 1320.3, 1430.9, 1537.2, 1643.2, 1788.7, 1879.873, 8140.7872, 8571.9488,
        ],
        'Electron affinity': -0.52,
        symbol: 'Mn',
    },
    {
        'Atomic mass': 55.845,
        'Atomic no': 26,
        'Atomic orbitals': {
            '1s': -254.225505,
            '2p': -25.551766,
            '2s': -29.56486,
            '3d': -0.295049,
            '3p': -2.187523,
            '3s': -3.360621,
            '4s': -0.197978,
        },
        'Atomic radius': 1.4,
        'Atomic radius calculated': 1.56,
        'Boiling point': '3134 K',
        'Brinell hardness': '490 MN m<sup>-2</sup>',
        'Bulk modulus': '170 GPa',
        'Coefficient of linear thermal expansion': '11.8 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2, 3],
        'Critical temperature': 'no data K',
        'Density of solid': '7874 kg m<sup>-3</sup>',
        'Electrical resistivity': '10 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>6</sup>.4s<sup>2</sup>',
        'ICSD oxidation states': [2, 3],
        'Ionic radii': { '2': 0.92, '3': 0.785 },
        'Ionic radii hs': { '2': 0.92, '3': 0.785 },
        'Ionic radii ls': { '2': 0.75, '3': 0.69, '4': 0.725, '6': 0.39 },
        'Liquid range': '1323 K',
        'Melting point': '1811 K',
        'Mendeleev no': 61,
        'Mineral hardness': '4.0',
        'Molar volume': '7.09 cm<sup>3</sup>',
        Name: 'Iron',
        'Oxidation states': [-2, -1, 1, 2, 3, 4, 5, 6],
        'Poissons ratio': '0.29',
        Reflectivity: '65 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '82 GPa',
        'Shannon radii': {
            '2': {
                IV: { 'High Spin': { crystal_radius: 0.77, ionic_radius: 0.63 } },
                IVSQ: { 'High Spin': { crystal_radius: 0.78, ionic_radius: 0.64 } },
                VI: {
                    'Low Spin': { crystal_radius: 0.75, ionic_radius: 0.61 },
                    'High Spin': { crystal_radius: 0.92, ionic_radius: 0.78 },
                },
                VIII: { 'High Spin': { crystal_radius: 1.06, ionic_radius: 0.92 } },
            },
            '3': {
                IV: { 'High Spin': { crystal_radius: 0.63, ionic_radius: 0.49 } },
                V: { '': { crystal_radius: 0.72, ionic_radius: 0.58 } },
                VI: {
                    'Low Spin': { crystal_radius: 0.69, ionic_radius: 0.55 },
                    'High Spin': { crystal_radius: 0.785, ionic_radius: 0.645 },
                },
                VIII: { 'High Spin': { crystal_radius: 0.92, ionic_radius: 0.78 } },
            },
            '4': { VI: { '': { crystal_radius: 0.725, ionic_radius: 0.585 } } },
            '6': { IV: { '': { crystal_radius: 0.39, ionic_radius: 0.25 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '80 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.04,
        'Velocity of sound': '4910 m s<sup>-1</sup>',
        'Vickers hardness': '608 MN m<sup>-2</sup>',
        X: 1.83,
        'Youngs modulus': '211 GPa',
        'NMR Quadrupole Moment': { 'Fe-57': 160 },
        'Metallic radius': 1.277,
        iupac_ordering: 64,
        'IUPAC ordering': 64,
        'Ground level': '5D4',
        'Ionization energies': [
            7.9024681, 16.19921, 30.651, 54.91, 75, 98.985, 124.976, 151.06, 233.6, 262.1, 290.9, 330.8, 361, 392.2,
            456.2, 489.312, 1262.7, 1357.8, 1460, 1575.6, 1687, 1798.4, 1950.4, 2045.759, 8828.1879, 9277.6818,
        ],
        'Electron affinity': 0.15323634,
        symbol: 'Fe',
    },
    {
        'Atomic mass': 58.933195,
        'Atomic no': 27,
        'Atomic orbitals': {
            '1s': -275.616639,
            '2p': -28.152095,
            '2s': -32.379758,
            '3d': -0.322368,
            '3p': -2.388285,
            '3s': -3.651812,
            '4s': -0.204497,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.52,
        'Boiling point': '3200 K',
        'Brinell hardness': '700 MN m<sup>-2</sup>',
        'Bulk modulus': '180 GPa',
        'Coefficient of linear thermal expansion': '13.0 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2, 3],
        'Critical temperature': 'no data K',
        'Density of solid': '8900 kg m<sup>-3</sup>',
        'Electrical resistivity': '6 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>7</sup>.4s<sup>2</sup>',
        'ICSD oxidation states': [1, 2, 3, 4],
        'Ionic radii': { '2': 0.885, '3': 0.75, '4': 0.67 },
        'Ionic radii hs': { '2': 0.885, '3': 0.75, '4': 0.67 },
        'Ionic radii ls': { '2': 0.79, '3': 0.685 },
        'Liquid range': '1432 K',
        'Melting point': '1768 K',
        'Mendeleev no': 64,
        'Mineral hardness': '5.0',
        'Molar volume': '6.67 cm<sup>3</sup>',
        Name: 'Cobalt',
        'Oxidation states': [-1, 1, 2, 3, 4, 5],
        'Poissons ratio': '0.31',
        Reflectivity: '67 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '75 GPa',
        'Shannon radii': {
            '2': {
                IV: { 'High Spin': { crystal_radius: 0.72, ionic_radius: 0.58 } },
                V: { '': { crystal_radius: 0.81, ionic_radius: 0.67 } },
                VI: {
                    'Low Spin': { crystal_radius: 0.79, ionic_radius: 0.65 },
                    'High Spin': { crystal_radius: 0.885, ionic_radius: 0.745 },
                },
                VIII: { '': { crystal_radius: 1.04, ionic_radius: 0.9 } },
            },
            '3': {
                VI: {
                    'High Spin': { crystal_radius: 0.75, ionic_radius: 0.61 },
                    'Low Spin': { crystal_radius: 0.685, ionic_radius: 0.545 },
                },
            },
            '4': {
                IV: { '': { crystal_radius: 0.54, ionic_radius: 0.4 } },
                VI: { 'High Spin': { crystal_radius: 0.67, ionic_radius: 0.53 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '100 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2,
        'Velocity of sound': '4720 m s<sup>-1</sup>',
        'Vickers hardness': '1043 MN m<sup>-2</sup>',
        X: 1.88,
        'Youngs modulus': '209 GPa',
        'NMR Quadrupole Moment': { 'Co-59': 420.3 },
        'Metallic radius': 1.25,
        iupac_ordering: 67,
        'IUPAC ordering': 67,
        'Ground level': '4F9/2',
        'Ionization energies': [
            7.88101, 17.0844, 33.5, 51.27, 79.5, 102, 128.9, 157.8, 186.14, 275.4, 305.32, 336.1, 378.5, 410, 441.1,
            511.96, 546.588, 1397.2, 1504.5, 1606, 1724, 1844, 1960.8, 2119.4, 2218.876, 9544.1833, 10012.122,
        ],
        'Electron affinity': 0.662265,
        symbol: 'Co',
    },
    {
        'Atomic mass': 58.6934,
        'Atomic no': 28,
        'Atomic orbitals': {
            '1s': -297.870824,
            '2p': -30.868027,
            '2s': -35.312112,
            '3d': -0.348699,
            '3p': -2.594158,
            '3s': -3.950717,
            '4s': -0.210764,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.49,
        'Boiling point': '3186 K',
        'Brinell hardness': '700 MN m<sup>-2</sup>',
        'Bulk modulus': '180 GPa',
        'Coefficient of linear thermal expansion': '13.4 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '8908 kg m<sup>-3</sup>',
        'Electrical resistivity': '7.2 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>8</sup>.4s<sup>2</sup>',
        'ICSD oxidation states': [1, 2, 3, 4],
        'Ionic radii': { '3': 0.74 },
        'Ionic radii hs': { '3': 0.74 },
        'Ionic radii ls': { '2': 0.83, '3': 0.7, '4': 0.62 },
        'Liquid range': '1458 K',
        'Melting point': '1728 K',
        'Mendeleev no': 67,
        'Mineral hardness': '4.0',
        'Molar volume': '6.59 cm<sup>3</sup>',
        Name: 'Nickel',
        'Oxidation states': [-1, 1, 2, 3, 4],
        'Poissons ratio': '0.31',
        Reflectivity: '72 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '76 GPa',
        'Shannon radii': {
            '2': {
                IV: { '': { crystal_radius: 0.69, ionic_radius: 0.55 } },
                IVSQ: { '': { crystal_radius: 0.63, ionic_radius: 0.49 } },
                V: { '': { crystal_radius: 0.77, ionic_radius: 0.63 } },
                VI: { '': { crystal_radius: 0.83, ionic_radius: 0.69 } },
            },
            '3': {
                VI: {
                    'Low Spin': { crystal_radius: 0.7, ionic_radius: 0.56 },
                    'High Spin': { crystal_radius: 0.74, ionic_radius: 0.6 },
                },
            },
            '4': { VI: { 'Low Spin': { crystal_radius: 0.62, ionic_radius: 0.48 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '91 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.97,
        'Velocity of sound': '4970 m s<sup>-1</sup>',
        'Vickers hardness': '638 MN m<sup>-2</sup>',
        X: 1.91,
        'Youngs modulus': '200 GPa',
        'NMR Quadrupole Moment': { 'Ni-61': 162.15 },
        'Metallic radius': 1.246,
        iupac_ordering: 70,
        'IUPAC ordering': 70,
        'Ground level': '3F4',
        'Ionization energies': [
            7.639878, 18.168838, 35.187, 54.92, 76.06, 108, 132, 162, 193.2, 224.7, 319.5, 351.6, 384.5, 429.3, 462.8,
            495.4, 571.07, 607.02, 1541, 1646, 1758, 1880, 2008.1, 2130.5, 2295.6, 2399.259, 10288.8862, 10775.386,
        ],
        'Electron affinity': 1.1571612,
        symbol: 'Ni',
    },
    {
        'Atomic mass': 63.546,
        'Atomic no': 29,
        'Atomic orbitals': {
            '1s': -320.78852,
            '2p': -33.481247,
            '2s': -38.14131,
            '3d': -0.202272,
            '3p': -2.609244,
            '3s': -4.057453,
            '4s': -0.172056,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.45,
        'Boiling point': '3200 K',
        'Brinell hardness': '874 MN m<sup>-2</sup>',
        'Bulk modulus': '140 GPa',
        'Coefficient of linear thermal expansion': '16.5 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '8920 kg m<sup>-3</sup>',
        'Electrical resistivity': '1.72 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>10</sup>.4s<sup>1</sup>',
        'ICSD oxidation states': [1, 2, 3],
        'Ionic radii': { '1': 0.91, '2': 0.87, '3': 0.68 },
        'Liquid range': '1842.23 K',
        'Melting point': '1357.77 K',
        'Mendeleev no': 72,
        'Mineral hardness': '3.0',
        'Molar volume': '7.11 cm<sup>3</sup>',
        Name: 'Copper',
        'Oxidation states': [1, 2, 3, 4],
        'Poissons ratio': '0.34',
        Reflectivity: '90 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '48 GPa',
        'Shannon radii': {
            '1': {
                II: { '': { crystal_radius: 0.6, ionic_radius: 0.46 } },
                IV: { '': { crystal_radius: 0.74, ionic_radius: 0.6 } },
                VI: { '': { crystal_radius: 0.91, ionic_radius: 0.77 } },
            },
            '2': {
                IV: { '': { crystal_radius: 0.71, ionic_radius: 0.57 } },
                IVSQ: { '': { crystal_radius: 0.71, ionic_radius: 0.57 } },
                V: { '': { crystal_radius: 0.79, ionic_radius: 0.65 } },
                VI: { '': { crystal_radius: 0.87, ionic_radius: 0.73 } },
            },
            '3': { VI: { 'Low Spin': { crystal_radius: 0.68, ionic_radius: 0.54 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '400 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.96,
        'Velocity of sound': '3570 m s<sup>-1</sup>',
        'Vickers hardness': '369 MN m<sup>-2</sup>',
        X: 1.9,
        'Youngs modulus': '130 GPa',
        'NMR Quadrupole Moment': { 'Cu-63': -220.15, 'Cu-65': -204.14 },
        'Metallic radius': 1.278,
        iupac_ordering: 73,
        'IUPAC ordering': 73,
        'Ground level': '2S1/2',
        'Ionization energies': [
            7.72638, 20.29239, 36.841, 57.38, 79.8, 103, 139, 166, 198, 232.2, 265.33, 367, 401, 436, 483.1, 518.7,
            552.8, 632.5, 670.608, 1690.5, 1800, 1918, 2044, 2179.4, 2307.3, 2479.1, 2586.954, 11062.4313, 11567.613,
        ],
        'Electron affinity': 1.235784,
        symbol: 'Cu',
    },
    {
        'Atomic mass': 65.409,
        'Atomic no': 30,
        'Atomic orbitals': {
            '1s': -344.969756,
            '2p': -36.648765,
            '2s': -41.531323,
            '3d': -0.398944,
            '3p': -3.022363,
            '3s': -4.573041,
            '4s': -0.222725,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.42,
        'Boiling point': '1180 K',
        'Brinell hardness': '412 MN m<sup>-2</sup>',
        'Bulk modulus': '70 GPa',
        'Coefficient of linear thermal expansion': '30.2 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '7140 kg m<sup>-3</sup>',
        'Electrical resistivity': '6.0 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>10</sup>.4s<sup>2</sup>',
        'ICSD oxidation states': [2],
        'Ionic radii': { '2': 0.88 },
        'Liquid range': '487.32 K',
        'Melting point': '692.68 K',
        'Mendeleev no': 76,
        'Mineral hardness': '2.5',
        'Molar volume': '9.16 cm<sup>3</sup>',
        Name: 'Zinc',
        'Oxidation states': [1, 2],
        'Poissons ratio': '0.25',
        Reflectivity: '80 %',
        'Refractive index': '1.002050',
        'Rigidity modulus': '43 GPa',
        'Shannon radii': {
            '2': {
                IV: { '': { crystal_radius: 0.74, ionic_radius: 0.6 } },
                V: { '': { crystal_radius: 0.82, ionic_radius: 0.68 } },
                VI: { '': { crystal_radius: 0.88, ionic_radius: 0.74 } },
                VIII: { '': { crystal_radius: 1.04, ionic_radius: 0.9 } },
            },
        },
        'Superconduction temperature': '0.85 K',
        'Thermal conductivity': '120 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.01,
        'Velocity of sound': '3700 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.65,
        'Youngs modulus': '108 GPa',
        'NMR Quadrupole Moment': { 'Zn-67': 150.15 },
        'Metallic radius': 1.34,
        iupac_ordering: 76,
        'IUPAC ordering': 76,
        'Ground level': '1S0',
        'Ionization energies': [
            9.394197, 17.96439, 39.7233, 59.573, 82.6, 108, 133.9, 173.9, 203, 238, 274.4, 310.8, 417.6, 453.4, 490.6,
            540, 577.8, 613.3, 697.5, 737.366, 1846.8, 1961, 2085, 2214, 2358, 2491.5, 2669.9, 2781.996, 11864.9399,
            12388.929,
        ],
        'Electron affinity': -0.62,
        symbol: 'Zn',
    },
    {
        'Atomic mass': 69.723,
        'Atomic no': 31,
        'Atomic orbitals': {
            '1s': -370.170639,
            '2p': -40.093339,
            '2s': -45.200869,
            '3d': -0.736204,
            '3p': -3.584666,
            '3s': -5.241645,
            '4p': -0.101634,
            '4s': -0.328019,
        },
        'Atomic radius': 1.3,
        'Atomic radius calculated': 1.36,
        'Boiling point': '2477 K',
        'Brinell hardness': '60 MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': '120 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '5904 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 14 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>10</sup>.4s<sup>2</sup>.4p<sup>1</sup>',
        'ICSD oxidation states': [2, 3],
        'Ionic radii': { '3': 0.76 },
        'Liquid range': '2174.09 K',
        'Melting point': '302.91 K',
        'Mendeleev no': 81,
        'Mineral hardness': '1.5',
        'Molar volume': '11.80 cm<sup>3</sup>',
        Name: 'Gallium',
        'Oxidation states': [1, 2, 3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': {
                IV: { '': { crystal_radius: 0.61, ionic_radius: 0.47 } },
                V: { '': { crystal_radius: 0.69, ionic_radius: 0.55 } },
                VI: { '': { crystal_radius: 0.76, ionic_radius: 0.62 } },
            },
        },
        'Superconduction temperature': '1.083 K',
        'Thermal conductivity': '29 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.87,
        'Velocity of sound': '2740 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.81,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.35,
        iupac_ordering: 79,
        'IUPAC ordering': 79,
        'Ground level': '2P°1/2',
        'Ionization energies': [
            5.999302, 20.51514, 30.72576, 63.241, 86.01, 112.7, 140.8, 169.9, 211, 244, 280, 319, 356, 471.2, 508.8,
            548.3, 599.8, 640, 677, 765.7, 807.308, 2010, 2129, 2258, 2391, 2543.9, 2683, 2868, 2984.426, 12696.5575,
            13239.489,
        ],
        'Electron affinity': 0.3012011,
        symbol: 'Ga',
    },
    {
        'Atomic mass': 72.64,
        'Atomic no': 32,
        'Atomic orbitals': {
            '1s': -396.292991,
            '2p': -43.720129,
            '2s': -49.055282,
            '3d': -1.117316,
            '3p': -4.194822,
            '3s': -5.961472,
            '4p': -0.149882,
            '4s': -0.426523,
        },
        'Atomic radius': 1.25,
        'Atomic radius calculated': 1.25,
        'Boiling point': '3093 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': '6 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-4, 2, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '5323 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 50000 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>10</sup>.4s<sup>2</sup>.4p<sup>2</sup>',
        'ICSD oxidation states': [2, 3, 4],
        'Ionic radii': { '2': 0.87, '4': 0.67 },
        'Liquid range': '1881.6 K',
        'Melting point': '1211.4 K',
        'Mendeleev no': 84,
        'Mineral hardness': '6.0',
        'Molar volume': '13.63 cm<sup>3</sup>',
        Name: 'Germanium',
        'Oxidation states': [-4, 1, 2, 3, 4],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '2': { VI: { '': { crystal_radius: 0.87, ionic_radius: 0.73 } } },
            '4': {
                IV: { '': { crystal_radius: 0.53, ionic_radius: 0.39 } },
                VI: { '': { crystal_radius: 0.67, ionic_radius: 0.53 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '60 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.11,
        'Velocity of sound': '5400 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.01,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.39,
        iupac_ordering: 84,
        'IUPAC ordering': 84,
        'Ground level': '3P0',
        'Ionization energies': [
            7.899435, 15.93461, 34.0576, 45.7155, 90.5, 115.9, 144.9, 176.4, 212.5, 252.1, 286, 326, 367, 407, 527.9,
            567.3, 609.1, 662.8, 706.7, 744, 837.1, 880.44, 2180.1, 2304, 2439, 2575, 2737.1, 2881.9, 3074, 3194.293,
            13557.4208, 14119.43,
        ],
        'Electron affinity': 1.232676413,
        symbol: 'Ge',
    },
    {
        'Atomic mass': 74.9216,
        'Atomic no': 33,
        'Atomic orbitals': {
            '1s': -423.336658,
            '2p': -47.527869,
            '2s': -53.093086,
            '3d': -1.542767,
            '3p': -4.851725,
            '3s': -6.730755,
            '4p': -0.197497,
            '4s': -0.52367,
        },
        'Atomic radius': 1.15,
        'Atomic radius calculated': 1.14,
        'Boiling point': '887 K',
        'Brinell hardness': '1440 MN m<sup>-2</sup>',
        'Bulk modulus': '22 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-3, 3, 5],
        'Critical temperature': '1700 K',
        'Density of solid': '5727 kg m<sup>-3</sup>',
        'Electrical resistivity': '33 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>10</sup>.4s<sup>2</sup>.4p<sup>3</sup>',
        'ICSD oxidation states': [2, 3, 5, -2, -3, -1],
        'Ionic radii': { '3': 0.72, '5': 0.6 },
        'Liquid range': '203 K',
        'Melting point': '1090 K',
        'Mendeleev no': 89,
        'Mineral hardness': '3.5',
        'Molar volume': '12.95 cm<sup>3</sup>',
        Name: 'Arsenic',
        'Oxidation states': [-3, 2, 3, 5],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.001552',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.72, ionic_radius: 0.58 } } },
            '5': {
                IV: { '': { crystal_radius: 0.475, ionic_radius: 0.335 } },
                VI: { '': { crystal_radius: 0.6, ionic_radius: 0.46 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '50 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.85,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.18,
        'Youngs modulus': '8 GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 89,
        'IUPAC ordering': 89,
        'Ground level': '4S°3/2',
        'Ionization energies': [
            9.78855, 18.5892, 28.349, 50.15, 62.77, 121.19, 147, 180, 213, 247, 296, 333, 375, 418, 460, 587.6, 628.8,
            672.9, 728.9, 774, 814, 911.7, 956.79, 2356.9, 2486, 2626, 2766, 2938, 3088.1, 3287, 3411.643, 14447.678,
            15028.907,
        ],
        'Electron affinity': 0.80482,
        symbol: 'As',
    },
    {
        'Atomic mass': 78.96,
        'Atomic no': 34,
        'Atomic orbitals': {
            '1s': -451.300258,
            '2p': -51.514388,
            '2s': -57.311948,
            '3d': -2.011392,
            '3p': -5.553517,
            '3s': -7.547186,
            '4p': -0.245806,
            '4s': -0.621248,
        },
        'Atomic radius': 1.15,
        'Atomic radius calculated': 1.03,
        'Boiling point': '958 K',
        'Brinell hardness': '736 MN m<sup>-2</sup>',
        'Bulk modulus': '8.3 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-2, 2, 4, 6],
        'Critical temperature': '1766 K',
        'Density of solid': '4819 kg m<sup>-3</sup>',
        'Electrical resistivity': 'high 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>10</sup>.4s<sup>2</sup>.4p<sup>4</sup>',
        'ICSD oxidation states': [-1, 4, -2, 6],
        'Ionic radii': { '4': 0.64, '6': 0.56, '-2': 1.84 },
        'Liquid range': '464 K',
        'Melting point': '494 K',
        'Mendeleev no': 93,
        'Mineral hardness': '2.0',
        'Molar volume': '16.42 cm<sup>3</sup>',
        Name: 'Selenium',
        'Oxidation states': [-2, 2, 4, 6],
        'Poissons ratio': '0.33',
        Reflectivity: 'no data %',
        'Refractive index': '1.000895',
        'Rigidity modulus': '3.7 GPa',
        'Shannon radii': {
            '4': { VI: { '': { crystal_radius: 0.64, ionic_radius: 0.5 } } },
            '6': {
                IV: { '': { crystal_radius: 0.42, ionic_radius: 0.28 } },
                VI: { '': { crystal_radius: 0.56, ionic_radius: 0.42 } },
            },
            '-2': { VI: { '': { crystal_radius: 1.84, ionic_radius: 1.98 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.52 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.9,
        'Velocity of sound': '3350 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.55,
        'Youngs modulus': '10 GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 95,
        'IUPAC ordering': 95,
        'Ground level': '3P2',
        'Ionization energies': [
            9.752392, 21.196, 31.697, 42.947, 68.3, 81.83, 155.327, 184, 219, 255, 291, 342.9, 383, 426, 473, 517,
            650.5, 693.4, 739.8, 798, 845.8, 887, 989.6, 1036.36, 2540.7, 2674, 2820, 2964, 3146, 3301.8, 3507,
            3636.526, 15367.491, 15968.084,
        ],
        'Electron affinity': 2.020604712,
        symbol: 'Se',
    },
    {
        'Atomic mass': 79.904,
        'Atomic no': 35,
        'Atomic orbitals': {
            '1s': -480.182643,
            '2p': -55.67796,
            '2s': -61.710022,
            '3d': -2.52211,
            '3p': -6.298805,
            '3s': -8.409057,
            '4p': -0.295334,
            '4s': -0.720066,
        },
        'Atomic radius': 1.15,
        'Atomic radius calculated': 0.94,
        'Boiling point': '332 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '1.9 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-1, 1, 3, 5, 7],
        'Critical temperature': '586 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': '&gt; 10<sup>18</sup>10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>10</sup>.4s<sup>2</sup>.4p<sup>5</sup>',
        'ICSD oxidation states': [5, -1],
        'Ionic radii': { '3': 0.73, '5': 0.45, '7': 0.53, '-1': 1.82 },
        'Liquid range': '66.2 K',
        'Melting point': '265.8 K',
        'Mendeleev no': 98,
        'Mineral hardness': 'no data',
        'Molar volume': '19.78 cm<sup>3</sup>',
        Name: 'Bromine',
        'Oxidation states': [-1, 1, 3, 4, 5, 7],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.001132',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': { IVSQ: { '': { crystal_radius: 0.73, ionic_radius: 0.59 } } },
            '5': { IIIPY: { '': { crystal_radius: 0.45, ionic_radius: 0.31 } } },
            '7': {
                IV: { '': { crystal_radius: 0.39, ionic_radius: 0.25 } },
                VI: { '': { crystal_radius: 0.53, ionic_radius: 0.39 } },
            },
            '-1': { VI: { '': { crystal_radius: 1.82, ionic_radius: 1.96 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.12 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.85,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.96,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.14,
        iupac_ordering: 100,
        'IUPAC ordering': 100,
        'Ground level': '2P°3/2',
        'Ionization energies': [
            11.81381, 21.591, 34.871, 47.782, 59.595, 87.39, 103.03, 192.61, 224, 261, 301, 338, 393, 436, 481, 530,
            577, 716.3, 761, 809.8, 870, 920.8, 963, 1070.6, 1119.17, 2731.4, 2869, 3021, 3169, 3361, 3523.1, 3735,
            3868.986, 16317.011, 16937.127,
        ],
        'Electron affinity': 3.3635883,
        symbol: 'Br',
    },
    {
        'Atomic mass': 83.798,
        'Atomic no': 36,
        'Atomic orbitals': {
            '1s': -509.982989,
            '2p': -60.017328,
            '2s': -66.285953,
            '3d': -3.074109,
            '3p': -7.086634,
            '3s': -9.315192,
            '4p': -0.34634,
            '4s': -0.820574,
        },
        'Atomic radius': 'no data',
        'Atomic radius calculated': 0.88,
        'Boiling point': '119.93 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Critical temperature': '209.4 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Ar].3d<sup>10</sup>.4s<sup>2</sup>.4p<sup>6</sup>',
        'Liquid range': '4.14 K',
        'Max oxidation state': 0,
        'Melting point': '115.79 K',
        'Mendeleev no': 4,
        'Min oxidation state': 0,
        'Mineral hardness': 'no data',
        'Molar volume': '27.99 cm<sup>3</sup>',
        Name: 'Krypton',
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000427',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.00943 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.02,
        'Velocity of sound': '1120 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 2,
        'IUPAC ordering': 2,
        'Ground level': '1S0',
        'Ionization energies': [
            13.9996055, 24.35984, 35.838, 50.85, 64.69, 78.49, 109.13, 125.802, 233, 268, 308, 350, 391, 446, 492, 540,
            591, 640, 785, 831.6, 882.8, 945, 999, 1042, 1155, 1205.23, 2928.9, 3072, 3228, 3380, 3584, 3752, 3971,
            4109.083, 17296.421, 17936.209,
        ],
        'Electron affinity': -1.02,
        symbol: 'Kr',
    },
    {
        'Atomic mass': 85.4678,
        'Atomic no': 37,
        'Atomic orbitals': {
            '1s': -540.957115,
            '2p': -64.784678,
            '2s': -71.291202,
            '3d': -3.915508,
            '3p': -8.165416,
            '3s': -10.513861,
            '4p': -0.59217,
            '4s': -1.135051,
            '5s': -0.085375,
        },
        'Atomic radius': 2.35,
        'Atomic radius calculated': 2.65,
        'Boiling point': '961 K',
        'Brinell hardness': '0.216 MN m<sup>-2</sup>',
        'Bulk modulus': '2.5 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1],
        'Critical temperature': '2093 K',
        'Density of solid': '1532 kg m<sup>-3</sup>',
        'Electrical resistivity': '13.3 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].5s<sup>1</sup>',
        'ICSD oxidation states': [1],
        'Ionic radii': { '1': 1.66 },
        'Liquid range': '648.54 K',
        'Melting point': '312.46 K',
        'Mendeleev no': 9,
        'Mineral hardness': '0.3',
        'Molar volume': '55.76 cm<sup>3</sup>',
        Name: 'Rubidium',
        'Oxidation states': [1],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '1': {
                VI: { '': { crystal_radius: 1.66, ionic_radius: 1.52 } },
                VII: { '': { crystal_radius: 1.7, ionic_radius: 1.56 } },
                VIII: { '': { crystal_radius: 1.75, ionic_radius: 1.61 } },
                IX: { '': { crystal_radius: 1.77, ionic_radius: 1.63 } },
                X: { '': { crystal_radius: 1.8, ionic_radius: 1.66 } },
                XI: { '': { crystal_radius: 1.83, ionic_radius: 1.69 } },
                XII: { '': { crystal_radius: 1.86, ionic_radius: 1.72 } },
                XIV: { '': { crystal_radius: 1.97, ionic_radius: 1.83 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '58 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 3.03,
        'Velocity of sound': '1300 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.82,
        'Youngs modulus': '2.4 GPa',
        'Metallic radius': 2.537,
        iupac_ordering: 8,
        'IUPAC ordering': 8,
        'Ground level': '2S1/2',
        'Ionization energies': [
            4.1771281, 27.28954, 39.247, 52.2, 68.44, 82.9, 98.67, 132.79, 150.628, 277.12, 313.1, 356, 400, 443, 502,
            550, 601, 654, 706, 857, 905.3, 958.9, 1024, 1080, 1125, 1242.5, 1294.57, 3133.3, 3281, 3443, 3600, 3815,
            3988, 4214, 4356.865, 18305.884, 18965.516,
        ],
        'Electron affinity': 0.48591621,
        symbol: 'Rb',
    },
    {
        'Atomic mass': 87.62,
        'Atomic no': 38,
        'Atomic orbitals': {
            '1s': -572.870169,
            '2p': -69.745941,
            '2s': -76.491823,
            '3d': -4.813498,
            '3p': -9.301863,
            '3s': -11.771585,
            '4p': -0.844489,
            '4s': -1.455317,
            '5s': -0.131793,
        },
        'Atomic radius': 2,
        'Atomic radius calculated': 2.19,
        'Boiling point': '1655 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': '22.5 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '2630 kg m<sup>-3</sup>',
        'Electrical resistivity': '13.5 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].5s<sup>2</sup>',
        'ICSD oxidation states': [2],
        'Ionic radii': { '2': 1.32 },
        'Liquid range': '605 K',
        'Melting point': '1050 K',
        'Mendeleev no': 15,
        'Mineral hardness': '1.5',
        'Molar volume': '33.94 cm<sup>3</sup>',
        Name: 'Strontium',
        'Oxidation states': [2],
        'Poissons ratio': '0.28',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '6.1 GPa',
        'Shannon radii': {
            '2': {
                VI: { '': { crystal_radius: 1.32, ionic_radius: 1.18 } },
                VII: { '': { crystal_radius: 1.35, ionic_radius: 1.21 } },
                VIII: { '': { crystal_radius: 1.4, ionic_radius: 1.26 } },
                IX: { '': { crystal_radius: 1.45, ionic_radius: 1.31 } },
                X: { '': { crystal_radius: 1.5, ionic_radius: 1.36 } },
                XII: { '': { crystal_radius: 1.58, ionic_radius: 1.44 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '35 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.49,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.95,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'Sr-87': 305.2 },
        'Metallic radius': 2.151,
        iupac_ordering: 14,
        'IUPAC ordering': 14,
        'Ground level': '1S0',
        'Ionization energies': [
            5.69486745, 11.0302765, 42.88353, 56.28, 70.7, 88, 104, 121.21, 158.33, 177.3, 324.07, 362, 408, 454, 499,
            562, 612, 665, 722, 774, 932, 982.1, 1038, 1105, 1165, 1211, 1333.4, 1387.19, 3344.7, 3497, 3664, 3830,
            4053, 4232, 4465, 4612.397, 19345.588, 20025.233,
        ],
        'Electron affinity': 0.052066,
        symbol: 'Sr',
    },
    {
        'Atomic mass': 88.90585,
        'Atomic no': 39,
        'Atomic orbitals': {
            '1s': -605.631981,
            '2p': -74.803201,
            '2s': -81.789102,
            '3d': -5.671499,
            '3p': -10.399926,
            '3s': -12.992217,
            '4d': -0.108691,
            '4p': -1.02449,
            '4s': -1.697124,
            '5s': -0.150727,
        },
        'Atomic radius': 1.8,
        'Atomic radius calculated': 2.12,
        'Boiling point': '3609 K',
        'Brinell hardness': '589 MN m<sup>-2</sup>',
        'Bulk modulus': '41 GPa',
        'Coefficient of linear thermal expansion': '10.6 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '4472 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 60 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>1</sup>.5s<sup>2</sup>',
        'ICSD oxidation states': [3],
        'Ionic radii': { '3': 1.04 },
        'Liquid range': '1810 K',
        'Melting point': '1799 K',
        'Mendeleev no': 25,
        'Mineral hardness': 'no data',
        'Molar volume': '19.88 cm<sup>3</sup>',
        Name: 'Yttrium',
        'Oxidation states': [1, 2, 3],
        'Poissons ratio': '0.24',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '26 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.04, ionic_radius: 0.9 } },
                VII: { '': { crystal_radius: 1.1, ionic_radius: 0.96 } },
                VIII: { '': { crystal_radius: 1.159, ionic_radius: 1.019 } },
                IX: { '': { crystal_radius: 1.215, ionic_radius: 1.075 } },
            },
        },
        'Superconduction temperature': '1.3 (under pressure)K',
        'Thermal conductivity': '17 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.32,
        'Velocity of sound': '3300 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.22,
        'Youngs modulus': '64 GPa',
        'Metallic radius': 1.8,
        iupac_ordering: 48,
        'IUPAC ordering': 48,
        'Ground level': '2D3/2',
        'Ionization energies': [
            6.21726, 12.2236, 20.52441, 60.6072, 75.35, 91.39, 110.02, 128.12, 145.64, 185.7, 205.814, 374.04, 414, 463,
            512, 559, 624, 677, 733, 790, 847, 1010, 1061.9, 1120.2, 1190, 1253, 1300, 1427.6, 1483.12, 3562.9, 3720,
            3892, 4060, 4299, 4484, 4724, 4875.731, 20415.717, 21115.55,
        ],
        'Electron affinity': 0.30712,
        symbol: 'Y',
    },
    {
        'Atomic mass': 91.224,
        'Atomic no': 40,
        'Atomic orbitals': {
            '1s': -639.292236,
            '2p': -80.010043,
            '2s': -87.237062,
            '3d': -6.544643,
            '3p': -11.514415,
            '3s': -14.230432,
            '4d': -0.150673,
            '4p': -1.186597,
            '4s': -1.918971,
            '5s': -0.162391,
        },
        'Atomic radius': 1.55,
        'Atomic radius calculated': 2.06,
        'Boiling point': '4682 K',
        'Brinell hardness': '650 MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': '5.7 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4],
        'Critical temperature': 'no data K',
        'Density of solid': '6511 kg m<sup>-3</sup>',
        'Electrical resistivity': '43.3 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>2</sup>.5s<sup>2</sup>',
        'ICSD oxidation states': [2, 3, 4],
        'Ionic radii': { '4': 0.86 },
        'Liquid range': '2554 K',
        'Melting point': '2128 K',
        'Mendeleev no': 49,
        'Mineral hardness': '5.0',
        'Molar volume': '14.02 cm<sup>3</sup>',
        Name: 'Zirconium',
        'Oxidation states': [1, 2, 3, 4],
        'Poissons ratio': '0.34',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '33 GPa',
        'Shannon radii': {
            '4': {
                IV: { '': { crystal_radius: 0.73, ionic_radius: 0.59 } },
                V: { '': { crystal_radius: 0.8, ionic_radius: 0.66 } },
                VI: { '': { crystal_radius: 0.86, ionic_radius: 0.72 } },
                VII: { '': { crystal_radius: 0.92, ionic_radius: 0.78 } },
                VIII: { '': { crystal_radius: 0.98, ionic_radius: 0.84 } },
                IX: { '': { crystal_radius: 1.03, ionic_radius: 0.89 } },
            },
        },
        'Superconduction temperature': '0.61 K',
        'Thermal conductivity': '23 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.23,
        'Velocity of sound': '3800 m s<sup>-1</sup>',
        'Vickers hardness': '903 MN m<sup>-2</sup>',
        X: 1.33,
        'Youngs modulus': '68 GPa',
        'Metallic radius': 1.602,
        iupac_ordering: 51,
        'IUPAC ordering': 51,
        'Ground level': '3F2',
        'Ionization energies': [
            6.634126, 13.13, 23.17, 34.41836, 80.348, 96.38, 112, 133.7, 153, 172.02, 214.9, 236.252, 426, 470, 520,
            573, 622, 690, 745, 803, 863, 922, 1092, 1144.7, 1205.4, 1277, 1344, 1392, 1525.1, 1582.37, 3788, 3950,
            4127, 4300, 4553, 4744, 4991, 5146.935, 21516.469, 22236.678,
        ],
        'Electron affinity': 0.433289,
        symbol: 'Zr',
    },
    {
        'Atomic mass': 92.90638,
        'Atomic no': 41,
        'Atomic orbitals': {
            '1s': -673.76253,
            '2p': -85.272175,
            '2s': -92.74086,
            '3d': -7.339839,
            '3p': -12.552855,
            '3s': -15.393727,
            '4d': -0.125252,
            '4p': -1.250049,
            '4s': -2.036693,
            '5s': -0.144272,
        },
        'Atomic radius': 1.45,
        'Atomic radius calculated': 1.98,
        'Boiling point': '5017 K',
        'Brinell hardness': '736 MN m<sup>-2</sup>',
        'Bulk modulus': '170 GPa',
        'Coefficient of linear thermal expansion': '7.3 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [5],
        'Critical temperature': 'no data K',
        'Density of solid': '8570 kg m<sup>-3</sup>',
        'Electrical resistivity': '15.2 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>4</sup>.5s<sup>1</sup>',
        'ICSD oxidation states': [2, 3, 4, 5],
        'Ionic radii': { '3': 0.86, '4': 0.82, '5': 0.78 },
        'Liquid range': '2267 K',
        'Melting point': '2750 K',
        'Mendeleev no': 53,
        'Mineral hardness': '6.0',
        'Molar volume': '10.83 cm<sup>3</sup>',
        Name: 'Niobium',
        'Oxidation states': [-1, 2, 3, 4, 5],
        'Poissons ratio': '0.40',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '38 GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.86, ionic_radius: 0.72 } } },
            '4': {
                VI: { '': { crystal_radius: 0.82, ionic_radius: 0.68 } },
                VIII: { '': { crystal_radius: 0.93, ionic_radius: 0.79 } },
            },
            '5': {
                IV: { '': { crystal_radius: 0.62, ionic_radius: 0.48 } },
                VI: { '': { crystal_radius: 0.78, ionic_radius: 0.64 } },
                VII: { '': { crystal_radius: 0.83, ionic_radius: 0.69 } },
                VIII: { '': { crystal_radius: 0.88, ionic_radius: 0.74 } },
            },
        },
        'Superconduction temperature': '9.25 K',
        'Thermal conductivity': '54 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.18,
        'Velocity of sound': '3480 m s<sup>-1</sup>',
        'Vickers hardness': '1320 MN m<sup>-2</sup>',
        X: 1.6,
        'Youngs modulus': '105 GPa',
        'Metallic radius': 1.473,
        iupac_ordering: 54,
        'IUPAC ordering': 54,
        'Ground level': '6D1/2',
        'Ionization energies': [
            6.75885, 14.32, 25.04, 37.611, 50.5728, 102.069, 119.1, 136, 159.2, 180, 200.28, 246.1, 268.59, 482.5, 530,
            581, 636, 688, 758, 816, 877, 940, 1000, 1176, 1230.6, 1293.7, 1368, 1439, 1488, 1625.9, 1684.97, 4020.1,
            4187, 4369, 4540, 4815, 5011, 5265, 5426.066, 22648.046, 23388.801,
        ],
        'Electron affinity': 0.917407,
        symbol: 'Nb',
    },
    {
        'Atomic mass': 95.94,
        'Atomic no': 42,
        'Atomic orbitals': {
            '1s': -709.232119,
            '2p': -90.791541,
            '2s': -98.503638,
            '3d': -8.257721,
            '3p': -13.71481,
            '3s': -16.681545,
            '4d': -0.153347,
            '4p': -1.39005,
            '4s': -2.234824,
            '5s': -0.14788,
        },
        'Atomic radius': 1.45,
        'Atomic radius calculated': 1.9,
        'Boiling point': '4912 K',
        'Brinell hardness': '1500 MN m<sup>-2</sup>',
        'Bulk modulus': '230 GPa',
        'Coefficient of linear thermal expansion': '4.8 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4, 6],
        'Critical temperature': 'no data K',
        'Density of solid': '10280 kg m<sup>-3</sup>',
        'Electrical resistivity': '5.5 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>5</sup>.5s<sup>1</sup>',
        'ICSD oxidation states': [2, 3, 4, 5, 6],
        'Ionic radii': { '3': 0.83, '4': 0.79, '5': 0.75, '6': 0.73 },
        'Liquid range': '2016 K',
        'Melting point': '2896 K',
        'Mendeleev no': 56,
        'Mineral hardness': '5.5',
        'Molar volume': '9.38 cm<sup>3</sup>',
        Name: 'Molybdenum',
        'Oxidation states': [-2, -1, 1, 2, 3, 4, 5, 6],
        'Poissons ratio': '0.31',
        Reflectivity: '58 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '20 GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.83, ionic_radius: 0.69 } } },
            '4': { VI: { '': { crystal_radius: 0.79, ionic_radius: 0.65 } } },
            '5': {
                IV: { '': { crystal_radius: 0.6, ionic_radius: 0.46 } },
                VI: { '': { crystal_radius: 0.75, ionic_radius: 0.61 } },
            },
            '6': {
                IV: { '': { crystal_radius: 0.55, ionic_radius: 0.41 } },
                V: { '': { crystal_radius: 0.64, ionic_radius: 0.5 } },
                VI: { '': { crystal_radius: 0.73, ionic_radius: 0.59 } },
                VII: { '': { crystal_radius: 0.87, ionic_radius: 0.73 } },
            },
        },
        'Superconduction temperature': '0.915 K',
        'Thermal conductivity': '139 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.17,
        'Velocity of sound': '6190 m s<sup>-1</sup>',
        'Vickers hardness': '1530 MN m<sup>-2</sup>',
        X: 2.16,
        'Youngs modulus': '329 GPa',
        'Metallic radius': 1.402,
        iupac_ordering: 57,
        'IUPAC ordering': 57,
        'Ground level': '7S3',
        'Ionization energies': [
            7.09243, 16.16, 27.13, 40.33, 54.417, 68.82704, 125.638, 143.6, 164.12, 186.3, 209.3, 230.28, 279.1, 302.6,
            544, 591, 646, 702, 758, 829, 890, 953, 1019, 1082, 1263, 1319.6, 1385.1, 1462, 1537, 1587, 1730.1, 1790.93,
            4259, 4430, 4618, 4800, 5084, 5287, 5548, 5713.194, 23810.654, 24572.156,
        ],
        'Electron affinity': 0.74733,
        symbol: 'Mo',
    },
    {
        'Atomic mass': 98,
        'Atomic no': 43,
        'Atomic orbitals': {
            '1s': -745.742024,
            '2p': -96.61021,
            '2s': -104.567508,
            '3d': -9.33986,
            '3p': -15.041738,
            '3s': -18.135303,
            '4d': -0.270262,
            '4p': -1.64323,
            '4s': -2.550712,
            '5s': -0.183636,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.83,
        'Boiling point': '4538 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4, 7],
        'Critical temperature': 'no data K',
        'Density of solid': '11500 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 22 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>5</sup>.5s<sup>2</sup>',
        'Ionic radii': { '4': 0.785, '5': 0.74, '7': 0.7 },
        'Liquid range': '2108 K',
        'Melting point': '2430 K',
        'Mendeleev no': 59,
        'Mineral hardness': 'no data',
        'Molar volume': '8.63 cm<sup>3</sup>',
        Name: 'Technetium',
        'Oxidation states': [-3, -1, 1, 2, 3, 4, 5, 6, 7],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '4': { VI: { '': { crystal_radius: 0.785, ionic_radius: 0.645 } } },
            '5': { VI: { '': { crystal_radius: 0.74, ionic_radius: 0.6 } } },
            '7': {
                IV: { '': { crystal_radius: 0.51, ionic_radius: 0.37 } },
                VI: { '': { crystal_radius: 0.7, ionic_radius: 0.56 } },
            },
        },
        'Superconduction temperature': '7.8 K',
        'Thermal conductivity': '51 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.16,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.9,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.363,
        iupac_ordering: 60,
        'IUPAC ordering': 60,
        'Ground level': '6S5/2',
        'Ionization energies': [
            7.11938, 15.26, 29.55, 41, 57, 72, 88, 150, 169, 189.9, 214, 239, 262.08, 311, 338.55, 604, 655, 713, 773,
            829, 904, 968, 1032, 1102, 1166, 1354, 1411.6, 1479.5, 1559, 1638, 1689, 1838, 1900.28, 4505, 4681, 4874,
            5060, 5361, 5570, 5838, 6008.391, 25004.533, 25786.99,
        ],
        'Electron affinity': 0.552,
        symbol: 'Tc',
    },
    {
        'Atomic mass': 101.07,
        'Atomic no': 44,
        'Atomic orbitals': {
            '1s': -782.918621,
            '2p': -102.333649,
            '2s': -110.536054,
            '3d': -10.195668,
            '3p': -16.145217,
            '3s': -19.366692,
            '4d': -0.210375,
            '4p': -1.667549,
            '4s': -2.628363,
            '5s': -0.152834,
        },
        'Atomic radius': 1.3,
        'Atomic radius calculated': 1.78,
        'Boiling point': '4423 K',
        'Brinell hardness': '2160 MN m<sup>-2</sup>',
        'Bulk modulus': '220 GPa',
        'Coefficient of linear thermal expansion': '6.4 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '12370 kg m<sup>-3</sup>',
        'Electrical resistivity': '7.1 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>7</sup>.5s<sup>1</sup>',
        'ICSD oxidation states': [2, 3, 4, 5, 6],
        'Ionic radii': { '3': 0.82, '4': 0.76, '5': 0.705, '7': 0.52, '8': 0.5 },
        'Liquid range': '1816 K',
        'Melting point': '2607 K',
        'Mendeleev no': 62,
        'Mineral hardness': '6.5',
        'Molar volume': '8.17 cm<sup>3</sup>',
        Name: 'Ruthenium',
        'Oxidation states': [-2, 1, 2, 3, 4, 5, 6, 7, 8],
        'Poissons ratio': '0.30',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '173 GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.82, ionic_radius: 0.68 } } },
            '4': { VI: { '': { crystal_radius: 0.76, ionic_radius: 0.62 } } },
            '5': { VI: { '': { crystal_radius: 0.705, ionic_radius: 0.565 } } },
            '7': { IV: { '': { crystal_radius: 0.52, ionic_radius: 0.38 } } },
            '8': { IV: { '': { crystal_radius: 0.5, ionic_radius: 0.36 } } },
        },
        'Superconduction temperature': '0.49 K',
        'Thermal conductivity': '120 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.13,
        'Velocity of sound': '5970 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.2,
        'Youngs modulus': '447 GPa',
        'Metallic radius': 1.339,
        iupac_ordering: 63,
        'IUPAC ordering': 63,
        'Ground level': '5F5',
        'Ionization energies': [
            7.3605, 16.76, 28.47, 45, 59, 76, 93, 110, 178.41, 198, 219.9, 245, 271, 295.9, 348, 376.25, 670, 723, 784,
            845, 905, 981, 1048, 1115, 1187, 1253, 1447, 1506.7, 1577, 1659, 1743, 1794, 1949, 2013.04, 4758, 4939,
            5136, 5330, 5647, 5861, 6137, 6311.721, 26229.895, 27033.502,
        ],
        'Electron affinity': 1.0463825,
        symbol: 'Ru',
    },
    {
        'Atomic mass': 102.9055,
        'Atomic no': 45,
        'Atomic orbitals': {
            '1s': -821.136773,
            '2p': -108.357665,
            '2s': -116.80695,
            '3d': -11.21725,
            '3p': -17.415299,
            '3s': -20.765603,
            '4d': -0.239422,
            '4p': -1.806456,
            '4s': -2.825505,
            '5s': -0.154624,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.73,
        'Boiling point': '3968 K',
        'Brinell hardness': '1100 MN m<sup>-2</sup>',
        'Bulk modulus': '380 GPa',
        'Coefficient of linear thermal expansion': '8.2 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '12450 kg m<sup>-3</sup>',
        'Electrical resistivity': '4.3 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>8</sup>.5s<sup>1</sup>',
        'ICSD oxidation states': [3, 4],
        'Ionic radii': { '3': 0.805, '4': 0.74, '5': 0.69 },
        'Liquid range': '1731 K',
        'Melting point': '2237 K',
        'Mendeleev no': 65,
        'Mineral hardness': '6.0',
        'Molar volume': '8.28 cm<sup>3</sup>',
        Name: 'Rhodium',
        'Oxidation states': [-1, 1, 2, 3, 4, 5, 6],
        'Poissons ratio': '0.26',
        Reflectivity: '84 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '150 GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.805, ionic_radius: 0.665 } } },
            '4': { VI: { '': { crystal_radius: 0.74, ionic_radius: 0.6 } } },
            '5': { VI: { '': { crystal_radius: 0.69, ionic_radius: 0.55 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '150 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.1,
        'Velocity of sound': '4700 m s<sup>-1</sup>',
        'Vickers hardness': '1246 MN m<sup>-2</sup>',
        X: 2.28,
        'Youngs modulus': '275 GPa',
        'Metallic radius': 1.345,
        iupac_ordering: 66,
        'IUPAC ordering': 66,
        'Ground level': '4F9/2',
        'Ionization energies': [
            7.4589, 18.08, 31.06, 42, 63, 80, 97, 115.1, 135, 207.51, 228, 252.1, 277, 306, 331.58, 389.3, 415.97, 739,
            794, 857, 921, 984, 1061, 1131, 1202, 1274, 1344, 1544, 1604.9, 1677.6, 1763, 1851, 1903, 2063, 2129.22,
            5018, 5203, 5406, 5600, 5940, 6161, 6444, 6623.262, 27486.983, 28311.965,
        ],
        'Electron affinity': 1.142892,
        symbol: 'Rh',
    },
    {
        'Atomic mass': 106.42,
        'Atomic no': 46,
        'Atomic orbitals': {
            '1s': -860.134909,
            '2p': -114.408286,
            '2s': -123.105078,
            '3d': -12.132197,
            '3p': -18.580798,
            '3s': -22.060898,
            '4d': -0.160771,
            '4p': -1.815215,
            '4s': -2.889173,
        },
        'Atomic radius': 1.4,
        'Atomic radius calculated': 1.69,
        'Boiling point': '3236 K',
        'Brinell hardness': '37.3 MN m<sup>-2</sup>',
        'Bulk modulus': '180 GPa',
        'Coefficient of linear thermal expansion': '11.8 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '12023 kg m<sup>-3</sup>',
        'Electrical resistivity': '10.8 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>',
        'ICSD oxidation states': [2, 4],
        'Ionic radii': { '1': 0.73, '2': 1, '3': 0.9, '4': 0.755 },
        'Liquid range': '1407.95 K',
        'Melting point': '1828.05 K',
        'Mendeleev no': 69,
        'Mineral hardness': '4.75',
        'Molar volume': '8.56 cm<sup>3</sup>',
        Name: 'Palladium',
        'Oxidation states': [2, 4],
        'Poissons ratio': '0.39',
        Reflectivity: '72 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '44 GPa',
        'Shannon radii': {
            '1': { II: { '': { crystal_radius: 0.73, ionic_radius: 0.59 } } },
            '2': {
                IVSQ: { '': { crystal_radius: 0.78, ionic_radius: 0.64 } },
                VI: { '': { crystal_radius: 1, ionic_radius: 0.86 } },
            },
            '3': { VI: { '': { crystal_radius: 0.9, ionic_radius: 0.76 } } },
            '4': { VI: { '': { crystal_radius: 0.755, ionic_radius: 0.615 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '72 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.1,
        'Velocity of sound': '3070 m s<sup>-1</sup>',
        'Vickers hardness': '461 MN m<sup>-2</sup>',
        X: 2.2,
        'Youngs modulus': '121 GPa',
        'Metallic radius': 1.376,
        iupac_ordering: 69,
        'IUPAC ordering': 69,
        'Ground level': '1S0',
        'Ionization energies': [
            8.336839, 19.43, 32.93, 46, 61, 84.1, 101, 120, 141, 159.9, 238.57, 260, 286, 311, 342, 369.1, 427, 457.5,
            810, 869, 933, 1000, 1065, 1145, 1218, 1290, 1366, 1438, 1644, 1706.2, 1781.3, 1869, 1962, 2016, 2181,
            2248.87, 5284, 5475, 5683, 5880, 6242, 6469, 6759, 6943.097, 28776.034, 29622.6,
        ],
        'Electron affinity': 0.5621412,
        symbol: 'Pd',
    },
    {
        'Atomic mass': 107.8682,
        'Atomic no': 47,
        'Atomic orbitals': {
            '1s': -900.324578,
            '2p': -120.913351,
            '2s': -129.859807,
            '3d': -13.367803,
            '3p': -20.06763,
            '3s': -23.678437,
            '4d': -0.298706,
            '4p': -2.086602,
            '4s': -3.22309,
            '5s': -0.157407,
        },
        'Atomic radius': 1.6,
        'Atomic radius calculated': 1.65,
        'Boiling point': '2435 K',
        'Brinell hardness': '24.5 MN m<sup>-2</sup>',
        'Bulk modulus': '100 GPa',
        'Coefficient of linear thermal expansion': '18.9 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1],
        'Critical temperature': 'no data K',
        'Density of solid': '10490 kg m<sup>-3</sup>',
        'Electrical resistivity': '1.63 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>.5s<sup>1</sup>',
        'ICSD oxidation states': [1, 2, 3],
        'Ionic radii': { '1': 1.29, '2': 1.08, '3': 0.89 },
        'Liquid range': '1200.07 K',
        'Melting point': '1234.93 K',
        'Mendeleev no': 71,
        'Mineral hardness': '2.5',
        'Molar volume': '10.27 cm<sup>3</sup>',
        Name: 'Silver',
        'Oxidation states': [1, 2, 3],
        'Poissons ratio': '0.37',
        Reflectivity: '97 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '30 GPa',
        'Shannon radii': {
            '1': {
                II: { '': { crystal_radius: 0.81, ionic_radius: 0.67 } },
                IV: { '': { crystal_radius: 1.14, ionic_radius: 1 } },
                IVSQ: { '': { crystal_radius: 1.16, ionic_radius: 1.02 } },
                V: { '': { crystal_radius: 1.23, ionic_radius: 1.09 } },
                VI: { '': { crystal_radius: 1.29, ionic_radius: 1.15 } },
                VII: { '': { crystal_radius: 1.36, ionic_radius: 1.22 } },
                VIII: { '': { crystal_radius: 1.42, ionic_radius: 1.28 } },
            },
            '2': {
                IVSQ: { '': { crystal_radius: 0.93, ionic_radius: 0.79 } },
                VI: { '': { crystal_radius: 1.08, ionic_radius: 0.94 } },
            },
            '3': {
                IVSQ: { '': { crystal_radius: 0.81, ionic_radius: 0.67 } },
                VI: { '': { crystal_radius: 0.89, ionic_radius: 0.75 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '430 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.11,
        'Velocity of sound': '2600 m s<sup>-1</sup>',
        'Vickers hardness': '251 MN m<sup>-2</sup>',
        X: 1.93,
        'Youngs modulus': '83 GPa',
        'Metallic radius': 1.445,
        iupac_ordering: 72,
        'IUPAC ordering': 72,
        'Ground level': '2S1/2',
        'Ionization energies': [
            7.576234, 21.4844, 34.8, 49, 65, 82, 106, 125, 145.1, 167, 188, 271.46, 294, 321, 347, 381, 408.43, 469,
            500.87, 885, 946, 1013, 1082, 1149, 1231, 1308, 1382, 1460, 1535, 1747, 1810.5, 1888, 1979, 2077, 2131,
            2302, 2371.99, 5558, 5753, 5966, 6170, 6551, 6785, 7082, 7271.298, 30097.318, 30965.698,
        ],
        'Electron affinity': 1.304473,
        symbol: 'Ag',
    },
    {
        'Atomic mass': 112.411,
        'Atomic no': 48,
        'Atomic orbitals': {
            '1s': -941.476646,
            '2p': -127.63512,
            '2s': -136.83249,
            '3d': -14.685252,
            '3p': -21.637522,
            '3s': -25.379908,
            '4d': -0.47053,
            '4p': -2.39526,
            '4s': -3.596069,
            '5s': -0.204228,
        },
        'Atomic radius': 1.55,
        'Atomic radius calculated': 1.61,
        'Boiling point': '1040 K',
        'Brinell hardness': '203 MN m<sup>-2</sup>',
        'Bulk modulus': '42 GPa',
        'Coefficient of linear thermal expansion': '30.8 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '8650 kg m<sup>-3</sup>',
        'Electrical resistivity': '7 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>.5s<sup>2</sup>',
        'ICSD oxidation states': [2],
        'Ionic radii': { '2': 1.09 },
        'Liquid range': '445.78 K',
        'Melting point': '594.22 K',
        'Mendeleev no': 75,
        'Mineral hardness': '2.0',
        'Molar volume': '13.00 cm<sup>3</sup>',
        Name: 'Cadmium',
        'Oxidation states': [1, 2],
        'Poissons ratio': '0.30',
        Reflectivity: '67 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '19 GPa',
        'Shannon radii': {
            '2': {
                IV: { '': { crystal_radius: 0.92, ionic_radius: 0.78 } },
                V: { '': { crystal_radius: 1.01, ionic_radius: 0.87 } },
                VI: { '': { crystal_radius: 1.09, ionic_radius: 0.95 } },
                VII: { '': { crystal_radius: 1.17, ionic_radius: 1.03 } },
                VIII: { '': { crystal_radius: 1.24, ionic_radius: 1.1 } },
                XII: { '': { crystal_radius: 1.45, ionic_radius: 1.31 } },
            },
        },
        'Superconduction temperature': '0.517 K',
        'Thermal conductivity': '97 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.18,
        'Velocity of sound': '2310 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.69,
        'Youngs modulus': '50 GPa',
        'Metallic radius': 1.51,
        iupac_ordering: 75,
        'IUPAC ordering': 75,
        'Ground level': '1S0',
        'Ionization energies': [
            8.99382, 16.908313, 37.468, 51, 67.9, 87, 105, 130.1, 150, 173, 195, 218, 305, 329, 358, 385, 421, 452.6,
            513, 546.19, 963, 1026, 1095, 1167, 1237, 1320, 1401, 1477, 1558, 1635, 1852, 1917.9, 1998, 2091, 2195,
            2250, 2427, 2498.62, 5839, 6039, 6257, 6460, 6869, 7109, 7414, 7607.95, 31451.062, 32341.49,
        ],
        'Electron affinity': -0.72,
        symbol: 'Cd',
    },
    {
        'Atomic mass': 114.818,
        'Atomic no': 49,
        'Atomic orbitals': {
            '1s': -983.647445,
            '2p': -134.628845,
            '2s': -144.078357,
            '3d': -16.139823,
            '3p': -23.345778,
            '3s': -27.2206,
            '4d': -0.730481,
            '4p': -2.795832,
            '4s': -4.062639,
            '5p': -0.101782,
            '5s': -0.290497,
        },
        'Atomic radius': 1.55,
        'Atomic radius calculated': 1.56,
        'Boiling point': '2345 K',
        'Brinell hardness': '8.83 MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': '32.1 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '7310 kg m<sup>-3</sup>',
        'Electrical resistivity': '8 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>.5s<sup>2</sup>.5p<sup>1</sup>',
        'ICSD oxidation states': [1, 2, 3],
        'Ionic radii': { '3': 0.94 },
        'Liquid range': '1915.25 K',
        'Melting point': '429.75 K',
        'Mendeleev no': 79,
        'Mineral hardness': '1.2',
        'Molar volume': '15.76 cm<sup>3</sup>',
        Name: 'Indium',
        'Oxidation states': [1, 2, 3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': {
                IV: { '': { crystal_radius: 0.76, ionic_radius: 0.62 } },
                VI: { '': { crystal_radius: 0.94, ionic_radius: 0.8 } },
                VIII: { '': { crystal_radius: 1.06, ionic_radius: 0.92 } },
            },
        },
        'Superconduction temperature': '3.41 K',
        'Thermal conductivity': '82 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.93,
        'Velocity of sound': '1215 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.78,
        'Youngs modulus': '11 GPa',
        'NMR Quadrupole Moment': { 'In-113': 759.8, 'In-115': 770.8 },
        'Metallic radius': 1.67,
        iupac_ordering: 78,
        'IUPAC ordering': 78,
        'Ground level': '2P°1/2',
        'Ionization energies': [
            5.7863557, 18.87041, 28.04415, 55.45, 69.3, 90, 109, 130.1, 156, 178, 201, 226, 249, 341, 368, 396, 425,
            462, 497.1, 560, 593.38, 1043, 1109, 1181, 1255, 1328, 1413, 1496, 1575, 1659, 1738, 1961, 2028.5, 2111,
            2207, 2317, 2373, 2555, 2628.77, 6126, 6331, 6554, 6770, 7196, 7442, 7754, 7953.14, 32837.592, 33750.31,
        ],
        'Electron affinity': 0.383926,
        symbol: 'In',
    },
    {
        'Atomic mass': 118.71,
        'Atomic no': 50,
        'Atomic orbitals': {
            '1s': -1026.762169,
            '2p': -141.821093,
            '2s': -151.523991,
            '3d': -17.657276,
            '3p': -25.117913,
            '3s': -29.125969,
            '4d': -1.004952,
            '4p': -3.211998,
            '4s': -4.546335,
            '5p': -0.14445,
            '5s': -0.369349,
        },
        'Atomic radius': 1.45,
        'Atomic radius calculated': 1.45,
        'Boiling point': '2875 K',
        'Brinell hardness': '51 MN m<sup>-2</sup>',
        'Bulk modulus': '58 GPa',
        'Coefficient of linear thermal expansion': '22 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-4, 2, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '7310 kg m<sup>-3</sup>',
        'Electrical resistivity': '11.5 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>.5s<sup>2</sup>.5p<sup>2</sup>',
        'ICSD oxidation states': [2, 3, 4],
        'Ionic radii': { '4': 0.83 },
        'Liquid range': '2369.92 K',
        'Melting point': '505.08 K',
        'Mendeleev no': 83,
        'Mineral hardness': '1.5',
        'Molar volume': '16.29 cm<sup>3</sup>',
        Name: 'Tin',
        'Oxidation states': [-4, 2, 4],
        'Poissons ratio': '0.36',
        Reflectivity: '54 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '18 GPa',
        'Shannon radii': {
            '4': {
                IV: { '': { crystal_radius: 0.69, ionic_radius: 0.55 } },
                V: { '': { crystal_radius: 0.76, ionic_radius: 0.62 } },
                VI: { '': { crystal_radius: 0.83, ionic_radius: 0.69 } },
                VII: { '': { crystal_radius: 0.89, ionic_radius: 0.75 } },
                VIII: { '': { crystal_radius: 0.95, ionic_radius: 0.81 } },
            },
        },
        'Superconduction temperature': '3.72 K',
        'Thermal conductivity': '67 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.17,
        'Velocity of sound': '2500 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.96,
        'Youngs modulus': '50 GPa',
        'NMR Quadrupole Moment': { 'Sn-119': -132.1 },
        'Metallic radius': 1.58,
        iupac_ordering: 83,
        'IUPAC ordering': 83,
        'Ground level': '3P0',
        'Ionization energies': [
            7.343918, 14.63307, 30.506, 40.74, 77.03, 94, 112.9, 135, 156, 184, 208, 232, 258, 282, 379, 407, 437, 466,
            506, 537, 608, 642.35, 1127, 1195, 1269, 1347, 1421, 1508, 1596, 1676, 1763, 1844, 2074, 2142.1, 2227, 2326,
            2443, 2499, 2687, 2762.49, 6421, 6631, 6859, 7080, 7531, 7790, 8103, 8306.95, 34257.143, 35192.39,
        ],
        'Electron affinity': 1.1120702,
        symbol: 'Sn',
    },
    {
        'Atomic mass': 121.76,
        'Atomic no': 51,
        'Atomic orbitals': {
            '1s': -1070.823495,
            '2p': -149.214271,
            '2s': -159.171745,
            '3d': -19.239895,
            '3p': -26.956184,
            '3s': -31.098242,
            '4d': -1.297338,
            '4p': -3.646579,
            '4s': -5.04964,
            '5p': -0.185623,
            '5s': -0.445605,
        },
        'Atomic radius': 1.45,
        'Atomic radius calculated': 1.33,
        'Boiling point': '1860 K',
        'Brinell hardness': '294 MN m<sup>-2</sup>',
        'Bulk modulus': '42 GPa',
        'Coefficient of linear thermal expansion': '11 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-3, 3, 5],
        'Critical temperature': 'no data K',
        'Density of solid': '6697 kg m<sup>-3</sup>',
        'Electrical resistivity': '40 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>.5s<sup>2</sup>.5p<sup>3</sup>',
        'ICSD oxidation states': [-2, 3, 5, -1, -3],
        'Ionic radii': { '3': 0.9, '5': 0.76 },
        'Liquid range': '956.22 K',
        'Melting point': '903.78 K',
        'Mendeleev no': 88,
        'Mineral hardness': '3.0',
        'Molar volume': '18.19 cm<sup>3</sup>',
        Name: 'Antimony',
        'Oxidation states': [-3, 3, 5],
        'Poissons ratio': 'no data',
        Reflectivity: '55 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '20 GPa',
        'Shannon radii': {
            '3': {
                IVPY: { '': { crystal_radius: 0.9, ionic_radius: 0.76 } },
                V: { '': { crystal_radius: 0.94, ionic_radius: 0.8 } },
                VI: { '': { crystal_radius: 0.9, ionic_radius: 0.76 } },
            },
            '5': { VI: { '': { crystal_radius: 0.74, ionic_radius: 0.6 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '24 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.06,
        'Velocity of sound': '3420 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.05,
        'Youngs modulus': '55 GPa',
        'NMR Quadrupole Moment': { 'Sb-121': -543.11, 'Sb-123': -692.14 },
        'Metallic radius': 1.61,
        iupac_ordering: 88,
        'IUPAC ordering': 88,
        'Ground level': '4S°3/2',
        'Ionization energies': [
            8.608389, 16.626, 25.3235, 43.804, 55, 99.51, 117, 139, 162, 185, 214, 238, 265, 292, 317, 420, 447, 479,
            510, 552, 584, 657, 693.26, 1214, 1285, 1360, 1441, 1518, 1606, 1698, 1781, 1869, 1954, 2190, 2266, 2349,
            2428, 2567, 2654, 2815, 2900, 6714, 6929, 7167, 7390, 7887, 8140, 8455, 8669.48, 35710.028, 36668.05,
        ],
        'Electron affinity': 1.04740119,
        symbol: 'Sb',
    },
    {
        'Atomic mass': 127.6,
        'Atomic no': 52,
        'Atomic orbitals': {
            '1s': -1115.831819,
            '2p': -156.808583,
            '2s': -167.021776,
            '3d': -20.887801,
            '3p': -28.860685,
            '3s': -33.137485,
            '4d': -1.608381,
            '4p': -4.100084,
            '4s': -5.572846,
            '5p': -0.226594,
            '5s': -0.520997,
        },
        'Atomic radius': 1.4,
        'Atomic radius calculated': 1.23,
        'Boiling point': '1261 K',
        'Brinell hardness': '180 MN m<sup>-2</sup>',
        'Bulk modulus': '65 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-2, 2, 4, 6],
        'Critical temperature': 'no data K',
        'Density of solid': '6240 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 10000 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>.5s<sup>2</sup>.5p<sup>4</sup>',
        'ICSD oxidation states': [-2, 4, -1, 6],
        'Ionic radii': { '4': 1.11, '6': 0.7, '-2': 2.07 },
        'Liquid range': '538.34 K',
        'Melting point': '722.66 K',
        'Mendeleev no': 92,
        'Mineral hardness': '2.25',
        'Molar volume': '20.46 cm<sup>3</sup>',
        Name: 'Tellurium',
        'Oxidation states': [-2, 2, 4, 5, 6],
        'Poissons ratio': 'no data',
        Reflectivity: '50 %',
        'Refractive index': '1.000991',
        'Rigidity modulus': '16 GPa',
        'Shannon radii': {
            '4': {
                III: { '': { crystal_radius: 0.66, ionic_radius: 0.52 } },
                IV: { '': { crystal_radius: 0.8, ionic_radius: 0.66 } },
                VI: { '': { crystal_radius: 1.11, ionic_radius: 0.97 } },
            },
            '6': {
                IV: { '': { crystal_radius: 0.57, ionic_radius: 0.43 } },
                VI: { '': { crystal_radius: 0.7, ionic_radius: 0.56 } },
            },
            '-2': { VI: { '': { crystal_radius: 2.07, ionic_radius: 2.21 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '3 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.06,
        'Velocity of sound': '2610 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.1,
        'Youngs modulus': '43 GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 94,
        'IUPAC ordering': 94,
        'Ground level': '3P2',
        'Ionization energies': [
            9.009808, 18.6, 27.84, 37.4155, 59.3, 69.1, 124.2, 143, 167, 191.1, 215, 245, 272, 299, 328, 354, 461, 491,
            522, 555, 599, 633, 709, 746.12, 1304, 1377, 1455, 1538, 1618, 1707, 1803, 1889, 1979, 2066, 2309, 2386,
            2472, 2552, 2700, 2788, 2954, 3041, 7022, 7243, 7485, 7714, 8240, 8499, 8821, 9040.83, 37196.522, 38177.56,
        ],
        'Electron affinity': 1.9708757,
        symbol: 'Te',
    },
    {
        'Atomic mass': 126.90447,
        'Atomic no': 53,
        'Atomic orbitals': {
            '1s': -1161.787047,
            '2p': -164.603788,
            '2s': -175.073804,
            '3d': -22.600693,
            '3p': -30.831092,
            '3s': -35.243351,
            '4d': -1.938179,
            '4p': -4.572522,
            '4s': -6.115811,
            '5p': -0.267904,
            '5s': -0.596339,
        },
        'Atomic radius': 1.4,
        'Atomic radius calculated': 1.15,
        'Boiling point': '457.4 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '7.7 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-1, 1, 3, 5, 7],
        'Critical temperature': '819 K',
        'Density of solid': '4940 kg m<sup>-3</sup>',
        'Electrical resistivity': '&gt; 10<sup>15</sup>10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>.5s<sup>2</sup>.5p<sup>5</sup>',
        'ICSD oxidation states': [5, -1],
        'Ionic radii': { '5': 1.09, '7': 0.67, '-1': 2.06 },
        'Liquid range': '70.55 K',
        'Melting point': '386.85 K',
        'Mendeleev no': 97,
        'Mineral hardness': 'no data',
        'Molar volume': '25.72 cm<sup>3</sup>',
        Name: 'Iodine',
        'Oxidation states': [-1, 1, 3, 5, 7],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '5': {
                IIIPY: { '': { crystal_radius: 0.58, ionic_radius: 0.44 } },
                VI: { '': { crystal_radius: 1.09, ionic_radius: 0.95 } },
            },
            '7': {
                IV: { '': { crystal_radius: 0.56, ionic_radius: 0.42 } },
                VI: { '': { crystal_radius: 0.67, ionic_radius: 0.53 } },
            },
            '-1': { VI: { '': { crystal_radius: 2.06, ionic_radius: 2.2 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.449 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.98,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.66,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'I-127': -696.12, 'I-129': -604.1 },
        'Metallic radius': 'no data',
        iupac_ordering: 99,
        'IUPAC ordering': 99,
        'Ground level': '2P°3/2',
        'Ionization energies': [
            10.45126, 19.13126, 29.57, 40.357, 51.52, 74.4, 87.61, 150.81, 171, 197, 220.9, 247, 279, 307, 335, 365,
            393, 505, 535, 569, 601, 649, 683, 762, 800.8, 1397, 1472, 1553, 1639, 1720, 1812, 1911, 1999, 2093, 2181,
            2431, 2510, 2598, 2680, 2836, 2926, 3096, 3185.5, 7337, 7563, 7811, 8044, 8601, 8867, 9196, 9421.1,
            38716.996, 39721.41,
        ],
        'Electron affinity': 3.05905238,
        symbol: 'I',
    },
    {
        'Atomic mass': 131.293,
        'Atomic no': 54,
        'Atomic orbitals': {
            '1s': -1208.688993,
            '2p': -172.599583,
            '2s': -183.327495,
            '3d': -24.37823,
            '3p': -32.867042,
            '3s': -37.415454,
            '4d': -2.286666,
            '4p': -5.063802,
            '4s': -6.67834,
            '5p': -0.309835,
            '5s': -0.672086,
        },
        'Atomic radius': 'no data',
        'Atomic radius calculated': 1.08,
        'Boiling point': '165.1 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Critical temperature': '289.7 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Kr].4d<sup>10</sup>.5s<sup>2</sup>.5p<sup>6</sup>',
        'Ionic radii': { '8': 0.62 },
        'Liquid range': '3.7 K',
        'Max oxidation state': 8,
        'Melting point': '161.4 K',
        'Mendeleev no': 5,
        'Min oxidation state': 2,
        'Mineral hardness': 'no data',
        'Molar volume': '35.92 cm<sup>3</sup>',
        Name: 'Xenon',
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': '1.000702',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '8': {
                IV: { '': { crystal_radius: 0.54, ionic_radius: 0.4 } },
                VI: { '': { crystal_radius: 0.62, ionic_radius: 0.48 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.00565 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.16,
        'Velocity of sound': '1090 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.6,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 1,
        'IUPAC ordering': 1,
        'Ground level': '1S0',
        'Ionization energies': [
            12.1298437, 20.975, 31.05, 42.2, 54.1, 66.703, 91.6, 105.9778, 179.84, 202, 229.02, 255, 281, 314, 343, 374,
            404, 434, 549, 582, 616, 650, 700, 736, 818, 857, 1493, 1571, 1653, 1742, 1826, 1919, 2023, 2113, 2209,
            2300, 2556, 2637, 2726, 2811, 2975, 3068, 3243, 3333.8, 7660, 7889, 8144, 8382, 8971, 9243, 9581, 9810.37,
            40271.724, 41299.71,
        ],
        'Electron affinity': -0.82,
        symbol: 'Xe',
    },
    {
        'Atomic mass': 132.9054519,
        'Atomic no': 55,
        'Atomic orbitals': {
            '1s': -1256.738791,
            '2p': -180.995344,
            '2s': -191.981873,
            '3d': -26.418398,
            '3p': -35.166423,
            '3s': -39.851584,
            '4d': -2.848386,
            '4p': -5.769326,
            '4s': -7.455966,
            '5p': -0.504903,
            '5s': -0.915819,
            '6s': -0.078699,
        },
        'Atomic radius': 2.6,
        'Atomic radius calculated': 2.98,
        'Boiling point': '944 K',
        'Brinell hardness': '0.14 MN m<sup>-2</sup>',
        'Bulk modulus': '1.6 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1],
        'Critical temperature': '1938 K',
        'Density of solid': '1879 kg m<sup>-3</sup>',
        'Electrical resistivity': '21 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].6s<sup>1</sup>',
        'ICSD oxidation states': [1],
        'Ionic radii': { '1': 1.81 },
        'Liquid range': '642.41 K',
        'Melting point': '301.59 K',
        'Mendeleev no': 8,
        'Mineral hardness': '0.2',
        'Molar volume': '70.94 cm<sup>3</sup>',
        Name: 'Cesium',
        'Oxidation states': [1],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '1': {
                VI: { '': { crystal_radius: 1.81, ionic_radius: 1.67 } },
                VIII: { '': { crystal_radius: 1.88, ionic_radius: 1.74 } },
                IX: { '': { crystal_radius: 1.92, ionic_radius: 1.78 } },
                X: { '': { crystal_radius: 1.95, ionic_radius: 1.81 } },
                XI: { '': { crystal_radius: 1.99, ionic_radius: 1.85 } },
                XII: { '': { crystal_radius: 2.02, ionic_radius: 1.88 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '36 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 3.43,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.79,
        'Youngs modulus': '1.7 GPa',
        'Metallic radius': 2.719,
        iupac_ordering: 7,
        'IUPAC ordering': 7,
        'Ground level': '2S1/2',
        'Ionization energies': [
            3.89390572743, 23.15745, 33.195, 43, 56, 69.1, 82.9, 110.1, 125.61, 213.3, 233, 261, 289, 316, 352, 382,
            413, 445, 476, 597, 629, 666, 700, 753, 791, 875, 916.1, 1592, 1672, 1757, 1848, 1936, 2029, 2137, 2230,
            2329, 2422, 2683, 2767, 2859, 2945, 3118, 3214, 3392, 3485, 7989, 8224, 8484, 8726, 9350, 9629, 9974,
            10208.78, 41861.075, 42912.99,
        ],
        'Electron affinity': 0.47163025,
        symbol: 'Cs',
    },
    {
        'Atomic mass': 137.327,
        'Atomic no': 56,
        'Atomic orbitals': {
            '1s': -1305.743258,
            '2p': -189.598483,
            '2s': -200.844444,
            '3d': -28.528933,
            '3p': -37.536931,
            '3s': -42.359434,
            '4d': -3.432441,
            '4p': -6.497622,
            '4s': -8.257061,
            '5p': -0.698605,
            '5s': -1.157159,
            '6s': -0.118967,
        },
        'Atomic radius': 2.15,
        'Atomic radius calculated': 2.53,
        'Boiling point': '2143 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '9.6 GPa',
        'Coefficient of linear thermal expansion': '20.6 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '3510 kg m<sup>-3</sup>',
        'Electrical resistivity': '34 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].6s<sup>2</sup>',
        'ICSD oxidation states': [2],
        'Ionic radii': { '2': 1.49 },
        'Liquid range': '1143 K',
        'Melting point': '1000 K',
        'Mendeleev no': 14,
        'Mineral hardness': '1.25',
        'Molar volume': '38.16 cm<sup>3</sup>',
        Name: 'Barium',
        'Oxidation states': [2],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '4.9 GPa',
        'Shannon radii': {
            '2': {
                VI: { '': { crystal_radius: 1.49, ionic_radius: 1.35 } },
                VII: { '': { crystal_radius: 1.52, ionic_radius: 1.38 } },
                VIII: { '': { crystal_radius: 1.56, ionic_radius: 1.42 } },
                IX: { '': { crystal_radius: 1.61, ionic_radius: 1.47 } },
                X: { '': { crystal_radius: 1.66, ionic_radius: 1.52 } },
                XI: { '': { crystal_radius: 1.71, ionic_radius: 1.57 } },
                XII: { '': { crystal_radius: 1.75, ionic_radius: 1.61 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '18 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.68,
        'Velocity of sound': '1620 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.89,
        'Youngs modulus': '13 GPa',
        'Metallic radius': 2.236,
        iupac_ordering: 13,
        'IUPAC ordering': 13,
        'Ground level': '1S0',
        'Ionization energies': [
            5.2116646, 10.003826, 35.8438, 47, 58, 71, 86, 101, 130.5, 146.52, 241, 267.1, 296, 325, 354, 390, 422, 455,
            488, 520, 646, 679, 717, 752, 809, 846, 935, 976.62, 1695, 1776, 1864, 1958, 2047, 2142, 2256, 2349, 2452,
            2547, 2814, 2901, 2994, 3081, 3266, 3363, 3546, 3640, 8326, 8565, 8831, 9077, 9739, 10023, 10376, 10616.42,
            43485.366, 44561.47,
        ],
        'Electron affinity': 0.144626,
        symbol: 'Ba',
    },
    {
        'Atomic mass': 138.90547,
        'Atomic no': 57,
        'Atomic orbitals': {
            '1s': -1355.622446,
            '2p': -198.325243,
            '2s': -209.831151,
            '3d': -30.626696,
            '3p': -39.895838,
            '3s': -44.856283,
            '4d': -3.95801,
            '4p': -7.167724,
            '4s': -9.000543,
            '5d': -0.141085,
            '5p': -0.824498,
            '5s': -1.324936,
            '6s': -0.132233,
        },
        'Atomic radius': 1.95,
        'Atomic radius calculated': 'no data',
        'Boiling point': '3743 K',
        'Brinell hardness': '363 MN m<sup>-2</sup>',
        'Bulk modulus': '28 GPa',
        'Coefficient of linear thermal expansion': '12.1 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '6146 kg m<sup>-3</sup>',
        'Electrical resistivity': '61.5 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].5d<sup>1</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [2, 3],
        'Ionic radii': { '3': 1.172 },
        'Liquid range': '2550 K',
        'Melting point': '1193 K',
        'Mendeleev no': 33,
        'Mineral hardness': '2.5',
        'Molar volume': '22.39 cm<sup>3</sup>',
        Name: 'Lanthanum',
        'Oxidation states': [2, 3],
        'Poissons ratio': '0.28',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '14 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.172, ionic_radius: 1.032 } },
                VII: { '': { crystal_radius: 1.24, ionic_radius: 1.1 } },
                VIII: { '': { crystal_radius: 1.3, ionic_radius: 1.16 } },
                IX: { '': { crystal_radius: 1.356, ionic_radius: 1.216 } },
                X: { '': { crystal_radius: 1.41, ionic_radius: 1.27 } },
                XII: { '': { crystal_radius: 1.5, ionic_radius: 1.36 } },
            },
        },
        'Superconduction temperature': '6.00 K',
        'Thermal conductivity': '13 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.43,
        'Velocity of sound': '2475 m s<sup>-1</sup>',
        'Vickers hardness': '491 MN m<sup>-2</sup>',
        X: 1.1,
        'Youngs modulus': '37 GPa',
        'NMR Quadrupole Moment': { 'La-139': 200.6 },
        'Metallic radius': 1.877,
        iupac_ordering: 47,
        'IUPAC ordering': 47,
        'Ground level': '2D3/2',
        'Ionization energies': [
            5.5769, 11.18496, 19.1773, 49.95, 61.6, 74, 88, 105, 119, 151.4, 168.77, 275, 303, 332, 364, 393, 431, 464,
            498, 533, 566, 696, 731, 770, 806, 865, 906, 995, 1039.09, 1800, 1884, 1974, 2069, 2162, 2259, 2377, 2473,
            2577, 2674, 2950, 3036, 3133, 3222, 3416, 3515, 3704, 3800, 8669, 8914, 9184, 9437, 10136, 10426, 10789,
            11033.4, 45144.996, 46245.6,
        ],
        'Electron affinity': 0.5575462,
        symbol: 'La',
    },
    {
        'Atomic mass': 140.116,
        'Atomic no': 58,
        'Atomic orbitals': {
            '1s': -1406.148284,
            '2p': -206.925148,
            '2s': -218.684842,
            '3d': -32.412569,
            '3p': -41.938282,
            '3s': -47.035283,
            '4d': -4.192548,
            '4f': -0.337442,
            '4p': -7.532106,
            '4s': -9.432744,
            '5d': -0.14055,
            '5p': -0.85011,
            '5s': -1.369728,
            '6s': -0.133974,
        },
        'Atomic radius': 1.85,
        'Atomic radius calculated': 'no data',
        'Boiling point': '3633 K',
        'Brinell hardness': '412 MN m<sup>-2</sup>',
        'Bulk modulus': '22 GPa',
        'Coefficient of linear thermal expansion': '6.3 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '6689 kg m<sup>-3</sup>',
        'Electrical resistivity': '74 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>1</sup>.5d<sup>1</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3, 4],
        'Ionic radii': { '3': 1.15, '4': 1.01 },
        'Liquid range': '2565 K',
        'Melting point': '1068 K',
        'Mendeleev no': 32,
        'Mineral hardness': '2.5',
        'Molar volume': '20.69 cm<sup>3</sup>',
        Name: 'Cerium',
        'Oxidation states': [2, 3, 4],
        'Poissons ratio': '0.24',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '14 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.15, ionic_radius: 1.01 } },
                VII: { '': { crystal_radius: 1.21, ionic_radius: 1.07 } },
                VIII: { '': { crystal_radius: 1.283, ionic_radius: 1.143 } },
                IX: { '': { crystal_radius: 1.336, ionic_radius: 1.196 } },
                X: { '': { crystal_radius: 1.39, ionic_radius: 1.25 } },
                XII: { '': { crystal_radius: 1.48, ionic_radius: 1.34 } },
            },
            '4': {
                VI: { '': { crystal_radius: 1.01, ionic_radius: 0.87 } },
                VIII: { '': { crystal_radius: 1.11, ionic_radius: 0.97 } },
                X: { '': { crystal_radius: 1.21, ionic_radius: 1.07 } },
                XII: { '': { crystal_radius: 1.28, ionic_radius: 1.14 } },
            },
        },
        'Superconduction temperature': '0.022 (under pressure)K',
        'Thermal conductivity': '11 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.42,
        'Velocity of sound': '2100 m s<sup>-1</sup>',
        'Vickers hardness': '270 MN m<sup>-2</sup>',
        X: 1.12,
        'Youngs modulus': '34 GPa',
        'Metallic radius': 1.707,
        iupac_ordering: 46,
        'IUPAC ordering': 46,
        'Ground level': '1G°4',
        'Ionization energies': [
            5.5386, 10.956, 20.1974, 36.906, 65.55, 77.6, 91, 106, 125, 140, 172, 192.24, 312, 340, 371, 403, 435, 472,
            509, 543, 579, 613, 749, 785, 824, 862, 924, 965, 1060, 1103.5, 1908, 1994, 2087, 2185, 2280, 2378, 2500,
            2600, 2706, 2806, 3087, 3176, 3274, 3366, 3570, 3672, 3865, 3963, 9020, 9269, 9545, 9803, 10542, 10840,
            11210, 11459.85, 46840.306, 47965.72,
        ],
        'Electron affinity': 0.572,
        symbol: 'Ce',
    },
    {
        'Atomic mass': 140.90765,
        'Atomic no': 59,
        'Atomic orbitals': {
            '1s': -1457.338067,
            '2p': -215.418313,
            '2s': -227.426363,
            '3d': -33.913996,
            '3p': -43.692548,
            '3s': -48.924994,
            '4d': -4.154228,
            '4f': -0.155138,
            '4p': -7.613108,
            '4s': -9.577447,
            '5p': -0.778046,
            '5s': -1.296106,
            '6s': -0.124465,
        },
        'Atomic radius': 1.85,
        'Atomic radius calculated': 2.47,
        'Boiling point': '3563 K',
        'Brinell hardness': '481 MN m<sup>-2</sup>',
        'Bulk modulus': '29 GPa',
        'Coefficient of linear thermal expansion': '6.7 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '6640 kg m<sup>-3</sup>',
        'Electrical resistivity': '70 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>3</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3, 4],
        'Ionic radii': { '3': 1.13, '4': 0.99 },
        'Liquid range': '2355 K',
        'Melting point': '1208 K',
        'Mendeleev no': 31,
        'Mineral hardness': 'no data',
        'Molar volume': '20.80 cm<sup>3</sup>',
        Name: 'Praseodymium',
        'Oxidation states': [2, 3, 4],
        'Poissons ratio': '0.28',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '15 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.13, ionic_radius: 0.99 } },
                VIII: { '': { crystal_radius: 1.266, ionic_radius: 1.126 } },
                IX: { '': { crystal_radius: 1.319, ionic_radius: 1.179 } },
            },
            '4': {
                VI: { '': { crystal_radius: 0.99, ionic_radius: 0.85 } },
                VIII: { '': { crystal_radius: 1.1, ionic_radius: 0.96 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '13 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.4,
        'Velocity of sound': '2280 m s<sup>-1</sup>',
        'Vickers hardness': '400 MN m<sup>-2</sup>',
        X: 1.13,
        'Youngs modulus': '37 GPa',
        'Metallic radius': 1.828,
        iupac_ordering: 45,
        'IUPAC ordering': 45,
        'Ground level': '4I°9/2',
        'Ionization energies': [
            5.4702, 10.631, 21.6237, 38.981, 57.53, 82, 97, 112, 131, 148, 162, 196, 217.02, 350, 378, 412, 445, 478,
            516, 554, 590, 627, 663, 803, 840, 880, 920, 985, 1028, 1124, 1169.9, 2019, 2108, 2202, 2304, 2400, 2501,
            2628, 2729, 2838, 2941, 3227, 3319, 3419, 3512, 3729, 3832, 4030, 4130, 9378, 9632, 9913, 10175, 10959,
            11262, 11641, 11895.89, 48571.71, 49722.25,
        ],
        'Electron affinity': 0.1092346,
        symbol: 'Pr',
    },
    {
        'Atomic mass': 144.242,
        'Atomic no': 60,
        'Atomic orbitals': {
            '1s': -1509.698955,
            '2p': -224.351816,
            '2s': -236.613572,
            '3d': -35.754515,
            '3p': -45.791219,
            '3s': -51.161263,
            '4d': -4.377027,
            '4f': -0.179508,
            '4p': -7.96782,
            '4s': -10.000891,
            '5p': -0.798503,
            '5s': -1.334934,
            '6s': -0.125796,
        },
        'Atomic radius': 1.85,
        'Atomic radius calculated': 2.06,
        'Boiling point': '3373 K',
        'Brinell hardness': '265 MN m<sup>-2</sup>',
        'Bulk modulus': '32 GPa',
        'Coefficient of linear thermal expansion': '9.6 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '6800 kg m<sup>-3</sup>',
        'Electrical resistivity': '64.3 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>4</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [2, 3],
        'Ionic radii': { '2': 1.43, '3': 1.123 },
        'Liquid range': '2076 K',
        'Melting point': '1297 K',
        'Mendeleev no': 30,
        'Mineral hardness': 'no data',
        'Molar volume': '20.59 cm<sup>3</sup>',
        Name: 'Neodymium',
        'Oxidation states': [2, 3],
        'Poissons ratio': '0.28',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '16 GPa',
        'Shannon radii': {
            '2': {
                VIII: { '': { crystal_radius: 1.43, ionic_radius: 1.29 } },
                IX: { '': { crystal_radius: 1.49, ionic_radius: 1.35 } },
            },
            '3': {
                VI: { '': { crystal_radius: 1.123, ionic_radius: 0.983 } },
                VIII: { '': { crystal_radius: 1.249, ionic_radius: 1.109 } },
                IX: { '': { crystal_radius: 1.303, ionic_radius: 1.163 } },
                XII: { '': { crystal_radius: 1.41, ionic_radius: 1.27 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '17 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.39,
        'Velocity of sound': '2330 m s<sup>-1</sup>',
        'Vickers hardness': '343 MN m<sup>-2</sup>',
        X: 1.14,
        'Youngs modulus': '41 GPa',
        'Metallic radius': 1.821,
        iupac_ordering: 44,
        'IUPAC ordering': 44,
        'Ground level': '5I4',
        'Ionization energies': [
            5.525, 10.783, 22.09, 40.6, 60, 84, 99, 114, 136, 152, 168, 195, 221, 243, 389, 420, 453, 489, 522, 562,
            602, 638, 678, 714, 859, 896, 939, 978, 1049, 1092, 1191, 1238.42, 2134, 2224, 2321, 2425, 2525, 2627, 2758,
            2861, 2974, 3078, 3371, 3465, 3567, 3662, 3891, 3997, 4198, 4302, 9742, 10002, 10288, 10555, 11384, 11694,
            12082, 12341.66, 50339.59, 51515.58,
        ],
        'Electron affinity': 0.0974933,
        symbol: 'Nd',
    },
    {
        'Atomic mass': 145,
        'Atomic no': 61,
        'Atomic orbitals': {
            '1s': -1562.980284,
            '2p': -233.455114,
            '2s': -245.970548,
            '3d': -37.625433,
            '3p': -47.921132,
            '3s': -53.429311,
            '4d': -4.596822,
            '4f': -0.200159,
            '4p': -8.320495,
            '4s': -10.422756,
            '5p': -0.817702,
            '5s': -1.372265,
            '6s': -0.127053,
        },
        'Atomic radius': 1.85,
        'Atomic radius calculated': 2.05,
        'Boiling point': '3273 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '33 GPa',
        'Coefficient of linear thermal expansion': '11 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '7264 kg m<sup>-3</sup>',
        'Electrical resistivity': 'about 75 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>5</sup>.6s<sup>2</sup>',
        'Ionic radii': { '3': 1.11 },
        'Liquid range': '1900 K',
        'Melting point': '1373 K',
        'Mendeleev no': 29,
        'Mineral hardness': 'no data',
        'Molar volume': '20.23 cm<sup>3</sup>',
        Name: 'Promethium',
        'Oxidation states': [3],
        'Poissons ratio': '0.28',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '18 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.11, ionic_radius: 0.97 } },
                VIII: { '': { crystal_radius: 1.233, ionic_radius: 1.093 } },
                IX: { '': { crystal_radius: 1.284, ionic_radius: 1.144 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '15 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.38,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.13,
        'Youngs modulus': '46 GPa',
        'Metallic radius': 1.811,
        iupac_ordering: 43,
        'IUPAC ordering': 43,
        'Ground level': '6H°5/2',
        'Ionization energies': [
            5.58187, 10.938, 22.44, 41.17, 61.7, 85, 101, 116, 138, 155, 174, 202, 229, 248, 269, 430, 462, 497, 534,
            569, 609, 651, 689, 730, 767, 916, 956, 998, 1040, 1113, 1158, 1261, 1308.7, 2251, 2344, 2443, 2549, 2652,
            2755, 2892, 2997, 3112, 3219, 3519, 3613, 3718, 3816, 4056, 4166, 4371, 4476, 10115, 10378, 10671, 10942,
            11819, 12136, 12532, 12797.26, 52144.29, 53346.1,
        ],
        'Electron affinity': 0.129,
        symbol: 'Pm',
    },
    {
        'Atomic mass': 150.36,
        'Atomic no': 62,
        'Atomic orbitals': {
            '1s': -1617.183426,
            '2p': -242.729726,
            '2s': -255.498846,
            '3d': -39.528656,
            '3p': -50.08426,
            '3s': -55.731133,
            '4d': -4.814978,
            '4f': -0.21776,
            '4p': -8.672685,
            '4s': -10.844667,
            '5p': -0.835987,
            '5s': -1.408552,
            '6s': -0.128259,
        },
        'Atomic radius': 1.85,
        'Atomic radius calculated': 2.38,
        'Boiling point': '2076 K',
        'Brinell hardness': '441 MN m<sup>-2</sup>',
        'Bulk modulus': '38 GPa',
        'Coefficient of linear thermal expansion': '12.7 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '7353 kg m<sup>-3</sup>',
        'Electrical resistivity': '94 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>6</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [2, 3],
        'Ionic radii': { '2': 1.36, '3': 1.0979999999999999 },
        'Liquid range': '731 K',
        'Melting point': '1345 K',
        'Mendeleev no': 28,
        'Mineral hardness': 'no data',
        'Molar volume': '19.98 cm<sup>3</sup>',
        Name: 'Samarium',
        'Oxidation states': [2, 3],
        'Poissons ratio': '0.27',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '20 GPa',
        'Shannon radii': {
            '2': {
                VII: { '': { crystal_radius: 1.36, ionic_radius: 1.22 } },
                VIII: { '': { crystal_radius: 1.41, ionic_radius: 1.27 } },
                IX: { '': { crystal_radius: 1.46, ionic_radius: 1.32 } },
            },
            '3': {
                VI: { '': { crystal_radius: 1.098, ionic_radius: 0.958 } },
                VII: { '': { crystal_radius: 1.16, ionic_radius: 1.02 } },
                VIII: { '': { crystal_radius: 1.219, ionic_radius: 1.079 } },
                IX: { '': { crystal_radius: 1.272, ionic_radius: 1.132 } },
                XII: { '': { crystal_radius: 1.38, ionic_radius: 1.24 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '13 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.36,
        'Velocity of sound': '2130 m s<sup>-1</sup>',
        'Vickers hardness': '412 MN m<sup>-2</sup>',
        X: 1.17,
        'Youngs modulus': '50 GPa',
        'Metallic radius': 1.804,
        iupac_ordering: 42,
        'IUPAC ordering': 42,
        'Ground level': '7F0',
        'Ionization energies': [
            5.64371, 11.078, 23.55, 41.64, 62.7, 87, 103, 118, 141, 158, 179, 208, 237, 257, 276, 306.5, 474, 506, 543,
            581, 617, 658, 702, 742, 782, 822, 976, 1016, 1060, 1103, 1180, 1226, 1332, 1381.56, 2371, 2466, 2569, 2676,
            2782, 2887, 3028, 3137, 3253, 3363, 3669, 3766, 3873, 3971, 4227, 4337, 4548, 4655, 10494, 10762, 11060,
            11337, 12264, 12588, 12992, 13262.85, 53986.12, 55214.23,
        ],
        'Electron affinity': 0.162,
        symbol: 'Sm',
    },
    {
        'Atomic mass': 151.964,
        'Atomic no': 63,
        'Atomic orbitals': {
            '1s': -1672.309322,
            '2p': -252.176697,
            '2s': -265.199534,
            '3d': -41.465518,
            '3p': -52.281987,
            '3s': -58.068128,
            '4d': -5.03242,
            '4f': -0.232773,
            '4p': -9.025455,
            '4s': -11.267747,
            '5p': -0.853575,
            '5s': -1.444087,
            '6s': -0.129426,
        },
        'Atomic radius': 1.85,
        'Atomic radius calculated': 2.31,
        'Boiling point': '1800 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '8.3 GPa',
        'Coefficient of linear thermal expansion': '35 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2, 3],
        'Critical temperature': 'no data K',
        'Density of solid': '5244 kg m<sup>-3</sup>',
        'Electrical resistivity': '90 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>7</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [2, 3],
        'Ionic radii': { '2': 1.31, '3': 1.087 },
        'Liquid range': '701 K',
        'Melting point': '1099 K',
        'Mendeleev no': 18,
        'Mineral hardness': 'no data',
        'Molar volume': '28.97 cm<sup>3</sup>',
        Name: 'Europium',
        'Oxidation states': [2, 3],
        'Poissons ratio': '0.15',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '7.9 GPa',
        'Shannon radii': {
            '2': {
                VI: { '': { crystal_radius: 1.31, ionic_radius: 1.17 } },
                VII: { '': { crystal_radius: 1.34, ionic_radius: 1.2 } },
                VIII: { '': { crystal_radius: 1.39, ionic_radius: 1.25 } },
                IX: { '': { crystal_radius: 1.44, ionic_radius: 1.3 } },
                X: { '': { crystal_radius: 1.49, ionic_radius: 1.35 } },
            },
            '3': {
                VI: { '': { crystal_radius: 1.087, ionic_radius: 0.947 } },
                VII: { '': { crystal_radius: 1.15, ionic_radius: 1.01 } },
                VIII: { '': { crystal_radius: 1.206, ionic_radius: 1.066 } },
                IX: { '': { crystal_radius: 1.26, ionic_radius: 1.12 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '14 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.35,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': '167 MN m<sup>-2</sup>',
        X: 1.2,
        'Youngs modulus': '18 GPa',
        'Metallic radius': 2.041,
        iupac_ordering: 41,
        'IUPAC ordering': 41,
        'Ground level': '8S°7/2',
        'Ionization energies': [
            5.670385, 11.24, 24.84, 42.94, 63.2, 89, 105, 120, 144, 161, 183, 213, 243, 263, 281, 311, 344.4, 518, 553,
            590, 630, 667, 709, 755, 795, 838, 879, 1037, 1078, 1124, 1167, 1249, 1296, 1406, 1456.06, 2495, 2591, 2697,
            2807, 2914, 3022, 3168, 3279, 3398, 3510, 3823, 3921, 4031, 4131, 4400, 4513, 4729, 4838, 10880, 11153,
            11457, 11739, 12718, 13050, 13462, 13738.58, 55865.92, 57120.64,
        ],
        'Electron affinity': 0.11613,
        symbol: 'Eu',
    },
    {
        'Atomic mass': 157.25,
        'Atomic no': 64,
        'Atomic orbitals': {
            '1s': -1728.625195,
            '2p': -262.081616,
            '2s': -275.36313,
            '3d': -43.754556,
            '3p': -54.836922,
            '3s': -60.764408,
            '4d': -5.531835,
            '4f': -0.489012,
            '4p': -9.669866,
            '4s': -11.986486,
            '5d': -0.12722,
            '5p': -0.978749,
            '5s': -1.608477,
            '6s': -0.143627,
        },
        'Atomic radius': 1.8,
        'Atomic radius calculated': 2.33,
        'Boiling point': '3523 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '38 GPa',
        'Coefficient of linear thermal expansion': '9.4 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '7901 kg m<sup>-3</sup>',
        'Electrical resistivity': '131 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>7</sup>.5d<sup>1</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3],
        'Ionic radii': { '3': 1.075 },
        'Liquid range': '1938 K',
        'Melting point': '1585 K',
        'Mendeleev no': 27,
        'Mineral hardness': 'no data',
        'Molar volume': '19.90 cm<sup>3</sup>',
        Name: 'Gadolinium',
        'Oxidation states': [1, 2, 3],
        'Poissons ratio': '0.26',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '22 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.078, ionic_radius: 0.938 } },
                VII: { '': { crystal_radius: 1.14, ionic_radius: 1 } },
                VIII: { '': { crystal_radius: 1.193, ionic_radius: 1.053 } },
                IX: { '': { crystal_radius: 1.247, ionic_radius: 1.107 } },
            },
        },
        'Superconduction temperature': '1.083 K',
        'Thermal conductivity': '11 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.34,
        'Velocity of sound': '2680 m s<sup>-1</sup>',
        'Vickers hardness': '570 MN m<sup>-2</sup>',
        X: 1.2,
        'Youngs modulus': '55 GPa',
        'Metallic radius': 1.802,
        iupac_ordering: 40,
        'IUPAC ordering': 40,
        'Ground level': '9D°2',
        'Ionization energies': [
            6.1498, 12.076, 20.54, 44.44, 64.8, 89, 106, 123, 144, 165, 183, 213, 246, 268, 288, 319, 352, 384.4, 565,
            601, 639, 680, 719, 761, 810, 851, 895, 937, 1100, 1142, 1189, 1233, 1321, 1368, 1481, 1532.3, 2621, 2720,
            2827, 2941, 3050, 3160, 3312, 3424, 3546, 3660, 3980, 4080, 4191, 4294, 4578, 4693, 4914, 5025, 11273,
            11552, 11861, 12147, 13183, 13521, 13943, 14224.57, 57783.9, 59065.53,
        ],
        'Electron affinity': 0.137,
        symbol: 'Gd',
    },
    {
        'Atomic mass': 158.92535,
        'Atomic no': 65,
        'Atomic orbitals': {
            '1s': -1785.331942,
            '2p': -271.590585,
            '2s': -285.121013,
            '3d': -45.443863,
            '3p': -56.785113,
            '3s': -62.851563,
            '4d': -5.467662,
            '4f': -0.256311,
            '4p': -9.735637,
            '4s': -12.120486,
            '5p': -0.88723,
            '5s': -1.513669,
            '6s': -0.131677,
        },
        'Atomic radius': 1.75,
        'Atomic radius calculated': 2.25,
        'Boiling point': '3503 K',
        'Brinell hardness': '677 MN m<sup>-2</sup>',
        'Bulk modulus': '38.7 GPa',
        'Coefficient of linear thermal expansion': '10.3 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '8219 kg m<sup>-3</sup>',
        'Electrical resistivity': '115 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>9</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3, 4],
        'Ionic radii': { '3': 1.063, '4': 0.9 },
        'Liquid range': '1874 K',
        'Melting point': '1629 K',
        'Mendeleev no': 26,
        'Mineral hardness': 'no data',
        'Molar volume': '19.30 cm<sup>3</sup>',
        Name: 'Terbium',
        'Oxidation states': [1, 3, 4],
        'Poissons ratio': '0.26',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '22 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.063, ionic_radius: 0.923 } },
                VII: { '': { crystal_radius: 1.12, ionic_radius: 0.98 } },
                VIII: { '': { crystal_radius: 1.18, ionic_radius: 1.04 } },
                IX: { '': { crystal_radius: 1.235, ionic_radius: 1.095 } },
            },
            '4': {
                VI: { '': { crystal_radius: 0.9, ionic_radius: 0.76 } },
                VIII: { '': { crystal_radius: 1.02, ionic_radius: 0.88 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '11 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.33,
        'Velocity of sound': '2620 m s<sup>-1</sup>',
        'Vickers hardness': '863 MN m<sup>-2</sup>',
        X: 1.1,
        'Youngs modulus': '56 GPa',
        'Metallic radius': 1.781,
        iupac_ordering: 39,
        'IUPAC ordering': 39,
        'Ground level': '6H°15/2',
        'Ionization energies': [
            5.8638, 11.513, 21.82, 39.33, 66.5, 90, 108, 125, 143, 168, 186, 216, 250, 273, 294, 325, 358, 393, 426.6,
            613, 651, 690, 732, 772, 816, 866, 909, 954, 997, 1165, 1208, 1256, 1301, 1393, 1443, 1559, 1610.4, 2750,
            2852, 2961, 3078, 3189, 3300, 3458, 3573, 3698, 3814, 4139, 4242, 4355, 4460, 4760, 4877, 5103, 5217, 11673,
            11957, 12272, 12563, 13658, 14003, 14434, 14721.02, 59739.3, 61049.65,
        ],
        'Electron affinity': 0.131318,
        symbol: 'Tb',
    },
    {
        'Atomic mass': 162.5,
        'Atomic no': 66,
        'Atomic orbitals': {
            '1s': -1843.229585,
            '2p': -281.558531,
            '2s': -295.342856,
            '3d': -47.4867,
            '3p': -59.091931,
            '3s': -65.299442,
            '4d': -5.686352,
            '4f': -0.265302,
            '4p': -10.094091,
            '4s': -12.551251,
            '5p': -0.90349,
            '5s': -1.547977,
            '6s': -0.132769,
        },
        'Atomic radius': 1.75,
        'Atomic radius calculated': 2.28,
        'Boiling point': '2840 K',
        'Brinell hardness': '500 MN m<sup>-2</sup>',
        'Bulk modulus': '41 GPa',
        'Coefficient of linear thermal expansion': '9.9 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '8551 kg m<sup>-3</sup>',
        'Electrical resistivity': '92.6 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>10</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3],
        'Ionic radii': { '2': 1.21, '3': 1.052 },
        'Liquid range': '1160 K',
        'Melting point': '1680 K',
        'Mendeleev no': 24,
        'Mineral hardness': 'no data',
        'Molar volume': '19.01 cm<sup>3</sup>',
        Name: 'Dysprosium',
        'Oxidation states': [2, 3],
        'Poissons ratio': '0.25',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '25 GPa',
        'Shannon radii': {
            '2': {
                VI: { '': { crystal_radius: 1.21, ionic_radius: 1.07 } },
                VII: { '': { crystal_radius: 1.27, ionic_radius: 1.13 } },
                VIII: { '': { crystal_radius: 1.33, ionic_radius: 1.19 } },
            },
            '3': {
                VI: { '': { crystal_radius: 1.052, ionic_radius: 0.912 } },
                VII: { '': { crystal_radius: 1.11, ionic_radius: 0.97 } },
                VIII: { '': { crystal_radius: 1.167, ionic_radius: 1.027 } },
                IX: { '': { crystal_radius: 1.223, ionic_radius: 1.083 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '11 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.31,
        'Velocity of sound': '2710 m s<sup>-1</sup>',
        'Vickers hardness': '540 MN m<sup>-2</sup>',
        X: 1.22,
        'Youngs modulus': '61 GPa',
        'Metallic radius': 1.773,
        iupac_ordering: 38,
        'IUPAC ordering': 38,
        'Ground level': '5I8',
        'Ionization energies': [
            5.93905, 11.647, 22.89, 41.23, 62.1, 93, 110, 127, 152, 170, 192, 224, 259, 279, 300, 332, 366, 399, 431,
            464.9, 664, 702, 743, 786, 827, 872, 924, 969, 1014, 1059, 1232, 1275, 1325, 1371, 1468, 1520, 1638, 1691.7,
            2882, 2987, 3098, 3217, 3331, 3445, 3607, 3725, 3852, 3970, 4303, 4407, 4523, 4629, 4945, 5066, 5296, 5412,
            12081, 12370, 12690, 12986, 14144, 14495, 14936, 15228.06, 61736.56, 63073.5,
        ],
        'Electron affinity': 0.352,
        symbol: 'Dy',
    },
    {
        'Atomic mass': 164.93032,
        'Atomic no': 67,
        'Atomic orbitals': {
            '1s': -1902.051908,
            '2p': -291.700994,
            '2s': -305.739294,
            '3d': -49.565996,
            '3p': -61.436304,
            '3s': -67.785492,
            '4d': -5.906195,
            '4f': -0.272677,
            '4p': -10.455303,
            '4s': -12.985498,
            '5p': -0.919463,
            '5s': -1.582088,
            '6s': -0.133845,
        },
        'Atomic radius': 1.75,
        'Atomic radius calculated': 'no data',
        'Boiling point': '2993 K',
        'Brinell hardness': '746 MN m<sup>-2</sup>',
        'Bulk modulus': '40 GPa',
        'Coefficient of linear thermal expansion': '11.2 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '8795 kg m<sup>-3</sup>',
        'Electrical resistivity': '81.4 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>11</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3],
        'Ionic radii': { '3': 1.041 },
        'Liquid range': '1259 K',
        'Melting point': '1734 K',
        'Mendeleev no': 23,
        'Mineral hardness': 'no data',
        'Molar volume': '18.74 cm<sup>3</sup>',
        Name: 'Holmium',
        'Oxidation states': [3],
        'Poissons ratio': '0.23',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '26 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.041, ionic_radius: 0.901 } },
                VIII: { '': { crystal_radius: 1.155, ionic_radius: 1.015 } },
                IX: { '': { crystal_radius: 1.212, ionic_radius: 1.072 } },
                X: { '': { crystal_radius: 1.26, ionic_radius: 1.12 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '16 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.3,
        'Velocity of sound': '2760 m s<sup>-1</sup>',
        'Vickers hardness': '481 MN m<sup>-2</sup>',
        X: 1.23,
        'Youngs modulus': '65 GPa',
        'Metallic radius': 1.765,
        iupac_ordering: 37,
        'IUPAC ordering': 37,
        'Ground level': '4I°15/2',
        'Ionization energies': [
            6.0215, 11.781, 22.79, 42.52, 63.9, 95, 112, 129, 155, 173, 197, 229, 263, 284, 305, 340, 373, 408, 441,
            475, 510, 715, 755, 797, 842, 885, 929, 985, 1029, 1077, 1122, 1300, 1346, 1395, 1443, 1545, 1598, 1719,
            1773.6, 3018, 3125, 3238, 3359, 3476, 3592, 3760, 3880, 4009, 4131, 4469, 4576, 4693, 4802, 5135, 5258,
            5494, 5611, 12495, 12790, 13116, 13417, 14639, 14998, 15448, 15745.77, 63772.43, 65136.8,
        ],
        'Electron affinity': 0.338,
        symbol: 'Ho',
    },
    {
        'Atomic mass': 167.259,
        'Atomic no': 68,
        'Atomic orbitals': {
            '1s': -1961.799176,
            '2p': -302.01827,
            '2s': -316.310631,
            '3d': -51.682149,
            '3p': -63.818655,
            '3s': -70.310142,
            '4d': -6.127443,
            '4f': -0.278577,
            '4p': -10.819574,
            '4s': -13.423547,
            '5p': -0.935202,
            '5s': -1.616073,
            '6s': -0.134905,
        },
        'Atomic radius': 1.75,
        'Atomic radius calculated': 2.26,
        'Boiling point': '3141 K',
        'Brinell hardness': '814 MN m<sup>-2</sup>',
        'Bulk modulus': '44 GPa',
        'Coefficient of linear thermal expansion': '12.2 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '9066 kg m<sup>-3</sup>',
        'Electrical resistivity': '86.0 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>12</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3],
        'Ionic radii': { '3': 1.03 },
        'Liquid range': '1371 K',
        'Melting point': '1802 K',
        'Mendeleev no': 22,
        'Mineral hardness': 'no data',
        'Molar volume': '18.46 cm<sup>3</sup>',
        Name: 'Erbium',
        'Oxidation states': [3],
        'Poissons ratio': '0.24',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '28 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.03, ionic_radius: 0.89 } },
                VII: { '': { crystal_radius: 1.085, ionic_radius: 0.945 } },
                VIII: { '': { crystal_radius: 1.144, ionic_radius: 1.004 } },
                IX: { '': { crystal_radius: 1.202, ionic_radius: 1.062 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '15 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.29,
        'Velocity of sound': '2830 m s<sup>-1</sup>',
        'Vickers hardness': '589 MN m<sup>-2</sup>',
        X: 1.24,
        'Youngs modulus': '70 GPa',
        'Metallic radius': 1.756,
        iupac_ordering: 36,
        'IUPAC ordering': 36,
        'Ground level': '3H6',
        'Ionization energies': [
            6.1077, 11.916, 22.7, 42.42, 65.1, 96, 114, 131, 158, 177, 201, 235, 268, 290, 311, 345, 381, 415, 450, 486,
            520, 555, 770, 810, 853, 899, 943, 989, 1046, 1092, 1142, 1188, 1370, 1416, 1468, 1516, 1625, 1678, 1803,
            1858.5, 3157, 3265, 3381, 3505, 3624, 3742, 3916, 4038, 4170, 4294, 4639, 4748, 4866, 4978, 5329, 5455,
            5695, 5815, 12918, 13217, 13548, 13855, 15146, 15511, 15971, 16274.56, 65848.24, 67241.9,
        ],
        'Electron affinity': 0.312,
        symbol: 'Er',
    },
    {
        'Atomic mass': 168.93421,
        'Atomic no': 69,
        'Atomic orbitals': {
            '1s': -2022.471608,
            '2p': -312.510608,
            '2s': -327.05712,
            '3d': -53.835494,
            '3p': -66.239338,
            '3s': -72.873753,
            '4d': -6.350307,
            '4f': -0.28312,
            '4p': -11.187151,
            '4s': -13.865665,
            '5p': -0.950748,
            '5s': -1.64999,
            '6s': -0.135953,
        },
        'Atomic radius': 1.75,
        'Atomic radius calculated': 2.22,
        'Boiling point': '2223 K',
        'Brinell hardness': '471 MN m<sup>-2</sup>',
        'Bulk modulus': '45 GPa',
        'Coefficient of linear thermal expansion': '13.3 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '9321 kg m<sup>-3</sup>',
        'Electrical resistivity': '67.6 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>13</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3],
        'Ionic radii': { '2': 1.17, '3': 1.02 },
        'Liquid range': '405 K',
        'Melting point': '1818 K',
        'Mendeleev no': 21,
        'Mineral hardness': 'no data',
        'Molar volume': '19.1 cm<sup>3</sup>',
        Name: 'Thulium',
        'Oxidation states': [2, 3],
        'Poissons ratio': '0.21',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '31 GPa',
        'Shannon radii': {
            '2': {
                VI: { '': { crystal_radius: 1.17, ionic_radius: 1.03 } },
                VII: { '': { crystal_radius: 1.23, ionic_radius: 1.09 } },
            },
            '3': {
                VI: { '': { crystal_radius: 1.02, ionic_radius: 0.88 } },
                VIII: { '': { crystal_radius: 1.134, ionic_radius: 0.994 } },
                IX: { '': { crystal_radius: 1.192, ionic_radius: 1.052 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '17 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.27,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': '520 MN m<sup>-2</sup>',
        X: 1.25,
        'Youngs modulus': '74 GPa',
        'Metallic radius': 1.747,
        iupac_ordering: 35,
        'IUPAC ordering': 35,
        'Ground level': '2F°7/2',
        'Ionization energies': [
            6.18431, 12.065, 23.66, 42.41, 65.4, 98, 116, 133, 160, 180, 205, 239, 274, 295, 317, 352, 387, 424, 460,
            496, 530, 570, 603, 825, 866, 911, 958, 1004, 1050, 1110, 1157, 1207, 1255, 1442, 1490, 1542, 1591, 1706,
            1761, 1889, 1945.2, 3298, 3409, 3528, 3653, 3775, 3895, 4075, 4199, 4335, 4461, 4812, 4922, 5044, 5157,
            5527, 5656, 5901, 6023, 13347, 13651, 13988, 14300, 15663, 16036, 16510, 16814.34, 67965.26, 69387.3,
        ],
        'Electron affinity': 1.02922,
        symbol: 'Tm',
    },
    {
        'Atomic mass': 173.04,
        'Atomic no': 70,
        'Atomic orbitals': {
            '1s': -2084.069389,
            '2p': -323.178219,
            '2s': -337.978976,
            '3d': -56.026315,
            '3p': -68.698655,
            '3s': -75.47663,
            '4d': -6.574963,
            '4f': -0.286408,
            '4p': -11.558246,
            '4s': -14.312076,
            '5p': -0.966137,
            '5s': -1.683886,
            '6s': -0.136989,
        },
        'Atomic radius': 1.75,
        'Atomic radius calculated': 2.22,
        'Boiling point': '1469 K',
        'Brinell hardness': '343 MN m<sup>-2</sup>',
        'Bulk modulus': '31 GPa',
        'Coefficient of linear thermal expansion': '26.3 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '6570 kg m<sup>-3</sup>',
        'Electrical resistivity': '25.0 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [2, 3],
        'Ionic radii': { '2': 1.16, '3': 1.008 },
        'Liquid range': '372 K',
        'Melting point': '1097 K',
        'Mendeleev no': 17,
        'Mineral hardness': 'no data',
        'Molar volume': '24.84 cm<sup>3</sup>',
        Name: 'Ytterbium',
        'Oxidation states': [2, 3],
        'Poissons ratio': '0.21',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '9.9 GPa',
        'Shannon radii': {
            '2': {
                VI: { '': { crystal_radius: 1.16, ionic_radius: 1.02 } },
                VII: { '': { crystal_radius: 1.22, ionic_radius: 1.08 } },
                VIII: { '': { crystal_radius: 1.28, ionic_radius: 1.14 } },
            },
            '3': {
                VI: { '': { crystal_radius: 1.008, ionic_radius: 0.868 } },
                VII: { '': { crystal_radius: 1.065, ionic_radius: 0.925 } },
                VIII: { '': { crystal_radius: 1.125, ionic_radius: 0.985 } },
                IX: { '': { crystal_radius: 1.182, ionic_radius: 1.042 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '39 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.26,
        'Velocity of sound': '1590 m s<sup>-1</sup>',
        'Vickers hardness': '206 MN m<sup>-2</sup>',
        X: 1.1,
        'Youngs modulus': '24 GPa',
        'Metallic radius': 1.94,
        iupac_ordering: 34,
        'IUPAC ordering': 34,
        'Ground level': '1S0',
        'Ionization energies': [
            6.25416, 12.179185, 25.053, 43.61, 65.6, 99, 117, 135, 163, 182, 209, 244, 279, 301, 324, 360, 396, 431,
            469, 505, 540, 580, 610, 651, 882, 924, 971, 1019, 1065, 1114, 1175, 1224, 1275, 1324, 1516, 1564, 1618,
            1668, 1789, 1845, 1978, 2036.4, 3443, 3555, 3677, 3805, 3929, 4051, 4238, 4364, 4502, 4630, 4988, 5101,
            5224, 5339, 5731, 5860, 6111, 6236, 13784, 14093, 14435, 14752, 16191, 16570, 17050, 17365.44, 70123.04,
            71574.8,
        ],
        'Electron affinity': -0.02,
        symbol: 'Yb',
    },
    {
        'Atomic mass': 174.967,
        'Atomic no': 71,
        'Atomic orbitals': {
            '1s': -2146.885351,
            '2p': -334.330902,
            '2s': -349.390492,
            '3d': -58.592982,
            '3p': -71.538779,
            '3s': -78.462398,
            '4d': -7.113364,
            '4f': -0.568096,
            '4p': -12.250904,
            '4s': -15.08337,
            '5d': -0.103686,
            '5p': -1.111991,
            '5s': -1.872086,
            '6s': -0.155112,
        },
        'Atomic radius': 1.75,
        'Atomic radius calculated': 2.17,
        'Boiling point': '3675 K',
        'Brinell hardness': '893 MN m<sup>-2</sup>',
        'Bulk modulus': '48 GPa',
        'Coefficient of linear thermal expansion': '9.9 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '9841 kg m<sup>-3</sup>',
        'Electrical resistivity': '58 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>1</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3],
        'Ionic radii': { '3': 1.001 },
        'Liquid range': '1750 K',
        'Melting point': '1925 K',
        'Mendeleev no': 20,
        'Mineral hardness': 'no data',
        'Molar volume': '17.78 cm<sup>3</sup>',
        Name: 'Lutetium',
        'Oxidation states': [3],
        'Poissons ratio': '0.26',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '27 GPa',
        'Shannon radii': {
            '3': {
                VI: { '': { crystal_radius: 1.001, ionic_radius: 0.861 } },
                VIII: { '': { crystal_radius: 1.117, ionic_radius: 0.977 } },
                IX: { '': { crystal_radius: 1.172, ionic_radius: 1.032 } },
            },
        },
        'Superconduction temperature': '0.022 K',
        'Thermal conductivity': '16 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.24,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': '1160 MN m<sup>-2</sup>',
        X: 1.27,
        'Youngs modulus': '69 GPa',
        'Metallic radius': 1.735,
        iupac_ordering: 33,
        'IUPAC ordering': 33,
        'Ground level': '2D3/2',
        'Ionization energies': [
            5.425871, 14.13, 20.9594, 45.249, 66.8, 98, 117, 136, 159, 185, 205, 238, 276, 305, 328, 361, 399, 438, 476,
            520, 560, 600, 630, 670, 713, 941, 985, 1032, 1081, 1130, 1178, 1242, 1292, 1345, 1395, 1591, 1641, 1696,
            1747, 1875, 1933, 2067, 2125.5, 3590, 3706, 3828, 3960, 4086, 4211, 4403, 4532, 4673, 4803, 5168, 5282,
            5408, 5525, 5937, 6070, 6326, 6452, 14228, 14542, 14890, 15211, 16730, 17120, 17610, 17928.05, 72322.91,
            73804.8,
        ],
        'Electron affinity': 0.23887,
        symbol: 'Lu',
    },
    {
        'Atomic mass': 178.49,
        'Atomic no': 72,
        'Atomic orbitals': {
            '1s': -2210.65199,
            '2p': -345.687023,
            '2s': -361.006527,
            '3d': -61.231443,
            '3p': -74.452656,
            '3s': -81.522812,
            '4d': -7.676638,
            '4f': -0.871574,
            '4p': -12.971211,
            '4s': -15.883625,
            '5d': -0.143805,
            '5p': -1.246441,
            '5s': -2.049828,
            '6s': -0.166465,
        },
        'Atomic radius': 1.55,
        'Atomic radius calculated': 2.08,
        'Boiling point': '4876 K',
        'Brinell hardness': '1700 MN m<sup>-2</sup>',
        'Bulk modulus': '110 GPa',
        'Coefficient of linear thermal expansion': '5.9 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4],
        'Critical temperature': 'no data K',
        'Density of solid': '13310 kg m<sup>-3</sup>',
        'Electrical resistivity': '34 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>2</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [4],
        'Ionic radii': { '4': 0.85 },
        'Liquid range': '2370 K',
        'Melting point': '2506 K',
        'Mendeleev no': 50,
        'Mineral hardness': '5.5',
        'Molar volume': '13.44 cm<sup>3</sup>',
        Name: 'Hafnium',
        'Oxidation states': [2, 3, 4],
        'Poissons ratio': '0.37',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '30 GPa',
        'Shannon radii': {
            '4': {
                IV: { '': { crystal_radius: 0.72, ionic_radius: 0.58 } },
                VI: { '': { crystal_radius: 0.85, ionic_radius: 0.71 } },
                VII: { '': { crystal_radius: 0.9, ionic_radius: 0.76 } },
                VIII: { '': { crystal_radius: 0.97, ionic_radius: 0.83 } },
            },
        },
        'Superconduction temperature': '0.128 K',
        'Thermal conductivity': '23 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.23,
        'Velocity of sound': '3010 m s<sup>-1</sup>',
        'Vickers hardness': '1760 MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': '78 GPa',
        'Metallic radius': 1.58,
        iupac_ordering: 50,
        'IUPAC ordering': 50,
        'Ground level': '3F2',
        'Ionization energies': [
            6.82507, 14.61, 22.55, 33.37, 68.37, 98, 118, 137, 157, 187, 209, 230, 270, 310, 334, 359, 399, 440, 481,
            520, 570, 610, 650, 690, 730, 772, 1002, 1047, 1094, 1146, 1195, 1245, 1311, 1362, 1417, 1467, 1669, 1719,
            1776, 1827, 1963, 2022, 2159, 2218.9, 3741, 3858, 3984, 4118, 4246, 4372, 4573, 4703, 4846, 4980, 5350,
            5468, 5595, 5713, 6149, 6284, 6545, 6674, 14678, 14999, 15351, 15680, 17280, 17680, 18180, 18502.32,
            74565.93, 76077.8,
        ],
        'Electron affinity': 0.17807,
        symbol: 'Hf',
    },
    {
        'Atomic mass': 180.94788,
        'Atomic no': 73,
        'Atomic orbitals': {
            '1s': -2275.371387,
            '2p': -357.248334,
            '2s': -372.828724,
            '3d': -63.942521,
            '3p': -77.440942,
            '3s': -84.658467,
            '4d': -8.265848,
            '4f': -1.199347,
            '4p': -13.71981,
            '4s': -16.713337,
            '5d': -0.182464,
            '5p': -1.37653,
            '5s': -2.223807,
            '6s': -0.174814,
        },
        'Atomic radius': 1.45,
        'Atomic radius calculated': 2,
        'Boiling point': '5731 K',
        'Brinell hardness': '800 MN m<sup>-2</sup>',
        'Bulk modulus': '200 GPa',
        'Coefficient of linear thermal expansion': '6.3 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [5],
        'Critical temperature': 'no data K',
        'Density of solid': '16650 kg m<sup>-3</sup>',
        'Electrical resistivity': '13.5 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>3</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3, 4, 5],
        'Ionic radii': { '3': 0.86, '4': 0.82, '5': 0.78 },
        'Liquid range': '2441 K',
        'Melting point': '3290 K',
        'Mendeleev no': 52,
        'Mineral hardness': '6.5',
        'Molar volume': '10.85 cm<sup>3</sup>',
        Name: 'Tantalum',
        'Oxidation states': [-1, 2, 3, 4, 5],
        'Poissons ratio': '0.34',
        Reflectivity: '78 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '69 GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.86, ionic_radius: 0.72 } } },
            '4': { VI: { '': { crystal_radius: 0.82, ionic_radius: 0.68 } } },
            '5': {
                VI: { '': { crystal_radius: 0.78, ionic_radius: 0.64 } },
                VII: { '': { crystal_radius: 0.83, ionic_radius: 0.69 } },
                VIII: { '': { crystal_radius: 0.88, ionic_radius: 0.74 } },
            },
        },
        'Superconduction temperature': '4.47 K',
        'Thermal conductivity': '57 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.22,
        'Velocity of sound': '3400 m s<sup>-1</sup>',
        'Vickers hardness': '873 MN m<sup>-2</sup>',
        X: 1.5,
        'Youngs modulus': '186 GPa',
        'Metallic radius': 1.47,
        iupac_ordering: 53,
        'IUPAC ordering': 53,
        'Ground level': '4F3/2',
        'Ionization energies': [
            7.549571, 16.2, 23.1, 35, 48.272, 94.01, 119, 139, 159, 180, 213, 235, 262, 304, 338, 363, 396, 439, 482,
            530, 570, 610, 660, 700, 750, 790, 832, 1064, 1110, 1160, 1211, 1262, 1313, 1382, 1434, 1490, 1542, 1748,
            1799, 1857, 1910, 2053, 2113, 2254, 2314.7, 3898.7, 4014, 4143, 4278, 4410, 4537, 4745, 4877, 5024, 5159,
            5537, 5655, 5785, 5907, 6364, 6502, 6769, 6900, 15137, 15461, 15820, 16150, 17840, 18250, 18760, 19088.51,
            76852.03, 78394.7,
        ],
        'Electron affinity': 0.32312,
        symbol: 'Ta',
    },
    {
        'Atomic mass': 183.84,
        'Atomic no': 74,
        'Atomic orbitals': {
            '1s': -2341.042887,
            '2p': -369.013973,
            '2s': -384.856157,
            '3d': -66.724787,
            '3p': -80.502102,
            '3s': -87.867792,
            '4d': -8.879693,
            '4f': -1.550835,
            '4p': -14.495102,
            '4s': -17.570797,
            '5d': -0.220603,
            '5p': -1.504457,
            '5s': -2.396018,
            '6s': -0.181413,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.93,
        'Boiling point': '5828 K',
        'Brinell hardness': '2570 MN m<sup>-2</sup>',
        'Bulk modulus': '310 GPa',
        'Coefficient of linear thermal expansion': '4.5 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4, 6],
        'Critical temperature': 'no data K',
        'Density of solid': '19250 kg m<sup>-3</sup>',
        'Electrical resistivity': '5.4 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>4</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [2, 3, 4, 5, 6],
        'Ionic radii': { '4': 0.8, '5': 0.76, '6': 0.74 },
        'Liquid range': '2133 K',
        'Melting point': '3695 K',
        'Mendeleev no': 55,
        'Mineral hardness': '7.5',
        'Molar volume': '9.47 cm<sup>3</sup>',
        Name: 'Tungsten',
        'Oxidation states': [-2, -1, 1, 2, 3, 4, 5, 6],
        'Poissons ratio': '0.28',
        Reflectivity: '62 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '161 GPa',
        'Shannon radii': {
            '4': { VI: { '': { crystal_radius: 0.8, ionic_radius: 0.66 } } },
            '5': { VI: { '': { crystal_radius: 0.76, ionic_radius: 0.62 } } },
            '6': {
                IV: { '': { crystal_radius: 0.56, ionic_radius: 0.42 } },
                V: { '': { crystal_radius: 0.65, ionic_radius: 0.51 } },
                VI: { '': { crystal_radius: 0.74, ionic_radius: 0.6 } },
            },
        },
        'Superconduction temperature': '0.015 K',
        'Thermal conductivity': '170 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.18,
        'Velocity of sound': '5174 m s<sup>-1</sup>',
        'Vickers hardness': '3430 MN m<sup>-2</sup>',
        X: 2.36,
        'Youngs modulus': '411 GPa',
        'Metallic radius': 1.41,
        iupac_ordering: 56,
        'IUPAC ordering': 56,
        'Ground level': '5D0',
        'Ionization energies': [
            7.86403, 16.37, 26, 38.2, 51.6, 64.77, 122.01, 141.2, 160.2, 179, 208.9, 231.6, 258.3, 290.7, 325.3, 361.9,
            387.9, 420.7, 462.1, 502.6, 543.4, 594.5, 640.6, 685.6, 734.1, 784.4, 833.4, 881.4, 1132.2, 1180, 1230.4,
            1283.4, 1335.1, 1386.8, 1459.9, 1512.4, 1569.1, 1621.7, 1829.8, 1882.9, 1940.6, 1994.8, 2149.1, 2210,
            2354.5, 2414.1, 4057, 4180, 4309, 4446, 4578, 4709, 4927, 5063, 5209, 5348, 5719, 5840, 5970, 6093, 6596,
            6735, 7000, 7130, 15566, 15896, 16252, 16588, 18476, 18872, 19362, 19686.74, 79181.94, 80755.6,
        ],
        'Electron affinity': 0.816268,
        symbol: 'W',
    },
    {
        'Atomic mass': 186.207,
        'Atomic no': 75,
        'Atomic orbitals': {
            '1s': -2407.665572,
            '2p': -380.982869,
            '2s': -397.087707,
            '3d': -69.57676,
            '3p': -83.634578,
            '3s': -91.149193,
            '4d': -9.516816,
            '4f': -1.92508,
            '4p': -15.295495,
            '4s': -18.454325,
            '5d': -0.258639,
            '5p': -1.631227,
            '5s': -2.567348,
            '6s': -0.186859,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.88,
        'Boiling point': '5869 K',
        'Brinell hardness': '1320 MN m<sup>-2</sup>',
        'Bulk modulus': '370 GPa',
        'Coefficient of linear thermal expansion': '6.2 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4],
        'Critical temperature': 'no data K',
        'Density of solid': '21020 kg m<sup>-3</sup>',
        'Electrical resistivity': '18 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>5</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3, 4, 5, 6, 7],
        'Ionic radii': { '4': 0.77, '5': 0.72, '6': 0.69, '7': 0.67 },
        'Liquid range': '2410 K',
        'Melting point': '3459 K',
        'Mendeleev no': 58,
        'Mineral hardness': '7.0',
        'Molar volume': '8.86 cm<sup>3</sup>',
        Name: 'Rhenium',
        'Oxidation states': [-3, -1, 1, 2, 3, 4, 5, 6, 7],
        'Poissons ratio': '0.30',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '178 GPa',
        'Shannon radii': {
            '4': { VI: { '': { crystal_radius: 0.77, ionic_radius: 0.63 } } },
            '5': { VI: { '': { crystal_radius: 0.72, ionic_radius: 0.58 } } },
            '6': { VI: { '': { crystal_radius: 0.69, ionic_radius: 0.55 } } },
            '7': {
                IV: { '': { crystal_radius: 0.52, ionic_radius: 0.38 } },
                VI: { '': { crystal_radius: 0.67, ionic_radius: 0.53 } },
            },
        },
        'Superconduction temperature': '1.70 K',
        'Thermal conductivity': '48 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.16,
        'Velocity of sound': '4700 m s<sup>-1</sup>',
        'Vickers hardness': '2450 MN m<sup>-2</sup>',
        X: 1.9,
        'Youngs modulus': '463 GPa',
        'Metallic radius': 1.375,
        iupac_ordering: 59,
        'IUPAC ordering': 59,
        'Ground level': '6S5/2',
        'Ionization energies': [
            7.83352, 16.6, 27, 39.1, 51.9, 67, 82.71, 144.4, 165, 187, 208, 236, 268, 291, 330, 377, 403, 429, 476, 520,
            570, 620, 670, 720, 760, 810, 860, 910, 953, 1194, 1242, 1294, 1349, 1402, 1454, 1530, 1583, 1641, 1696,
            1912, 1966, 2025, 2080, 2240, 2302, 2450, 2514.5, 4214, 4335, 4468, 4609, 4745, 4877, 5099, 5236, 5388,
            5528, 5919, 6042, 6176, 6300, 6810, 6952, 7230, 7366, 16080, 16410, 16780, 17120, 19000, 19420, 19950,
            20297.4, 81556.9, 83162.3,
        ],
        'Electron affinity': 0.06039663,
        symbol: 'Re',
    },
    {
        'Atomic mass': 190.23,
        'Atomic no': 76,
        'Atomic orbitals': {
            '1s': -2475.238617,
            '2p': -393.15408,
            '2s': -409.522396,
            '3d': -72.497183,
            '3p': -86.837047,
            '3s': -94.501324,
            '4d': -10.176082,
            '4f': -2.321175,
            '4p': -16.119671,
            '4s': -19.362527,
            '5d': -0.296791,
            '5p': -1.757404,
            '5s': -2.738293,
            '6s': -0.191489,
        },
        'Atomic radius': 1.3,
        'Atomic radius calculated': 1.85,
        'Boiling point': '5285 K',
        'Brinell hardness': '3920 MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': '5.1 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4],
        'Critical temperature': 'no data K',
        'Density of solid': '22610 kg m<sup>-3</sup>',
        'Electrical resistivity': '8.1 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>6</sup>.6s<sup>2</sup>',
        'Ionic radii': { '4': 0.77, '5': 0.715, '6': 0.685, '7': 0.665, '8': 0.53 },
        'Liquid range': '1979 K',
        'Melting point': '3306 K',
        'Mendeleev no': 63,
        'Mineral hardness': '7.0',
        'Molar volume': '8.42 cm<sup>3</sup>',
        Name: 'Osmium',
        'Oxidation states': [-2, -1, 1, 2, 3, 4, 5, 6, 7, 8],
        'Poissons ratio': '0.25',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '222 GPa',
        'Shannon radii': {
            '4': { VI: { '': { crystal_radius: 0.77, ionic_radius: 0.63 } } },
            '5': { VI: { '': { crystal_radius: 0.715, ionic_radius: 0.575 } } },
            '6': {
                V: { '': { crystal_radius: 0.63, ionic_radius: 0.49 } },
                VI: { '': { crystal_radius: 0.685, ionic_radius: 0.545 } },
            },
            '7': { VI: { '': { crystal_radius: 0.665, ionic_radius: 0.525 } } },
            '8': { IV: { '': { crystal_radius: 0.53, ionic_radius: 0.39 } } },
        },
        'Superconduction temperature': '0.66 K',
        'Thermal conductivity': '88 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.16,
        'Velocity of sound': '4940 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.2,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.352,
        iupac_ordering: 62,
        'IUPAC ordering': 62,
        'Ground level': '5D4',
        'Ionization energies': [
            8.43823, 17, 25, 41, 55, 70.1, 85.1, 102.02, 168.7, 190, 213, 235, 269, 298, 322, 367, 410, 436, 470, 520,
            570, 620, 670, 720, 770, 820, 870, 920, 970, 1015, 1262, 1311, 1364, 1420, 1474, 1528, 1606, 1660, 1720,
            1776, 1996, 2052, 2112, 2168, 2336, 2400, 2552, 2615.5, 4374, 4501, 4635, 4779, 4917, 5052, 5280, 5421,
            5575, 5717, 6115, 6240, 6376, 6503, 7039, 7185, 7468, 7610, 16560, 16900, 17270, 17620, 19600, 20030, 20570,
            20920.6, 83976.21, 85614.4,
        ],
        'Electron affinity': 1.0778013,
        symbol: 'Os',
    },
    {
        'Atomic mass': 192.217,
        'Atomic no': 77,
        'Atomic orbitals': {
            '1s': -2543.761342,
            '2p': -405.526834,
            '2s': -422.159424,
            '3d': -75.485027,
            '3p': -90.108427,
            '3s': -97.923081,
            '4d': -10.856593,
            '4f': -2.738339,
            '4p': -16.966578,
            '4s': -20.29429,
            '5d': -0.335189,
            '5p': -1.883349,
            '5s': -2.909174,
            '6s': -0.195511,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.8,
        'Boiling point': '4701 K',
        'Brinell hardness': '1670 MN m<sup>-2</sup>',
        'Bulk modulus': '320 GPa',
        'Coefficient of linear thermal expansion': '6.4 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '22650 kg m<sup>-3</sup>',
        'Electrical resistivity': '4.7 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>7</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [3, 4, 5],
        'Ionic radii': { '3': 0.82, '4': 0.765, '5': 0.71 },
        'Liquid range': '1962 K',
        'Melting point': '2739 K',
        'Mendeleev no': 66,
        'Mineral hardness': '6.5',
        'Molar volume': '8.52 cm<sup>3</sup>',
        Name: 'Iridium',
        'Oxidation states': [-3, -1, 1, 2, 3, 4, 5, 6],
        'Poissons ratio': '0.26',
        Reflectivity: '78 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '210 GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 0.82, ionic_radius: 0.68 } } },
            '4': { VI: { '': { crystal_radius: 0.765, ionic_radius: 0.625 } } },
            '5': { VI: { '': { crystal_radius: 0.71, ionic_radius: 0.57 } } },
        },
        'Superconduction temperature': '0.11 K',
        'Thermal conductivity': '150 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.13,
        'Velocity of sound': '4825 m s<sup>-1</sup>',
        'Vickers hardness': '1760 MN m<sup>-2</sup>',
        X: 2.2,
        'Youngs modulus': '528 GPa',
        'Metallic radius': 1.357,
        iupac_ordering: 65,
        'IUPAC ordering': 65,
        'Ground level': '4F9/2',
        'Ionization energies': [
            8.96702, 17, 28, 40, 57, 72, 89, 105, 122.7, 194.8, 217, 240, 264, 303, 329, 356, 407, 445, 472, 510, 560,
            610, 670, 720, 770, 820, 870, 920, 980, 1030, 1080, 1331, 1381, 1436, 1493, 1548, 1603, 1684, 1739, 1801,
            1857, 2083, 2139, 2201, 2258, 2435, 2500, 2656, 2720.4, 4540, 4668, 4806, 4952, 5092, 5229, 5466, 5609,
            5765, 5910, 6315, 6441, 6580, 6708, 7274, 7421, 7710, 7850, 17040, 17390, 17770, 18120, 20210, 20650, 21200,
            21556.6, 86438.9, 88113.3,
        ],
        'Electron affinity': 1.5643615,
        symbol: 'Ir',
    },
    {
        'Atomic mass': 195.084,
        'Atomic no': 78,
        'Atomic orbitals': {
            '1s': -2613.096532,
            '2p': -417.96053,
            '2s': -434.858003,
            '3d': -78.400271,
            '3p': -93.309108,
            '3s': -101.274869,
            '4d': -11.419476,
            '4f': -3.038049,
            '4p': -17.697297,
            '4s': -21.110651,
            '5d': -0.273634,
            '5p': -1.884256,
            '5s': -2.950526,
            '6s': -0.161308,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.77,
        'Boiling point': '4098 K',
        'Brinell hardness': '392 MN m<sup>-2</sup>',
        'Bulk modulus': '230 GPa',
        'Coefficient of linear thermal expansion': '8.8 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '21090 kg m<sup>-3</sup>',
        'Electrical resistivity': '10.6 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>9</sup>.6s<sup>1</sup>',
        'Ionic radii': { '2': 0.94, '4': 0.765, '5': 0.71 },
        'Liquid range': '2056.6 K',
        'Melting point': '2041.4 K',
        'Mendeleev no': 68,
        'Mineral hardness': '3.5',
        'Molar volume': '9.09 cm<sup>3</sup>',
        Name: 'Platinum',
        'Oxidation states': [-2, 2, 4, 5, 6],
        'Poissons ratio': '0.38',
        Reflectivity: '73 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '61 GPa',
        'Shannon radii': {
            '2': {
                IVSQ: { '': { crystal_radius: 0.74, ionic_radius: 0.6 } },
                VI: { '': { crystal_radius: 0.94, ionic_radius: 0.8 } },
            },
            '4': { VI: { '': { crystal_radius: 0.765, ionic_radius: 0.625 } } },
            '5': { VI: { '': { crystal_radius: 0.71, ionic_radius: 0.57 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '72 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.13,
        'Velocity of sound': '2680 m s<sup>-1</sup>',
        'Vickers hardness': '549 MN m<sup>-2</sup>',
        X: 2.28,
        'Youngs modulus': '168 GPa',
        'Metallic radius': 1.387,
        iupac_ordering: 68,
        'IUPAC ordering': 68,
        'Ground level': '3D3',
        'Ionization energies': [
            8.95883, 18.56, 29, 43, 56, 75, 91, 109, 126, 144.9, 220.4, 245, 269, 293, 332, 358, 392, 445, 479, 507,
            550, 610, 660, 710, 760, 820, 870, 930, 980, 1040, 1090, 1140, 1402, 1454, 1509, 1567, 1624, 1680, 1763,
            1821, 1883, 1941, 2171, 2228, 2291, 2350, 2536, 2603, 2762, 2827.8, 4715, 4839, 4980, 5128, 5270, 5410,
            5654, 5800, 5959, 6106, 6517, 6646, 6787, 6918, 7512, 7660, 7960, 8100, 17540, 17890, 18280, 18630, 20840,
            21280, 21840, 22205.7, 88955.18, 90659.7,
        ],
        'Electron affinity': 2.125105,
        symbol: 'Pt',
    },
    {
        'Atomic mass': 196.966569,
        'Atomic no': 79,
        'Atomic orbitals': {
            '1s': -2683.508245,
            '2p': -430.725701,
            '2s': -447.888973,
            '3d': -81.511751,
            '3p': -96.707,
            '3s': -104.824516,
            '4d': -12.131815,
            '4f': -3.486824,
            '4p': -18.578652,
            '4s': -22.078357,
            '5d': -0.304738,
            '5p': -2.002495,
            '5s': -3.113936,
            '6s': -0.162334,
        },
        'Atomic radius': 1.35,
        'Atomic radius calculated': 1.74,
        'Boiling point': '3129 K',
        'Brinell hardness': '2450 MN m<sup>-2</sup>',
        'Bulk modulus': '220 GPa',
        'Coefficient of linear thermal expansion': '14.2 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '19300 kg m<sup>-3</sup>',
        'Electrical resistivity': '2.2 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>10</sup>.6s<sup>1</sup>',
        'Ionic radii': { '1': 1.51, '3': 0.99, '5': 0.71 },
        'Liquid range': '1791.67 K',
        'Melting point': '1337.33 K',
        'Mendeleev no': 70,
        'Mineral hardness': '2.5',
        'Molar volume': '10.21 cm<sup>3</sup>',
        Name: 'Gold',
        'Oxidation states': [-1, 1, 2, 3, 5],
        'Poissons ratio': '0.44',
        Reflectivity: '95 %',
        'Refractive index': 'no data',
        'Rigidity modulus': '27 GPa',
        'Shannon radii': {
            '1': { VI: { '': { crystal_radius: 1.51, ionic_radius: 1.37 } } },
            '3': {
                IVSQ: { '': { crystal_radius: 0.82, ionic_radius: 0.68 } },
                VI: { '': { crystal_radius: 0.99, ionic_radius: 0.85 } },
            },
            '5': { VI: { '': { crystal_radius: 0.71, ionic_radius: 0.57 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '320 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.14,
        'Velocity of sound': '1740 m s<sup>-1</sup>',
        'Vickers hardness': '216 MN m<sup>-2</sup>',
        X: 2.54,
        'Youngs modulus': '78 GPa',
        'Metallic radius': 1.442,
        iupac_ordering: 71,
        'IUPAC ordering': 71,
        'Ground level': '2S1/2',
        'Ionization energies': [
            9.225554, 20.203, 30, 45, 60, 74, 94, 112, 130.1, 149, 168.2, 248, 275, 299, 324, 365, 392, 433, 487, 520,
            550, 600, 650, 710, 760, 820, 870, 930, 990, 1040, 1100, 1150, 1210, 1475, 1527, 1584, 1644, 1702, 1758,
            1845, 1904, 1967, 2026, 2261, 2320, 2383, 2443, 2640, 2708, 2870, 2941, 4888, 5013, 5156, 5307, 5452, 5594,
            5846, 5994, 6156, 6305, 6724, 6854, 6997, 7130, 7760, 7910, 8210, 8360, 18040, 18400, 18790, 19150, 21470,
            21920, 22500, 22868.1, 91515.82, 93254.3,
        ],
        'Electron affinity': 2.30861025,
        symbol: 'Au',
    },
    {
        'Atomic mass': 200.59,
        'Atomic no': 80,
        'Atomic orbitals': {
            '1s': -2755.022637,
            '2p': -443.848676,
            '2s': -461.27864,
            '3d': -84.845492,
            '3p': -100.328031,
            '3s': -108.597921,
            '4d': -13.019221,
            '4f': -4.110291,
            '4p': -19.636187,
            '4s': -23.222921,
            '5d': -0.452552,
            '5p': -2.261975,
            '5s': -3.423486,
            '6s': -0.205137,
        },
        'Atomic radius': 1.5,
        'Atomic radius calculated': 1.71,
        'Boiling point': '629.88 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': '25 GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1, 2],
        'Critical temperature': '1750 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': '96 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>10</sup>.6s<sup>2</sup>',
        'ICSD oxidation states': [1, 2],
        'Ionic radii': { '1': 1.33, '2': 1.16 },
        'Liquid range': '395.56 K',
        'Melting point': '234.32 K',
        'Mendeleev no': 74,
        'Mineral hardness': '1.5',
        'Molar volume': '14.09 cm<sup>3</sup>',
        Name: 'Mercury',
        'Oxidation states': [1, 2, 4],
        'Poissons ratio': 'no data',
        Reflectivity: '73 %',
        'Refractive index': '1.000933',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '1': {
                III: { '': { crystal_radius: 1.11, ionic_radius: 0.97 } },
                VI: { '': { crystal_radius: 1.33, ionic_radius: 1.19 } },
            },
            '2': {
                II: { '': { crystal_radius: 0.83, ionic_radius: 0.69 } },
                IV: { '': { crystal_radius: 1.1, ionic_radius: 0.96 } },
                VI: { '': { crystal_radius: 1.16, ionic_radius: 1.02 } },
                VIII: { '': { crystal_radius: 1.28, ionic_radius: 1.14 } },
            },
        },
        'Superconduction temperature': '3.95 K',
        'Thermal conductivity': '8.3 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.23,
        'Velocity of sound': '1407 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'Hg-201': 387.6 },
        'Metallic radius': 1.51,
        iupac_ordering: 74,
        'IUPAC ordering': 74,
        'Ground level': '1S0',
        'Ionization energies': [
            10.437504, 18.75688, 34.49, 48.55, 61.2, 76.6, 93, 113.9, 134, 153, 173, 192.7, 276.9, 307, 332, 357, 402,
            429, 477, 530, 560, 590, 650, 710, 760, 820, 880, 930, 990, 1050, 1110, 1160, 1220, 1280, 1549, 1603, 1661,
            1723, 1780, 1839, 1928, 1989, 2052, 2113, 2354, 2412, 2478, 2539, 2745, 2815, 2981, 3049.9, 5055, 5191,
            5335, 5490, 5636, 5780, 6041, 6192, 6356, 6508, 6933, 7066, 7211, 7350, 8010, 8160, 8470, 8620, 18550,
            18910, 19310, 19680, 22120, 22580, 23170, 23544.1, 94124.7, 95897.7,
        ],
        'Electron affinity': -0.52,
        symbol: 'Hg',
    },
    {
        'Atomic mass': 204.3833,
        'Atomic no': 81,
        'Atomic orbitals': {
            '1s': -2827.569408,
            '2p': -457.255971,
            '2s': -474.953368,
            '3d': -88.328299,
            '3p': -104.099296,
            '3s': -112.52218,
            '4d': -14.008848,
            '4f': -4.835747,
            '4p': -20.797078,
            '4s': -24.471512,
            '5d': -0.674544,
            '5p': -2.59873,
            '5s': -3.811512,
            '6p': -0.101507,
            '6s': -0.28502,
        },
        'Atomic radius': 1.9,
        'Atomic radius calculated': 1.56,
        'Boiling point': '1746 K',
        'Brinell hardness': '26.4 MN m<sup>-2</sup>',
        'Bulk modulus': '43 GPa',
        'Coefficient of linear thermal expansion': '29.9 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1, 3],
        'Critical temperature': 'no data K',
        'Density of solid': '11850 kg m<sup>-3</sup>',
        'Electrical resistivity': '15 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>10</sup>.6s<sup>2</sup>.6p<sup>1</sup>',
        'ICSD oxidation states': [1, 3],
        'Ionic radii': { '1': 1.64, '3': 1.025 },
        'Liquid range': '1169 K',
        'Melting point': '577 K',
        'Mendeleev no': 78,
        'Mineral hardness': '1.2',
        'Molar volume': '17.22 cm<sup>3</sup>',
        Name: 'Thallium',
        'Oxidation states': [1, 3],
        'Poissons ratio': '0.45',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '2.8 GPa',
        'Shannon radii': {
            '1': {
                VI: { '': { crystal_radius: 1.64, ionic_radius: 1.5 } },
                VIII: { '': { crystal_radius: 1.73, ionic_radius: 1.59 } },
                XII: { '': { crystal_radius: 1.84, ionic_radius: 1.7 } },
            },
            '3': {
                IV: { '': { crystal_radius: 0.89, ionic_radius: 0.75 } },
                VI: { '': { crystal_radius: 1.025, ionic_radius: 0.885 } },
                VIII: { '': { crystal_radius: 1.12, ionic_radius: 0.98 } },
            },
        },
        'Superconduction temperature': '2.38 K',
        'Thermal conductivity': '46 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.96,
        'Velocity of sound': '818 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.62,
        'Youngs modulus': '8 GPa',
        'Metallic radius': 1.7,
        iupac_ordering: 77,
        'IUPAC ordering': 77,
        'Ground level': '2P°1/2',
        'Ionization energies': [
            6.1082873, 20.4283, 29.852, 51.14, 62.6, 80, 97.9, 116, 135, 158, 177, 198, 218.3, 306.9, 340, 366, 392,
            439, 467, 520, 570, 600, 640, 700, 760, 820, 880, 930, 990, 1060, 1110, 1170, 1230, 1290, 1350, 1625, 1681,
            1740, 1802, 1862, 1920, 2014, 2075, 2140, 2202, 2447, 2508, 2574, 2635, 2854, 2925, 3094, 3164.7, 5234,
            5371, 5518, 5674, 5824, 5969, 6241, 6392, 6560, 6714, 7146, 7281, 7430, 7570, 8260, 8420, 8730, 8880, 19070,
            19440, 19840, 20210, 22780, 23250, 23850, 24234.1, 96783.21, 98591.6,
        ],
        'Electron affinity': 0.32005319,
        symbol: 'Tl',
    },
    {
        'Atomic mass': 207.2,
        'Atomic no': 82,
        'Atomic orbitals': {
            '1s': -2901.078061,
            '2p': -470.877785,
            '2s': -488.843335,
            '3d': -91.889924,
            '3p': -107.950391,
            '3s': -116.526852,
            '4d': -15.030026,
            '4f': -5.592532,
            '4p': -21.990564,
            '4s': -25.75333,
            '5d': -0.902393,
            '5p': -2.941657,
            '5s': -4.206797,
            '6p': -0.141831,
            '6s': -0.357187,
        },
        'Atomic radius': 1.8,
        'Atomic radius calculated': 1.54,
        'Boiling point': '2022 K',
        'Brinell hardness': '38.3 MN m<sup>-2</sup>',
        'Bulk modulus': '46 GPa',
        'Coefficient of linear thermal expansion': '28.9 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '11340 kg m<sup>-3</sup>',
        'Electrical resistivity': '21 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>10</sup>.6s<sup>2</sup>.6p<sup>2</sup>',
        'ICSD oxidation states': [2, 4],
        'Ionic radii': { '2': 1.33, '4': 0.915 },
        'Liquid range': '1421.39 K',
        'Melting point': '600.61 K',
        'Mendeleev no': 82,
        'Mineral hardness': '1.5',
        'Molar volume': '18.26 cm<sup>3</sup>',
        Name: 'Lead',
        'Oxidation states': [-4, 2, 4],
        'Poissons ratio': '0.44',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '5.6 GPa',
        'Shannon radii': {
            '2': {
                IVPY: { '': { crystal_radius: 1.12, ionic_radius: 0.98 } },
                VI: { '': { crystal_radius: 1.33, ionic_radius: 1.19 } },
                VII: { '': { crystal_radius: 1.37, ionic_radius: 1.23 } },
                VIII: { '': { crystal_radius: 1.43, ionic_radius: 1.29 } },
                IX: { '': { crystal_radius: 1.49, ionic_radius: 1.35 } },
                X: { '': { crystal_radius: 1.54, ionic_radius: 1.4 } },
                XI: { '': { crystal_radius: 1.59, ionic_radius: 1.45 } },
                XII: { '': { crystal_radius: 1.63, ionic_radius: 1.49 } },
            },
            '4': {
                IV: { '': { crystal_radius: 0.79, ionic_radius: 0.65 } },
                V: { '': { crystal_radius: 0.87, ionic_radius: 0.73 } },
                VI: { '': { crystal_radius: 0.915, ionic_radius: 0.775 } },
                VIII: { '': { crystal_radius: 1.08, ionic_radius: 0.94 } },
            },
        },
        'Superconduction temperature': '7.2 K',
        'Thermal conductivity': '35 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.02,
        'Velocity of sound': '1260 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.33,
        'Youngs modulus': '16 GPa',
        'Metallic radius': 1.75,
        iupac_ordering: 82,
        'IUPAC ordering': 82,
        'Ground level': '1/2,1/2)0',
        'Ionization energies': [
            7.4166799, 15.032499, 31.9373, 42.33256, 68.8, 82.9, 100.1, 120, 138, 158, 182, 203, 224, 245.1, 338.1, 374,
            401, 427, 478, 507, 570, 610, 650, 690, 750, 810, 870, 930, 990, 1050, 1120, 1180, 1240, 1300, 1360, 1430,
            1704, 1760, 1819, 1884, 1945, 2004, 2101, 2163, 2230, 2292, 2543, 2605, 2671, 2735, 2965, 3036, 3211,
            3282.1, 5414, 5555, 5703, 5862, 6015, 6162, 6442, 6597, 6767, 6924, 7362, 7500, 7650, 7790, 8520, 8680,
            9000, 9150, 19590, 19970, 20380, 20750, 23460, 23940, 24550, 24938.2, 99491.85, 101336.4,
        ],
        'Electron affinity': 0.3567212,
        symbol: 'Pb',
    },
    {
        'Atomic mass': 208.9804,
        'Atomic no': 83,
        'Atomic orbitals': {
            '1s': -2975.550959,
            '2p': -484.716359,
            '2s': -502.950758,
            '3d': -95.532476,
            '3p': -111.883393,
            '3s': -120.613998,
            '4d': -16.084817,
            '4f': -6.382744,
            '4p': -23.218641,
            '4s': -27.07034,
            '5d': -1.139408,
            '5p': -3.293637,
            '5s': -4.611934,
            '6p': -0.180198,
            '6s': -0.426129,
        },
        'Atomic radius': 1.6,
        'Atomic radius calculated': 1.43,
        'Boiling point': '1837 K',
        'Brinell hardness': '94.2 MN m<sup>-2</sup>',
        'Bulk modulus': '31 GPa',
        'Coefficient of linear thermal expansion': '13.4 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '9780 kg m<sup>-3</sup>',
        'Electrical resistivity': '130 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>10</sup>.6s<sup>2</sup>.6p<sup>3</sup>',
        'ICSD oxidation states': [1, 2, 3, 5],
        'Ionic radii': { '3': 1.17, '5': 0.9 },
        'Liquid range': '1292.6 K',
        'Melting point': '544.4 K',
        'Mendeleev no': 87,
        'Mineral hardness': '2.25',
        'Molar volume': '21.31 cm<sup>3</sup>',
        Name: 'Bismuth',
        'Oxidation states': [-3, 3, 5],
        'Poissons ratio': '0.33',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '12 GPa',
        'Shannon radii': {
            '3': {
                V: { '': { crystal_radius: 1.1, ionic_radius: 0.96 } },
                VI: { '': { crystal_radius: 1.17, ionic_radius: 1.03 } },
                VIII: { '': { crystal_radius: 1.31, ionic_radius: 1.17 } },
            },
            '5': { VI: { '': { crystal_radius: 0.9, ionic_radius: 0.76 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '8 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.07,
        'Velocity of sound': '1790 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.02,
        'Youngs modulus': '32 GPa',
        'Metallic radius': 1.82,
        iupac_ordering: 87,
        'IUPAC ordering': 87,
        'Ground level': '4S°3/2',
        'Ionization energies': [
            7.285516, 16.703, 25.57075, 45.37, 54.856, 88.4, 103, 122, 143, 161.1, 183, 208, 229, 252, 272.6, 370.2,
            409, 436, 464, 520, 550, 620, 660, 690, 750, 810, 870, 930, 990, 1060, 1120, 1180, 1250, 1310, 1380, 1440,
            1500, 1784, 1840, 1902, 1967, 2029, 2090, 2190, 2253, 2321, 2385, 2641, 2703, 2771, 2835, 3078, 3151, 3329,
            3401.8, 5599, 5740, 5892, 6054, 6208, 6358, 6648, 6804, 6977, 7137, 7580, 7720, 7870, 8010, 8780, 8950,
            9270, 9430, 20130, 20500, 20920, 21300, 24150, 24640, 25260, 25656.9, 102251.76, 104132.8,
        ],
        'Electron affinity': 0.94236213,
        symbol: 'Bi',
    },
    {
        'Atomic mass': 210,
        'Atomic no': 84,
        'Atomic orbitals': {
            '1s': -3050.988417,
            '2p': -498.77192,
            '2s': -517.275843,
            '3d': -99.256068,
            '3p': -115.898384,
            '3s': -124.783683,
            '4d': -17.173307,
            '4f': -7.206499,
            '4p': -24.481337,
            '4s': -28.42254,
            '5d': -1.386458,
            '5p': -3.655382,
            '5s': -5.027447,
            '6p': -0.217889,
            '6s': -0.493528,
        },
        'Atomic radius': 1.9,
        'Atomic radius calculated': 1.35,
        'Boiling point': '1235 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-2, 2, 4],
        'Critical temperature': 'no data K',
        'Density of solid': '9196 kg m<sup>-3</sup>',
        'Electrical resistivity': '40 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>10</sup>.6s<sup>2</sup>.6p<sup>4</sup>',
        'Ionic radii': { '4': 1.08, '6': 0.81 },
        'Liquid range': '708 K',
        'Melting point': '527 K',
        'Mendeleev no': 91,
        'Mineral hardness': 'no data',
        'Molar volume': '22.97 cm<sup>3</sup>',
        Name: 'Polonium',
        'Oxidation states': [-2, 2, 4, 6],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '4': {
                VI: { '': { crystal_radius: 1.08, ionic_radius: 0.94 } },
                VIII: { '': { crystal_radius: 1.22, ionic_radius: 1.08 } },
            },
            '6': { VI: { '': { crystal_radius: 0.81, ionic_radius: 0.67 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '20 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 1.97,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.53,
        iupac_ordering: 93,
        'IUPAC ordering': 93,
        'Ground level': '3P2',
        'Ionization energies': [
            8.41807, 19.3, 27.3, 36, 57, 69.1, 108, 125, 146.1, 166, 186, 209, 235, 257, 281, 304, 416, 444, 473, 502,
            560, 590, 670, 700, 740, 800, 870, 930, 990, 1060, 1120, 1180, 1250, 1320, 1380, 1440, 1510, 1570, 1865,
            1923, 1986, 2052, 2115, 2177, 2281, 2345, 2414, 2480, 2740, 2803, 2873, 2938, 3194, 3268, 3450, 3524.2,
            5785, 5930, 6084, 6248, 6405, 6557, 6856, 7015, 7191, 7350, 7810, 7950, 8100, 8240, 9050, 9220, 9550, 9710,
            20670, 21050, 21470, 21860, 24860, 25360, 25990, 26390.4, 105064.3, 106982.7,
        ],
        'Electron affinity': 1.407,
        symbol: 'Po',
    },
    {
        'Atomic mass': 210,
        'Atomic no': 85,
        'Atomic orbitals': {
            '1s': -3127.390276,
            '2p': -513.044243,
            '2s': -531.81835,
            '3d': -103.060375,
            '3p': -119.995013,
            '3s': -129.035542,
            '4d': -18.295162,
            '4f': -8.063483,
            '4p': -25.778264,
            '4s': -29.809515,
            '5d': -1.643758,
            '5p': -4.027061,
            '5s': -5.453383,
            '6p': -0.255453,
            '6s': -0.560189,
        },
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [-1, 1],
        'Critical temperature': 'no data K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>10</sup>.6s<sup>2</sup>.6p<sup>5</sup>',
        'Ionic radii': { '7': 0.76 },
        'Liquid range': 'no data K',
        'Melting point': '575 K',
        'Mendeleev no': 96,
        'Mineral hardness': 'no data',
        'Molar volume': 'no data cm<sup>3</sup>',
        Name: 'Astatine',
        'Oxidation states': [-1, 1, 3, 5],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': { '7': { VI: { '': { crystal_radius: 0.76, ionic_radius: 0.62 } } } },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '2 (estimate)W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.02,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.2,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 98,
        'IUPAC ordering': 98,
        'Ground level': '2P°3/2',
        'Ionization energies': [
            9.31751, 17.88, 26.58, 39.65, 50.39, 72, 85.1, 130.1, 149, 169, 192.1, 212, 236, 263, 287, 311, 335, 452,
            481, 510, 540, 600, 630, 720, 750, 790, 860, 920, 990, 1050, 1120, 1180, 1250, 1320, 1380, 1450, 1510, 1590,
            1650, 1948, 2007, 2071, 2139, 2203, 2266, 2373, 2439, 2510, 2576, 2841, 2905, 2977, 3042, 3312, 3388, 3573,
            3649, 5976, 6122, 6279, 6445, 6604, 6759, 7068, 7230, 7410, 7570, 8030, 8180, 8330, 8480, 9330, 9500, 9830,
            9990, 21210, 21600, 22030, 22420, 25580, 26090, 26730, 27139, 107923.4, 109886,
        ],
        'Electron affinity': 2.415787,
        symbol: 'At',
    },
    {
        'Atomic mass': 220,
        'Atomic no': 86,
        'Atomic orbitals': {
            '1s': -3204.756288,
            '2p': -527.533025,
            '2s': -546.57796,
            '3d': -106.945006,
            '3p': -124.172862,
            '3s': -133.369144,
            '4d': -19.449994,
            '4f': -8.953318,
            '4p': -27.108985,
            '4s': -31.230804,
            '5d': -1.911329,
            '5p': -4.408702,
            '5s': -5.889683,
            '6p': -0.29318,
            '6s': -0.62657,
        },
        'Atomic radius': 'no data',
        'Atomic radius calculated': 1.2,
        'Boiling point': '211.3 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Critical temperature': '377 K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Xe].4f<sup>14</sup>.5d<sup>10</sup>.6s<sup>2</sup>.6p<sup>6</sup>',
        'Liquid range': '9.3 K',
        'Max oxidation state': 0,
        'Melting point': '202 K',
        'Mendeleev no': 6,
        'Min oxidation state': 0,
        'Mineral hardness': 'no data',
        'Molar volume': '50.50 cm<sup>3</sup>',
        Name: 'Radon',
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '0.00361 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.2,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 2.2,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 0,
        'IUPAC ordering': 0,
        'Ground level': '1S0',
        'Ionization energies': [
            10.7485, 21.4, 29.4, 36.9, 52.9, 64, 88, 102, 154, 173.9, 195, 218, 240, 264, 293, 317, 342, 367, 488, 520,
            550, 580, 640, 680, 760, 800, 850, 920, 980, 1050, 1110, 1180, 1250, 1310, 1390, 1460, 1520, 1590, 1660,
            1720, 2033, 2094, 2158, 2227, 2293, 2357, 2467, 2535, 2606, 2674, 2944, 3010, 3082, 3149, 3433, 3510, 3699,
            3777, 6169, 6318, 6476, 6646, 6807, 6964, 7283, 7450, 7630, 7800, 8260, 8410, 8570, 8710, 9610, 9780, 10120,
            10290, 21770, 22160, 22600, 22990, 26310, 26830, 27490, 27903.1, 110842, 112843.7,
        ],
        'Electron affinity': -0.72,
        symbol: 'Rn',
    },
    {
        'Atomic mass': 223,
        'Atomic no': 87,
        'Atomic orbitals': {
            '1s': -3283.263399,
            '2p': -542.41424,
            '2s': -561.73045,
            '3d': -111.085223,
            '3p': -128.607136,
            '3s': -137.959632,
            '4d': -20.812462,
            '4f': -10.050648,
            '4p': -28.648131,
            '4s': -32.861013,
            '5d': -2.360991,
            '5p': -4.97328,
            '5s': -6.509516,
            '6p': -0.466197,
            '6s': -0.841848,
            '7s': -0.076176,
        },
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [1],
        'Critical temperature': 'no data K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].7s<sup>1</sup>',
        'Ionic radii': { '1': 1.94 },
        'Liquid range': 'no data K',
        'Melting point': 'maybe about 300 K',
        'Mendeleev no': 7,
        'Mineral hardness': 'no data',
        'Molar volume': 'no data cm<sup>3</sup>',
        Name: 'Francium',
        'Oxidation states': [1],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': { '1': { VI: { '': { crystal_radius: 1.94, ionic_radius: 1.8 } } } },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': 'no data W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 3.48,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.7,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 6,
        'IUPAC ordering': 6,
        'Ground level': '2S1/2',
        'Ionization energies': [
            4.0727411, 22.4, 33.5, 39.1, 50, 67, 80, 106, 120, 179, 200, 222.1, 245, 269, 293, 324, 349, 375, 400, 530,
            560, 590, 620, 690, 720, 810, 850, 910, 980, 1040, 1110, 1180, 1250, 1320, 1380, 1460, 1530, 1600, 1670,
            1740, 1810, 2119, 2182, 2247, 2317, 2384, 2450, 2564, 2631, 2706, 2774, 3049, 3115, 3190, 3257, 3556, 3635,
            3828, 3907, 6365, 6516, 6678, 6849, 7013, 7172, 7500, 7670, 7850, 8020, 8500, 8640, 8800, 8950, 9890, 10070,
            10420, 10590, 22330, 22730, 23170, 23570, 27060, 27590, 28260, 28683.4, 113817.2, 115859,
        ],
        'Electron affinity': 0.486,
        symbol: 'Fr',
    },
    {
        'Atomic mass': 226,
        'Atomic no': 88,
        'Atomic orbitals': {
            '1s': -3362.736563,
            '2p': -557.513214,
            '2s': -577.101208,
            '3d': -115.306476,
            '3p': -133.12325,
            '3s': -142.632426,
            '4d': -22.208125,
            '4f': -11.181066,
            '4p': -30.221208,
            '4s': -34.525628,
            '5d': -2.819853,
            '5p': -5.547203,
            '5s': -7.139137,
            '6p': -0.634674,
            '6s': -1.05135,
            '7s': -0.113732,
        },
        'Atomic radius': 2.15,
        'Atomic radius calculated': 'no data',
        'Boiling point': '2010 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [2],
        'Critical temperature': 'no data K',
        'Density of solid': '5000 kg m<sup>-3</sup>',
        'Electrical resistivity': '100 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].7s<sup>2</sup>',
        'Ionic radii': { '2': 1.62 },
        'Liquid range': '1037 K',
        'Melting point': '973 K',
        'Mendeleev no': 13,
        'Mineral hardness': 'no data',
        'Molar volume': '41.09 cm<sup>3</sup>',
        Name: 'Radium',
        'Oxidation states': [2],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '2': {
                VIII: { '': { crystal_radius: 1.62, ionic_radius: 1.48 } },
                XII: { '': { crystal_radius: 1.84, ionic_radius: 1.7 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '19 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.83,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 0.9,
        'Youngs modulus': 'no data GPa',
        'NMR Quadrupole Moment': { 'Ra-223': 1210.3 },
        'Metallic radius': 2.293,
        iupac_ordering: 12,
        'IUPAC ordering': 12,
        'Ground level': '1S0',
        'Ionization energies': [
            5.2784239, 10.14718, 31, 41, 52.9, 64, 82, 97, 124, 140, 204.9, 227, 250, 274, 299, 324, 356, 382, 409, 435,
            570, 600, 630, 660, 740, 770, 860, 900, 970, 1040, 1110, 1180, 1250, 1320, 1390, 1460, 1530, 1610, 1680,
            1750, 1820, 1880, 2208, 2271, 2338, 2409, 2477, 2544, 2662, 2731, 2806, 2876, 3155, 3224, 3298, 3368, 3682,
            3762, 3959, 4040, 6565, 6718, 6881, 7056, 7222, 7380, 7720, 7890, 8080, 8250, 8730, 8880, 9040, 9200, 10190,
            10360, 10720, 10890, 22900, 23300, 23750, 24160, 27830, 28370, 29050, 29479.8, 116848.7, 118931.3,
        ],
        'Electron affinity': 0.1,
        symbol: 'Ra',
    },
    {
        'Atomic mass': 227,
        'Atomic no': 89,
        'Atomic orbitals': {
            '1s': -3443.110367,
            '2p': -572.7627,
            '2s': -592.622878,
            '3d': -119.541743,
            '3p': -137.654394,
            '3s': -147.320716,
            '4d': -23.57061,
            '4f': -12.278225,
            '4p': -31.761846,
            '4s': -36.15826,
            '5d': -3.222752,
            '5p': -6.06511,
            '5s': -7.713078,
            '6d': -0.137786,
            '6p': -0.744524,
            '6s': -1.19698,
            '7s': -0.126551,
        },
        'Atomic radius': 1.95,
        'Atomic radius calculated': 'no data',
        'Boiling point': '3573 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '10070 kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].6d<sup>1</sup>.7s<sup>2</sup>',
        'Ionic radii': { '3': 1.26 },
        'Liquid range': '2250 K',
        'Melting point': '1323 K',
        'Mendeleev no': 48,
        'Mineral hardness': 'no data',
        'Molar volume': '22.55 cm<sup>3</sup>',
        Name: 'Actinium',
        'Oxidation states': [3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': { '3': { VI: { '': { crystal_radius: 1.26, ionic_radius: 1.12 } } } },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '12 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.47,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.1,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.878,
        iupac_ordering: 32,
        'IUPAC ordering': 32,
        'Ground level': '2D3/2',
        'Ionization energies': [
            5.380226, 11.75, 17.431, 44.8, 55, 67, 79, 98.9, 113.9, 143.9, 161.1, 233, 255, 279, 305, 330, 355, 390,
            416, 444, 470, 610, 640, 670, 710, 780, 820, 920, 950, 1030, 1100, 1170, 1240, 1310, 1380, 1460, 1530, 1610,
            1680, 1750, 1820, 1900, 1970, 2298, 2362, 2430, 2503, 2572, 2639, 2762, 2833, 2908, 2980, 3264, 3334, 3409,
            3479, 3811, 3893, 4093, 4175, 6767, 6923, 7088, 7265, 7430, 7600, 7950, 8120, 8310, 8480, 8970, 9120, 9290,
            9440, 10480, 10660, 11030, 11200, 23480, 23890, 24340, 24760, 28610, 29160, 29850, 30293.1, 119938.6,
            122062.9,
        ],
        'Electron affinity': 0.35,
        symbol: 'Ac',
    },
    {
        'Atomic mass': 232.03806,
        'Atomic no': 90,
        'Atomic orbitals': {
            '1s': -3524.439052,
            '2p': -588.218112,
            '2s': -608.350958,
            '3d': -123.846396,
            '3p': -142.25581,
            '3s': -152.079741,
            '4d': -24.955184,
            '4f': -13.397389,
            '4p': -33.325252,
            '4s': -37.814094,
            '5d': -3.625729,
            '5p': -6.58281,
            '5s': -8.287057,
            '6d': -0.172896,
            '6p': -0.846921,
            '6s': -1.333769,
            '7s': -0.135872,
        },
        'Atomic radius': 1.8,
        'Atomic radius calculated': 'no data',
        'Boiling point': '5093 K',
        'Brinell hardness': '400 MN m<sup>-2</sup>',
        'Bulk modulus': '54 GPa',
        'Coefficient of linear thermal expansion': '11.0 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4],
        'Critical temperature': 'no data K',
        'Density of solid': '11724 kg m<sup>-3</sup>',
        'Electrical resistivity': '15 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].6d<sup>2</sup>.7s<sup>2</sup>',
        'ICSD oxidation states': [4],
        'Ionic radii': { '4': 1.08 },
        'Liquid range': '2978 K',
        'Melting point': '2115 K',
        'Mendeleev no': 47,
        'Mineral hardness': '3.0',
        'Molar volume': '19.80 cm<sup>3</sup>',
        Name: 'Thorium',
        'Oxidation states': [2, 3, 4],
        'Poissons ratio': '0.27',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '31 GPa',
        'Shannon radii': {
            '4': {
                VI: { '': { crystal_radius: 1.08, ionic_radius: 0.94 } },
                VIII: { '': { crystal_radius: 1.19, ionic_radius: 1.05 } },
                IX: { '': { crystal_radius: 1.23, ionic_radius: 1.09 } },
                X: { '': { crystal_radius: 1.27, ionic_radius: 1.13 } },
                XI: { '': { crystal_radius: 1.32, ionic_radius: 1.18 } },
                XII: { '': { crystal_radius: 1.35, ionic_radius: 1.21 } },
            },
        },
        'Superconduction temperature': '1.38 K',
        'Thermal conductivity': '54 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.45,
        'Velocity of sound': '2490 m s<sup>-1</sup>',
        'Vickers hardness': '350 MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': '79 GPa',
        'Metallic radius': 1.798,
        iupac_ordering: 31,
        'IUPAC ordering': 31,
        'Ground level': '3F2',
        'Ionization energies': [
            6.3067, 12.1, 18.32, 28.648, 58, 69.1, 82, 95, 118, 133, 165, 181, 262, 285, 310, 336, 362, 389, 424, 451,
            480, 508, 650, 680, 720, 750, 830, 870, 970, 1010, 1090, 1160, 1240, 1310, 1380, 1460, 1530, 1600, 1680,
            1760, 1830, 1910, 1980, 2060, 2390, 2455, 2524, 2598, 2669, 2737, 2864, 2935, 3013, 3086, 3375, 3445, 3522,
            3593, 3943, 4025, 4230, 4313, 6972, 7130, 7299, 7480, 7650, 7810, 8180, 8350, 8550, 8720, 9220, 9370, 9540,
            9690, 10790, 10970, 11340, 11510, 24060, 24480, 24940, 25360, 29410, 29970, 30680, 31122.8, 123086.4,
            125253.4,
        ],
        'Electron affinity': 1.17,
        symbol: 'Th',
    },
    {
        'Atomic mass': 231.03588,
        'Atomic no': 91,
        'Atomic orbitals': {
            '1s': -3606.333629,
            '2p': -603.470278,
            '2s': -623.870431,
            '3d': -127.781168,
            '3p': -146.485678,
            '3s': -156.466742,
            '4d': -25.933121,
            '4f': -14.105747,
            '4p': -34.48293,
            '4s': -39.064507,
            '5d': -3.659928,
            '5f': -0.316813,
            '5p': -6.709821,
            '5s': -8.463463,
            '6d': -0.142481,
            '6p': -0.799756,
            '6s': -1.287232,
            '7s': -0.129653,
        },
        'Atomic radius': 1.8,
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [5],
        'Critical temperature': 'no data K',
        'Density of solid': '15370 kg m<sup>-3</sup>',
        'Electrical resistivity': '18 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>2</sup>.6d<sup>1</sup>.7s<sup>2</sup>',
        'Ionic radii': { '3': 1.16, '4': 1.04, '5': 0.92 },
        'Liquid range': 'no data K',
        'Melting point': '1841 K',
        'Mendeleev no': 46,
        'Mineral hardness': 'no data',
        'Molar volume': '15.18 cm<sup>3</sup>',
        Name: 'Protactinium',
        'Oxidation states': [3, 4, 5],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 1.18, ionic_radius: 1.04 } } },
            '4': {
                VI: { '': { crystal_radius: 1.04, ionic_radius: 0.9 } },
                VIII: { '': { crystal_radius: 1.15, ionic_radius: 1.01 } },
            },
            '5': {
                VI: { '': { crystal_radius: 0.92, ionic_radius: 0.78 } },
                VIII: { '': { crystal_radius: 1.05, ionic_radius: 0.91 } },
                IX: { '': { crystal_radius: 1.09, ionic_radius: 0.95 } },
            },
        },
        'Superconduction temperature': '1.4 K',
        'Thermal conductivity': '47 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.1,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.5,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.642,
        iupac_ordering: 30,
        'IUPAC ordering': 30,
        'Ground level': '4K11/2',
        'Ionization energies': [
            5.89, 11.9, 18.6, 30.9, 44.3, 72, 85.1, 98.9, 111, 137, 153, 187, 203, 292, 316, 342, 369, 395, 423, 460,
            488, 518, 546, 690, 720, 760, 790, 880, 920, 1020, 1060, 1150, 1220, 1300, 1370, 1450, 1520, 1600, 1670,
            1760, 1830, 1910, 1980, 2060, 2130, 2483, 2550, 2620, 2696, 2766, 2837, 2968, 3040, 3119, 3193, 3488, 3558,
            3637, 3709, 4077, 4161, 4370, 4454, 7181, 7341, 7510, 7690, 7870, 8040, 8410, 8590, 8780, 8960, 9460, 9620,
            9790, 9950, 11100, 11290, 11660, 11840, 24660, 25080, 25540, 25970, 30230, 30800, 31520, 31971.6, 126296.6,
            128507.1,
        ],
        'Electron affinity': 0.55,
        symbol: 'Pa',
    },
    {
        'Atomic mass': 238.02891,
        'Atomic no': 92,
        'Atomic orbitals': {
            '1s': -3689.355141,
            '2p': -619.10855,
            '2s': -639.778728,
            '3d': -131.977358,
            '3p': -150.97898,
            '3s': -161.118073,
            '4d': -27.123212,
            '4f': -15.02746,
            '4p': -35.853321,
            '4s': -40.528084,
            '5d': -3.866175,
            '5f': -0.366543,
            '5p': -7.018092,
            '5s': -8.824089,
            '6d': -0.14319,
            '6p': -0.822538,
            '6s': -1.325976,
            '7s': -0.130948,
        },
        'Atomic radius': 1.75,
        'Atomic radius calculated': 'no data',
        'Boiling point': '4200 K',
        'Brinell hardness': '2400 MN m<sup>-2</sup>',
        'Bulk modulus': '100 GPa',
        'Coefficient of linear thermal expansion': '13.9 x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [6],
        'Critical temperature': 'no data K',
        'Density of solid': '19050 kg m<sup>-3</sup>',
        'Electrical resistivity': '28 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>3</sup>.6d<sup>1</sup>.7s<sup>2</sup>',
        'ICSD oxidation states': [3, 4, 5, 6],
        'Ionic radii': { '3': 1.165, '4': 1.03, '5': 0.9, '6': 0.87 },
        'Liquid range': '2794.7 K',
        'Melting point': '1405.3 K',
        'Mendeleev no': 45,
        'Mineral hardness': '6.0',
        'Molar volume': '12.49 cm<sup>3</sup>',
        Name: 'Uranium',
        'Oxidation states': [3, 4, 5, 6],
        'Poissons ratio': '0.23',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '111 GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 1.165, ionic_radius: 1.025 } } },
            '4': {
                VI: { '': { crystal_radius: 1.03, ionic_radius: 0.89 } },
                VII: { '': { crystal_radius: 1.09, ionic_radius: 0.95 } },
                VIII: { '': { crystal_radius: 1.14, ionic_radius: 1 } },
                IX: { '': { crystal_radius: 1.19, ionic_radius: 1.05 } },
                XII: { '': { crystal_radius: 1.31, ionic_radius: 1.17 } },
            },
            '5': {
                VI: { '': { crystal_radius: 0.9, ionic_radius: 0.76 } },
                VII: { '': { crystal_radius: 0.98, ionic_radius: 0.84 } },
            },
            '6': {
                II: { '': { crystal_radius: 0.59, ionic_radius: 0.45 } },
                IV: { '': { crystal_radius: 0.66, ionic_radius: 0.52 } },
                VI: { '': { crystal_radius: 0.87, ionic_radius: 0.73 } },
                VII: { '': { crystal_radius: 0.95, ionic_radius: 0.81 } },
                VIII: { '': { crystal_radius: 1, ionic_radius: 0.86 } },
            },
        },
        'Superconduction temperature': '0.2 K',
        'Thermal conductivity': '27 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.41,
        'Velocity of sound': '3155 m s<sup>-1</sup>',
        'Vickers hardness': '1960 MN m<sup>-2</sup>',
        X: 1.38,
        'Youngs modulus': '208 GPa',
        'Metallic radius': 1.542,
        iupac_ordering: 29,
        'IUPAC ordering': 29,
        'Ground level': '5L°6',
        'Ionization energies': [
            6.19405, 11.6, 19.8, 36.7, 46, 62, 89, 101, 116, 128.9, 158, 173, 210, 227, 323, 348, 375, 402, 431, 458,
            497, 525, 557, 585, 730, 770, 800, 840, 930, 970, 1070, 1110, 1210, 1290, 1370, 1440, 1520, 1590, 1670,
            1750, 1830, 1910, 1990, 2070, 2140, 2220, 2578, 2646, 2718, 2794, 2867, 2938, 3073, 3147, 3228, 3301, 3602,
            3675, 3753, 3827, 4214, 4299, 4513, 4598, 7393, 7550, 7730, 7910, 8090, 8260, 8650, 8830, 9030, 9210, 9720,
            9870, 10040, 10200, 11410, 11600, 11990, 12160, 25260, 25680, 26150, 26590, 31060, 31640, 32400, 32836.5,
            129570.3, 131821,
        ],
        'Electron affinity': 0.53,
        symbol: 'U',
    },
    {
        'Atomic mass': 237,
        'Atomic no': 93,
        'Atomic orbitals': 'no data',
        'Atomic radius': 1.75,
        'Atomic radius calculated': 'no data',
        'Boiling point': '4273 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [5],
        'Critical temperature': 'no data K',
        'Density of solid': '20450 kg m<sup>-3</sup>',
        'Electrical resistivity': '120 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>4</sup>.6d<sup>1</sup>.7s<sup>2</sup>',
        'Ionic radii': { '2': 1.24, '3': 1.15, '4': 1.01, '5': 0.89, '6': 0.86, '7': 0.85 },
        'Liquid range': '3363 K',
        'Melting point': '910 K',
        'Mendeleev no': 44,
        'Mineral hardness': 'no data',
        'Molar volume': '11.59 cm<sup>3</sup>',
        Name: 'Neptunium',
        'Oxidation states': [3, 4, 5, 6, 7],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '2': { VI: { '': { crystal_radius: 1.24, ionic_radius: 1.1 } } },
            '3': { VI: { '': { crystal_radius: 1.15, ionic_radius: 1.01 } } },
            '4': {
                VI: { '': { crystal_radius: 1.01, ionic_radius: 0.87 } },
                VIII: { '': { crystal_radius: 1.12, ionic_radius: 0.98 } },
            },
            '5': { VI: { '': { crystal_radius: 0.89, ionic_radius: 0.75 } } },
            '6': { VI: { '': { crystal_radius: 0.86, ionic_radius: 0.72 } } },
            '7': { VI: { '': { crystal_radius: 0.85, ionic_radius: 0.71 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '6 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.39,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.36,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.503,
        iupac_ordering: 28,
        'IUPAC ordering': 28,
        'Ground level': '6L11/2',
        'Ionization energies': [
            6.26554, 11.5, 19.7, 33.8, 48, 65, 92, 107, 121, 136, 151, 179, 196, 233, 252, 355, 382, 408, 438, 466, 495,
            535, 565, 596, 626, 770, 810, 850, 880, 980, 1020, 1130, 1170, 1280, 1360, 1430, 1510, 1590, 1670, 1740,
            1820, 1910, 1990, 2070, 2140, 2230, 2310, 2675, 2745, 2817, 2894, 2969, 3041, 3181, 3255, 3338, 3413, 3718,
            3792, 3872, 3947, 4353, 4441, 4658, 4744, 7610, 7770, 7950, 8130, 8310, 8480, 8890, 9070, 9270, 9450, 9970,
            10130, 10300, 10470, 11730, 11930, 12320, 12500, 25870, 26300, 26770, 27210, 31910, 32500, 33300, 33722.2,
            132901.8, 135202,
        ],
        'Electron affinity': 0.48,
        symbol: 'Np',
    },
    {
        'Atomic mass': 244,
        'Atomic no': 94,
        'Atomic orbitals': 'no data',
        'Atomic radius': 1.75,
        'Atomic radius calculated': 'no data',
        'Boiling point': '3503 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [4],
        'Critical temperature': 'no data K',
        'Density of solid': '19816 kg m<sup>-3</sup>',
        'Electrical resistivity': '150 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>6</sup>.7s<sup>2</sup>',
        'Ionic radii': { '3': 1.14, '4': 1, '5': 0.88, '6': 0.85 },
        'Liquid range': '2590.5 K',
        'Melting point': '912.5 K',
        'Mendeleev no': 43,
        'Mineral hardness': 'no data',
        'Molar volume': '12.29 cm<sup>3</sup>',
        Name: 'Plutonium',
        'Oxidation states': [3, 4, 5, 6, 7],
        'Poissons ratio': '0.21',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': '43 GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 1.14, ionic_radius: 1 } } },
            '4': {
                VI: { '': { crystal_radius: 1, ionic_radius: 0.86 } },
                VIII: { '': { crystal_radius: 1.1, ionic_radius: 0.96 } },
            },
            '5': { VI: { '': { crystal_radius: 0.88, ionic_radius: 0.74 } } },
            '6': { VI: { '': { crystal_radius: 0.85, ionic_radius: 0.71 } } },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '6 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.43,
        'Velocity of sound': '2260 m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.28,
        'Youngs modulus': '96 GPa',
        'Metallic radius': 1.523,
        iupac_ordering: 27,
        'IUPAC ordering': 27,
        'Ground level': '7F0',
        'Ionization energies': [
            6.02576, 11.5, 21.1, 35, 49, 80, 95, 109, 124, 139, 159, 179, 200, 219, 258, 278, 389, 416, 444, 474, 503,
            532, 575, 605, 637, 668, 820, 850, 890, 930, 1030, 1070, 1180, 1220, 1340, 1420, 1500, 1580, 1660, 1740,
            1820, 1890, 1990, 2070, 2150, 2230, 2310, 2390, 2774, 2844, 2918, 2997, 3072, 3146, 3290, 3366, 3449, 3527,
            3836, 3911, 3993, 4068, 4496, 4585, 4807, 4890, 7830, 7990, 8170, 8360, 8540, 8710, 9130, 9310, 9520, 9700,
            10230, 10390, 10570, 10730, 12060, 12260, 12660, 12840, 26480, 26920, 27400, 27840, 32800, 33400, 34100,
            34625.8, 136299.2, 138646,
        ],
        'Electron affinity': -0.5,
        symbol: 'Pu',
    },
    {
        'Atomic mass': 243,
        'Atomic no': 95,
        'Atomic orbitals': 'no data',
        'Atomic radius': 1.75,
        'Atomic radius calculated': 'no data',
        'Boiling point': '2880 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>7</sup>.7s<sup>2</sup>',
        'Ionic radii': { '2': 1.4, '3': 1.115, '4': 0.99 },
        'Liquid range': '1431 K',
        'Melting point': '1449 K',
        'Mendeleev no': 42,
        'Mineral hardness': 'no data',
        'Molar volume': '17.63 cm<sup>3</sup>',
        Name: 'Americium',
        'Oxidation states': [2, 3, 4, 5, 6],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '2': {
                VII: { '': { crystal_radius: 1.35, ionic_radius: 1.21 } },
                VIII: { '': { crystal_radius: 1.4, ionic_radius: 1.26 } },
                IX: { '': { crystal_radius: 1.45, ionic_radius: 1.31 } },
            },
            '3': {
                VI: { '': { crystal_radius: 1.115, ionic_radius: 0.975 } },
                VIII: { '': { crystal_radius: 1.23, ionic_radius: 1.09 } },
            },
            '4': {
                VI: { '': { crystal_radius: 0.99, ionic_radius: 0.85 } },
                VIII: { '': { crystal_radius: 1.09, ionic_radius: 0.95 } },
            },
        },
        'Superconduction temperature': '0.6 K',
        'Thermal conductivity': '10 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.44,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.73,
        iupac_ordering: 26,
        'IUPAC ordering': 26,
        'Ground level': '8S°7/2',
        'Ionization energies': [
            5.97381, 11.7, 21.7, 36.8, 50, 67.9, 95, 110, 125, 141, 163, 184, 206, 225, 242, 284, 305, 424, 451, 481,
            511, 541, 571, 616, 646, 680, 711, 870, 900, 940, 980, 1090, 1130, 1240, 1280, 1410, 1490, 1570, 1650, 1730,
            1820, 1900, 1980, 2070, 2160, 2240, 2320, 2410, 2480, 2874, 2946, 3021, 3101, 3178, 3251, 3402, 3479, 3563,
            3641, 3956, 4033, 4115, 4191, 4642, 4733, 4960, 5050, 8040, 8210, 8390, 8590, 8770, 8950, 9380, 9560, 9770,
            9960, 10490, 10650, 10830, 11000, 12400, 12600, 13000, 13190, 27110, 27550, 28040, 28500, 33700, 34300,
            35100, 35549.4, 139769.5, 142161,
        ],
        'Electron affinity': 0.1,
        symbol: 'Am',
    },
    {
        'Atomic mass': 247,
        'Atomic no': 96,
        'Atomic orbitals': 'no data',
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': '3383 K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '13510 kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>7</sup>.6d<sup>1</sup>.7s<sup>2</sup>',
        'Ionic radii': { '3': 1.11, '4': 0.99 },
        'Liquid range': '1770 K',
        'Melting point': '1613 K',
        'Mendeleev no': 41,
        'Mineral hardness': 'no data',
        'Molar volume': '18.05 cm<sup>3</sup>',
        Name: 'Curium',
        'Oxidation states': [3, 4],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 1.11, ionic_radius: 0.97 } } },
            '4': {
                VI: { '': { crystal_radius: 0.99, ionic_radius: 0.85 } },
                VIII: { '': { crystal_radius: 1.09, ionic_radius: 0.95 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '8.8 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.45,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.743,
        iupac_ordering: 25,
        'IUPAC ordering': 25,
        'Ground level': '9D°2',
        'Ionization energies': [
            5.99141, 12.4, 20.1, 37.7, 51, 69.1, 97, 112, 128, 144, 167, 190, 213, 235, 253, 272, 311, 332, 460, 489,
            518, 550, 580, 611, 657, 689, 723, 755, 910, 950, 990, 1030, 1140, 1180, 1300, 1340, 1480, 1560, 1650, 1730,
            1810, 1890, 1980, 2060, 2160, 2240, 2320, 2410, 2490, 2580, 2976, 3050, 3125, 3207, 3284, 3360, 3515, 3593,
            3679, 3758, 4078, 4156, 4239, 4317, 4791, 4880, 5110, 5200, 8270, 8440, 8620, 8820, 9000, 9180, 9630, 9820,
            10020, 10220, 10760, 10920, 11100, 11270, 12740, 12950, 13350, 13550, 27740, 28180, 28700, 29100, 34600,
            35200, 36000, 36493, 143299.6, 145743,
        ],
        'Electron affinity': 0.28,
        symbol: 'Cm',
    },
    {
        'Atomic mass': 247,
        'Atomic no': 97,
        'Atomic orbitals': 'no data',
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '14780 kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>9</sup>.7s<sup>2</sup>',
        'Ionic radii': { '3': 1.1, '4': 0.97 },
        'Liquid range': 'no data K',
        'Melting point': '1259 K',
        'Mendeleev no': 40,
        'Mineral hardness': 'no data',
        'Molar volume': '16.84 cm<sup>3</sup>',
        Name: 'Berkelium',
        'Oxidation states': [3, 4],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 1.1, ionic_radius: 0.96 } } },
            '4': {
                VI: { '': { crystal_radius: 0.97, ionic_radius: 0.83 } },
                VIII: { '': { crystal_radius: 1.07, ionic_radius: 0.93 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': '10 W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.44,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.703,
        iupac_ordering: 24,
        'IUPAC ordering': 24,
        'Ground level': '6H°15/2',
        'Ionization energies': [
            6.19785, 11.9, 21.6, 36, 56, 70.1, 90, 114, 130, 147, 171, 195, 218, 240, 259, 279, 303, 339, 361, 497, 526,
            557, 590, 621, 652, 700, 733, 768, 800, 960, 1000, 1040, 1080, 1200, 1240, 1360, 1410, 1550, 1630, 1720,
            1800, 1890, 1970, 2050, 2140, 2240, 2320, 2410, 2490, 2580, 2670, 3080, 3154, 3232, 3315, 3393, 3469, 3630,
            3709, 3797, 3877, 4202, 4281, 4365, 4445, 4940, 5040, 5270, 5360, 8500, 8670, 8850, 9050, 9240, 9420, 9880,
            10070, 10280, 10480, 11020, 11190, 11380, 11550, 13090, 13300, 13720, 13910, 28380, 28800, 29300, 29800,
            35500, 36200, 37000, 37457.6, 146904.7, 149398,
        ],
        'Electron affinity': -1.72,
        symbol: 'Bk',
    },
    {
        'Atomic mass': 251,
        'Atomic no': 98,
        'Atomic orbitals': 'no data',
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': '15100 kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>10</sup>.7s<sup>2</sup>',
        'Ionic radii': { '3': 1.09, '4': 0.961 },
        'Liquid range': 'no data K',
        'Melting point': '1173 K',
        'Mendeleev no': 39,
        'Mineral hardness': 'no data',
        'Molar volume': '16.50 cm<sup>3</sup>',
        Name: 'Californium',
        'Oxidation states': [2, 3, 4],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': {
            '3': { VI: { '': { crystal_radius: 1.09, ionic_radius: 0.95 } } },
            '4': {
                VI: { '': { crystal_radius: 0.961, ionic_radius: 0.821 } },
                VIII: { '': { crystal_radius: 1.06, ionic_radius: 0.92 } },
            },
        },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': 'no data W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.45,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.86,
        iupac_ordering: 23,
        'IUPAC ordering': 23,
        'Ground level': '5I8',
        'Ionization energies': [
            6.28166, 12, 22.4, 37.7, 51.9, 75, 91, 112.9, 133, 152, 178, 201, 225, 247, 265, 286, 310, 334, 368, 390,
            536, 566, 597, 630, 662, 695, 744, 778, 814, 847, 1010, 1050, 1090, 1120, 1250, 1300, 1420, 1470, 1620,
            1700, 1790, 1880, 1960, 2050, 2130, 2220, 2320, 2410, 2490, 2580, 2670, 2750, 3186, 3261, 3340, 3424, 3503,
            3581, 3747, 3828, 3915, 3998, 4329, 4407, 4494, 4570, 5100, 5190, 5430, 5520, 8730, 8900, 9090, 9290, 9480,
            9660, 10140, 10330, 10550, 10740, 11300, 11470, 11650, 11820, 13450, 13660, 14080, 14280, 29000, 29500,
            30000, 30500, 36500, 37100, 37900, 38443.5, 150579.3, 153124,
        ],
        'Electron affinity': -1.01,
        symbol: 'Cf',
    },
    {
        'Atomic mass': 252,
        'Atomic no': 99,
        'Atomic orbitals': 'no data',
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>11</sup>.7s<sup>2</sup>',
        'Liquid range': 'no data K',
        'Melting point': '1133 K',
        'Mendeleev no': 38,
        'Mineral hardness': 'no data',
        'Molar volume': '28.52 cm<sup>3</sup>',
        Name: 'Einsteinium',
        'Oxidation states': [2, 3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': 'no data W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.45,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 1.86,
        iupac_ordering: 22,
        'IUPAC ordering': 22,
        'Ground level': '4I°15/2',
        'Ionization energies': [
            6.36758, 12.2, 22.7, 38.8, 54.1, 71, 97, 112.9, 137, 157, 180, 206, 231, 252, 270, 294, 317, 342, 367, 398,
            421, 576, 606, 638, 672, 705, 738, 790, 824, 861, 895, 1060, 1100, 1140, 1180, 1310, 1360, 1480, 1530, 1690,
            1780, 1870, 1950, 2040, 2130, 2220, 2300, 2410, 2490, 2580, 2680, 2760, 2850, 3294, 3370, 3449, 3535, 3616,
            3694, 3866, 3947, 4038, 4120, 4456, 4537, 4620, 4700, 5260, 5350, 5600, 5690, 8960, 9140, 9330, 9530, 9720,
            9910, 10400, 10590, 10810, 11010, 11570, 11740, 11930, 12110, 13810, 14030, 14460, 14700, 29700, 30100,
            30700, 31100, 37400, 38100, 38900, 39451.4, 154328.1, 156926,
        ],
        'Electron affinity': -0.3,
        symbol: 'Es',
    },
    {
        'Atomic mass': 257,
        'Atomic no': 100,
        'Atomic orbitals': 'no data',
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>12</sup>.7s<sup>2</sup>',
        'Liquid range': 'no data K',
        'Melting point': 'about 1800 K',
        'Mendeleev no': 37,
        'Mineral hardness': 'no data',
        'Molar volume': 'no data cm<sup>3</sup>',
        Name: 'Fermium',
        'Oxidation states': [2, 3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': 'no data W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.45,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 21,
        'IUPAC ordering': 21,
        'Ground level': '3H6',
        'Ionization energies': [
            6.5, 12.4, 23.2, 39.3, 55, 74, 93, 120, 136, 162, 185, 209, 237, 257, 276, 300, 326, 351, 377, 402, 430,
            453, 616, 647, 680, 716, 749, 782, 837, 871, 909, 944, 1110, 1150, 1190, 1230, 1370, 1420, 1550, 1600, 1770,
            1850, 1940, 2030, 2120, 2210, 2300, 2390, 2490, 2590, 2680, 2760, 2850, 2950, 3403, 3480, 3561, 3647, 3730,
            3810, 3986, 4070, 4160, 4245, 4586, 4670, 4760, 4840, 5420, 5510, 5760, 5860, 9200, 9370, 9570, 9770, 9970,
            10160, 10660, 10860, 11080, 11280, 11850, 12020, 12220, 12390, 14180, 14400, 14800, 15000, 30300, 30800,
            31300, 31800, 38400, 39100, 40000, 40482.2, 158152.5, 160804,
        ],
        'Electron affinity': 0.35,
        symbol: 'Fm',
    },
    {
        'Atomic mass': 258,
        'Atomic no': 101,
        'Atomic orbitals': 'no data',
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>13</sup>.7s<sup>2</sup>',
        'Liquid range': 'no data K',
        'Melting point': 'about 1100 K',
        'Mendeleev no': 36,
        'Mineral hardness': 'no data',
        'Molar volume': 'no data cm<sup>3</sup>',
        Name: 'Mendelevium',
        'Oxidation states': [2, 3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': 'no data W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.46,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 20,
        'IUPAC ordering': 20,
        'Ground level': '2F°7/2',
        'Ionization energies': [
            6.58,
            12.4,
            24.3,
            40,
            54.1,
            76,
            96,
            115.1,
            143.9,
            162,
            187,
            215,
            240,
            260,
            282,
            307,
            334,
            360,
            386,
            412,
            438,
            462,
            486,
            659,
            690,
            723,
            760,
            794,
            828,
            885,
            920,
            958,
            994,
            1160,
            1210,
            1250,
            1290,
            1430,
            1480,
            1620,
            1660,
            1840,
            1930,
            2020,
            2110,
            2200,
            2290,
            2390,
            2480,
            2580,
            2680,
            2760,
            2860,
            2950,
            3050,
            3513,
            3592,
            3675,
            3762,
            3845,
            3926,
            4109,
            4194,
            4286,
            4371,
            4720,
            4800,
            4890,
            4970,
            5580,
            5680,
            5930,
            6030,
            9430,
            9620,
            9810,
            10020,
            10220,
            10410,
            10930,
            11130,
            11350,
            11560,
            12130,
            12310,
            12500,
            12680,
            14560,
            14800,
            15200,
            15400,
            31000,
            31500,
            32000,
            32500,
            39500,
            40100,
            41000,
            41548,
            null,
            164764,
        ],
        'Electron affinity': 0.98,
        symbol: 'Md',
    },
    {
        'Atomic mass': 259,
        'Atomic no': 102,
        'Atomic orbitals': 'no data',
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>14</sup>.7s<sup>2</sup>',
        'Liquid range': 'no data K',
        'Melting point': 'about 1100 K',
        'Mendeleev no': 35,
        'Mineral hardness': 'no data',
        'Molar volume': 'no data cm<sup>3</sup>',
        Name: 'Nobelium',
        'Oxidation states': [2, 3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Shannon radii': { '2': { VI: { '': { crystal_radius: 1.24, ionic_radius: 1.1 } } } },
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': 'no data W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 2.46,
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 19,
        'IUPAC ordering': 19,
        'Ground level': '1S0',
        'Ionization energies': [
            6.62621,
            12.93,
            25.8,
            41.5,
            60,
            74,
            97,
            119,
            140,
            170,
            187,
            216,
            246,
            267,
            285,
            312,
            341,
            367,
            394,
            422,
            448,
            475,
            496,
            520,
            701,
            734,
            768,
            805,
            840,
            875,
            934,
            969,
            1010,
            1045,
            1220,
            1260,
            1300,
            1350,
            1500,
            1550,
            1680,
            1730,
            1920,
            2010,
            2110,
            2200,
            2290,
            2380,
            2470,
            2570,
            2680,
            2760,
            2860,
            2950,
            3050,
            3140,
            3627,
            3705,
            3790,
            3878,
            3962,
            4045,
            4234,
            4320,
            4413,
            4500,
            4850,
            4930,
            5030,
            5110,
            5750,
            5850,
            6110,
            6210,
            9680,
            9860,
            10060,
            10270,
            10470,
            10660,
            11200,
            11410,
            11630,
            11840,
            12420,
            12600,
            12800,
            12980,
            15000,
            15200,
            15600,
            15800,
            31700,
            32200,
            32700,
            33200,
            40500,
            41200,
            42100,
            42632,
            null,
            168806,
        ],
        'Electron affinity': -2.33,
        symbol: 'No',
    },
    {
        'Atomic mass': 262,
        'Atomic no': 103,
        'Atomic orbitals': 'no data',
        'Atomic radius': 'no data',
        'Atomic radius calculated': 'no data',
        'Boiling point': 'no data K',
        'Brinell hardness': 'no data MN m<sup>-2</sup>',
        'Bulk modulus': 'no data GPa',
        'Coefficient of linear thermal expansion': 'no data x10<sup>-6</sup>K<sup>-1</sup>',
        'Common oxidation states': [3],
        'Critical temperature': 'no data K',
        'Density of solid': 'no data kg m<sup>-3</sup>',
        'Electrical resistivity': 'no data 10<sup>-8</sup> &Omega; m',
        'Electronic structure': '[Rn].5f<sup>14</sup>.7s<sup>2</sup>.7p<sup>1</sup> (tentative)',
        'Liquid range': 'no data K',
        'Melting point': 'about 1900 K',
        'Mendeleev no': 34,
        'Mineral hardness': 'no data',
        'Molar volume': 'no data cm<sup>3</sup>',
        Name: 'Lawrencium',
        'Oxidation states': [3],
        'Poissons ratio': 'no data',
        Reflectivity: 'no data %',
        'Refractive index': 'no data',
        'Rigidity modulus': 'no data GPa',
        'Superconduction temperature': 'no data K',
        'Thermal conductivity': 'no data W m<sup>-1</sup> K<sup>-1</sup>',
        'Van der waals radius': 'no data',
        'Velocity of sound': 'no data m s<sup>-1</sup>',
        'Vickers hardness': 'no data MN m<sup>-2</sup>',
        X: 1.3,
        'Youngs modulus': 'no data GPa',
        'Metallic radius': 'no data',
        iupac_ordering: 18,
        'IUPAC ordering': 18,
        'Ground level': '2P°1/2',
        'Ionization energies': [
            4.96,
            14.54,
            21.8,
            43.6,
            56,
            80,
            96,
            121,
            143,
            165,
            197,
            216,
            244,
            269,
            290,
            322,
            344,
            374,
            403,
            431,
            459,
            487,
            510,
            540,
            560,
            745,
            779,
            814,
            852,
            888,
            922,
            985,
            1020,
            1061,
            1098,
            1280,
            1320,
            1360,
            1410,
            1570,
            1620,
            1760,
            1810,
            2010,
            2100,
            2190,
            2290,
            2380,
            2470,
            2570,
            2670,
            2780,
            2860,
            2960,
            3060,
            3150,
            3250,
            3741,
            3821,
            3906,
            3996,
            4082,
            4165,
            4360,
            4448,
            4540,
            4630,
            4990,
            5070,
            5160,
            5250,
            5920,
            6030,
            6290,
            6390,
            9920,
            10110,
            10310,
            10520,
            10720,
            10920,
            11470,
            11680,
            11910,
            12120,
            12710,
            12890,
            13090,
            13300,
            15300,
            15600,
            16000,
            16200,
            32400,
            32900,
            33400,
            33900,
            41600,
            42300,
            43200,
            43759,
            null,
            172930,
        ],
        'Electron affinity': -0.31,
        symbol: 'Lr',
    },
    {
        'Atomic mass': 267,
        'Atomic no': 104,
        Name: 'Rutherfordium',
        'Ground level': '3F2',
        'Ionization energies': [
            6.02,
            14.35,
            23.84,
            31.87,
            64,
            77,
            102,
            119,
            146.1,
            169,
            193,
            225,
            244,
            275,
            null,
            791,
            825,
            860,
            899,
            936,
            972,
            1036,
            1073,
            1114,
            1151,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            3857,
            3938,
            4025,
            4116,
            4203,
            4287,
            4489,
            4580,
            4670,
            4760,
            5130,
            5210,
            5300,
            5390,
            6100,
            6200,
            6470,
            6570,
            10170,
            10360,
            10560,
            10780,
            10980,
            11180,
            11750,
            11960,
            12200,
            12410,
            13010,
            13190,
            13400,
            13600,
            15800,
            16000,
            16400,
            16700,
            33100,
            33600,
            34100,
            34600,
            42700,
            43400,
            44300,
            null,
            null,
            177148,
        ],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Rf',
    },
    {
        'Atomic mass': 268,
        'Atomic no': 105,
        Name: 'Dubnium',
        'Ground level': '4F3/2',
        'Ionization energies': [
            6.8,
            14,
            23.1,
            33,
            43,
            86,
            98.9,
            126,
            145.1,
            172,
            196,
            220.9,
            254,
            274,
            307,
            null,
            838,
            872,
            908,
            948,
            985,
            1022,
            1089,
            1126,
            1168,
            1207,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            3975,
            4057,
            4145,
            4237,
            4326,
            4411,
            4620,
            4710,
            4810,
            4900,
            5260,
            5350,
            5450,
            5530,
            6280,
            6380,
            6650,
            6760,
            10420,
            10610,
            10820,
            11040,
            11240,
            11440,
            12040,
            12250,
            12480,
            12700,
            13300,
            13500,
            13700,
            13900,
            16200,
            16400,
            16900,
            17100,
            33800,
            34300,
            34800,
            35300,
            43800,
            44500,
            45400,
            null,
            null,
            181444,
        ],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Db',
    },
    {
        'Atomic mass': 269,
        'Atomic no': 106,
        Name: 'Seaborgium',
        'Ground level': '0',
        'Ionization energies': [
            7.8,
            17.1,
            25.8,
            35.5,
            47.2,
            59.3,
            109,
            122,
            152,
            170,
            200,
            224,
            251,
            285,
            306,
            339,
            null,
            885,
            921,
            958,
            998,
            1036,
            1073,
            1143,
            1181,
            1223,
            1263,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            4095,
            4178,
            4267,
            4360,
            4450,
            4540,
            4750,
            4840,
            4940,
            5030,
            5410,
            5490,
            5590,
            5680,
            6460,
            6570,
            6840,
            6950,
            10680,
            10870,
            11080,
            11300,
            11510,
            11710,
            12320,
            12540,
            12780,
            12990,
            13600,
            13800,
            14000,
            14200,
            16600,
            16800,
            17300,
            17500,
            34500,
            35000,
            35600,
            36100,
            44900,
            45700,
            46600,
            null,
            null,
            185839,
        ],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Sg',
    },
    {
        'Atomic mass': 270,
        'Atomic no': 107,
        Name: 'Bohrium',
        'Ground level': '5/2',
        'Ionization energies': [
            7.7,
            17.5,
            26.7,
            37.3,
            49,
            62.1,
            74.9,
            134,
            148,
            178,
            198,
            228,
            255,
            281,
            318,
            337,
            374,
            null,
            934,
            969,
            1008,
            1049,
            1088,
            1126,
            1197,
            1237,
            1280,
            1320,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            4216,
            4301,
            4390,
            4486,
            4580,
            4660,
            4890,
            4980,
            5080,
            5170,
            5550,
            5640,
            5740,
            5830,
            6650,
            6760,
            7040,
            7140,
            10930,
            11130,
            11340,
            11560,
            11780,
            11980,
            12610,
            12830,
            13070,
            13300,
            13900,
            14100,
            14300,
            14500,
            17000,
            17300,
            17700,
            18000,
            35200,
            35700,
            36300,
            36800,
            46100,
            46900,
            47800,
            null,
            null,
            190331,
        ],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Bh',
    },
    {
        'Atomic mass': 270,
        'Atomic no': 108,
        Name: 'Hassium',
        'Ground level': '4',
        'Ionization energies': [
            7.6,
            18.2,
            29.3,
            37.7,
            51.2,
            64,
            78.1,
            91.7,
            159.9,
            173.9,
            206.1,
            227,
            258,
            285,
            314,
            351,
            371,
            409,
            null,
            984,
            1020,
            1060,
            1101,
            1140,
            1180,
            1253,
            1294,
            1338,
            1379,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            4339,
            4425,
            4516,
            4610,
            4700,
            4790,
            5020,
            5110,
            5220,
            5310,
            5700,
            5780,
            5880,
            5980,
            6840,
            6950,
            7230,
            7340,
            11200,
            11390,
            11610,
            11830,
            12040,
            12250,
            12910,
            13130,
            13400,
            13600,
            14200,
            14400,
            14600,
            14800,
            17500,
            17700,
            18200,
            18400,
            35900,
            36400,
            37000,
            37500,
            47300,
            48100,
            49000,
            null,
            null,
            194917,
        ],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Hs',
    },
    {
        'Atomic mass': 278,
        'Atomic no': 109,
        Name: 'Meitnerium',
        'Ground level': null,
        'Ionization energies': [
            50,
            null,
            null,
            94,
            109,
            187,
            202,
            235.9,
            257,
            289,
            318,
            346,
            386,
            406,
            445,
            null,
            1035,
            1072,
            1112,
            1154,
            1195,
            1234,
            1311,
            1352,
            1397,
            1439,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            4464,
            4551,
            4640,
            4740,
            4830,
            4920,
            5160,
            5250,
            5360,
            5450,
            5840,
            5930,
            6030,
            6130,
            7030,
            7150,
            7430,
            7550,
            11460,
            11660,
            11870,
            12100,
            12320,
            12530,
            13200,
            13400,
            13700,
            13900,
            14500,
            14700,
            14900,
            15100,
            17900,
            18200,
            18700,
            18900,
            36700,
            37200,
            37800,
            38300,
            48500,
            49400,
            50300,
            null,
            null,
            199606,
        ],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Mt',
    },
    {
        'Atomic mass': 281,
        'Atomic no': 110,
        Name: 'Darmstadtium',
        'Ground level': null,
        'Ionization energies': [
            65,
            null,
            null,
            112.9,
            128,
            216,
            231,
            266,
            288,
            322,
            352,
            380,
            422,
            442,
            483,
            null,
            1087,
            1125,
            1165,
            1208,
            1250,
            1290,
            1369,
            1412,
            1457,
            1500,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            4590,
            4680,
            4770,
            4870,
            4960,
            5060,
            5300,
            5400,
            5500,
            5600,
            5990,
            6080,
            6190,
            6280,
            7230,
            7350,
            7640,
            7750,
            11730,
            11930,
            12140,
            12380,
            12600,
            12810,
            13500,
            13700,
            14000,
            14200,
            14800,
            15000,
            15300,
            15500,
            18400,
            18600,
            19100,
            19400,
            37400,
            37900,
            38500,
            39100,
            49800,
            50700,
            51600,
            null,
            null,
            204400,
        ],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Ds',
    },
    {
        'Atomic mass': 282,
        'Atomic no': 111,
        Name: 'Roentgenium',
        'Ground level': null,
        'Ionization energies': [],
        'Electron affinity': 1.565,
        'Van der waals radius': 'no data',
        symbol: 'Rg',
    },
    {
        'Atomic mass': 285,
        'Atomic no': 112,
        Name: 'Copernicium',
        'Ground level': null,
        'Ionization energies': [],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Cn',
    },
    {
        'Atomic mass': 286,
        'Atomic no': 113,
        Name: 'Nihonium',
        'Ground level': null,
        'Ionization energies': [],
        'Electron affinity': 0.69,
        'Van der waals radius': 'no data',
        symbol: 'Nh',
    },
    {
        'Atomic mass': 289,
        'Atomic no': 114,
        Name: 'Flerovium',
        'Ground level': null,
        'Ionization energies': [],
        'Electron affinity': null,
        'Van der waals radius': 'no data',
        symbol: 'Fl',
    },
    {
        'Atomic mass': 290,
        'Atomic no': 115,
        Name: 'Moscovium',
        'Ground level': null,
        'Ionization energies': [],
        'Electron affinity': 0.366,
        'Van der waals radius': 'no data',
        symbol: 'Mc',
    },
    {
        'Atomic mass': 293,
        'Atomic no': 116,
        Name: 'Livermorium',
        'Ground level': null,
        'Ionization energies': [],
        'Electron affinity': 0.776,
        'Van der waals radius': 'no data',
        symbol: 'Lv',
    },
    {
        'Atomic mass': 294,
        'Atomic no': 117,
        Name: 'Tennessine',
        'Ground level': null,
        'Ionization energies': [],
        'Electron affinity': 1.719,
        'Van der waals radius': 'no data',
        symbol: 'Ts',
    },
    {
        'Atomic mass': 2949,
        'Atomic no': 118,
        Name: 'Oganesson',
        'Ground level': null,
        'Ionization energies': [],
        'Electron affinity': 0.0561,
        'Van der waals radius': 'no data',
        symbol: 'Og',
    },
];
